/** klasa reprezentuje jednego osobnika (dowolnego ustalonego gatunku) 
 * dane pobierane sa z  z pliku skryptowego */
public class Individual extends Actor
{
    //PUBLICZNE

    /**  Nazwa konkretnego osobnika	 */
    String m_sIndividualName="No_name";
    /** przestzren przymiotnikow */
    AdverbSpace m_advSpace;
    /** Kontekst aktywnosci */
    Context m_currContext=null;	
    
    /** czy wykonane wstepne animacje     */
    boolean m_bDone = true;
    boolean m_bAnimationFinished = true;

    //KONSTRUKTORY
    public void OnCreate()
    {
        super.OnCreate();
        //TODO: przerzucic ten stuff do Warana
        /*    	UpdatePathMap(true);
        SetFlag(EFlags._STOPPED_BY_PATHFINDER);
        SetCollFlags(ECollFlags.OBJCOL_FLAG_ALIGNTOGROUND);
        
        SetEllipsoid(50,0,40);  //rad=39, posy=20, height=2*20
        this.SetCollType(ECollFlags.OBJCOL_TYPE_ELLIPSOID);
        this.SetCollAction(ECollFlags.OBJCOL_ACTION_SLIDE);
        //        ClearFlag(EFlags._BLOCK_MOVE);*/
    }

    //INTERFEJS Z ZEWNATRZ---------------------------------------
    public void SetIndividualName(String sName)
    {
        m_sIndividualName = sName;	
        SetName(sName);
    }
    public String GetIndividualName()
    {
        return m_sIndividualName;	
    }
    
    boolean Done()
    {
        return m_bDone;	
    }
    void SetNoDone()
    {
        //        LogLine("m_bDone=false");          
        m_bDone = false;
    }
    public void SetSpecies(Species species)
    {
        m_advSpace=species.m_advSpace;
        m_initVerb	= species.GetVerb(0);
        m_currContext = new Context(m_advSpace.GetDimension());	
        
        if (species.m_sMeshFileName != null)
        {
            this.LoadMesh(species.m_sMeshFileName);	   
            CrashLog("Individual.SetSpecies loaded mesh " + species.m_sMeshFileName);
        }
        InitMeshAnimations(species);
        
        this.ClearFlag( EFlags._NO_ANIMATION );
        this.ClearFlag( EFlags._NO_ANIMATION_REFRESH );	
    }
    //INTERFEJS DLA JEDNOSTKI STEROWANIA ---------------------------------------
    //------Ziany aktywnosci
    /** Zmiana aktywnosci losowa  -- DOKONCZYC */
    public void ChangeActivityRand()
    {
        DisableCallMethod("PlayStartAnim");		
        DisableCallMethod("PlayInnerAnim");
        DisableCallMethod("PlayEndAnim");	
        
        int nSize = m_currVerb.GetSuccCount();
        if(nSize==0)
            m_selectTrans=null;
        else
        {
            if(nSize==1)
                m_selectTrans=(Transition)m_currVerb.GetSuccessor(0);
            else
                m_selectTrans = (Transition)m_currVerb.GetSuccessor(RandomInt(nSize-1));
            LogLine("RAND ");
            PlayEndAnim();   // odgrywa koncowa animacje
        }
    }
    
    /** Zmiana aktywnosci narzucona	 */
    public void ChangeActivity(String sActivity)
    {  
        if(sActivity.equals(m_currVerb.GetName()))
            return;
        DisableCallMethod("PlayStartAnim");		
        DisableCallMethod("PlayInnerAnim");
        DisableCallMethod("PlayEndAnim");			
        m_selectTrans = m_currVerb.GetSuccessor(sActivity);
        //LogLine("Jestem w zmianie w czasowniku "+m_currVerb.GetName()+" na "+sActivity);
        PlayEndAnim();
    }
    /** Zmiana kontekstu*/
    public void ChangeContext()
    {
        //     LogLine("Zmieniam kontekst");
        if(m_currVerb!=null)
            this.SetAnimMorphTime(m_currVerb.m_fMorphTime);
        ClearSound();  //czysci aktualne dzwieki
        //		LogLine("Bede gral muzyke - zmiana kontekstu");
        StartSound();  // ustawia dzwieki zgodne z nowym kontekstem
        PlayInnerAnim();
    }
    /** Zmiana kierunku	do kierunku wektora vDir */
    public void SetDestDir(Vector vDir, float fSpeed)
    {
        this.SetMaxAngSpeed(fSpeed);
        this.SetDestDir(vDir);
        LogLine("SET DEST DIR");
    }

    void UpdateSpeed()
    {
        if(m_currAnim!=null)
            SetLocalSpeed(new Vector(0.0f, 0.0f,  m_currAnim.m_fSpeed));	
        else
            LogLine("UpdateSpeedError: currAnim==null ind: "+this+ " m_currVerb: "+m_currVerb.m_sName);
    }
    
    //JEDNOSTKA STEROWANIA - OBSLUGA ZDARZEN  ------------------
    //-------------  ZDARZENIA   
    public void Start()
    {
        this.SetPhysicsActive(true);
        m_currVerb=m_initVerb;
        m_currGO=m_initVerb;
        
        StartVerb();
    }

    //CHODZENIE PO GRAFIE AKTYWNOSCI (z odtwarzaniem multimediow)
    // ---Ogolne chodzenie po obiektach grafu
    /** Rozpoczecie przechodzenia  przez grafO. 	 */
    public void StartGraphObject()
    {
        StartSound();
        if(m_currGO.m_bPhysic)
        { 
            //		     this.SetPhysicsActive(true);
            this.SetPhysicsType(m_currGO.m_nPhysicType);	 //m_nPhysicType);
        }
        else
        {
            SetSpeed(new Vector(0,0,0));
            //this.SetPhysicsActive(false);
        }
    }
    public void EndGraphObject()
    {
        ClearSound();
    }
    /**Zaczyna odgrywac muzyke*/
    void StartSound()
    {
        if(m_currGO.m_sounds!=null)
        {
            m_currSound = (Sound)(m_currGO.m_sounds).FindBest(m_currContext);
            
            if(m_currSound!=null)
            {
                //				LogLine("Odtwarzam dziwek "+m_currSound.GetName()+"  "+m_currSound.m_fLength);
                m_currSoundId=this.AttachSound(m_currSound.GetName(),m_currSound.m_fRangeMin,m_currSound.m_fRangeMax);
                m_bIsPlaying=true;
                
                if(m_currSound.m_bIsCyclic )	
                {
                    if(m_currSound.m_bIsCyclic && (m_currSound.m_fPause>0))
                    {
                        DisableCallMethod("EndSound");
                        CallMethodIn("EndSound", m_currSound.m_fLength);
                        DisableCallMethod("PlayCyclic");
                        CallMethodEvery("PlayCyclic", m_currSound.m_fPause+m_currSound.m_fLength);
                        //					LogLine("Czekam na dziwek "+m_currSound.GetName()+"  "+m_currSound.m_fPause);
                    }
                }
                else 
                    CallMethodIn("EndSound", m_currSound.m_fLength);
            }
        }
    }	
    
    void EndSound()
    {
        if(!m_currSound.m_bIsCyclic)
            this.DetachSound(m_currSoundId);	
        else
        {
            //				LogLine("Zatrzymuje dzwiek");
            if(m_bIsPlaying)
            {
                this.StopSound(m_currSoundId);
                m_bIsPlaying=false;
            }
        }
        //				LogLine("Zatrzymalem dzwiek");
    }

    void PlayCyclic()
    {
        
        //	  LogLine("Odtwarzam dzwiek");
        if(!m_bIsPlaying)
        {
            this.PlaySound(m_currSoundId);
            m_bIsPlaying=true;
        }
        DisableCallMethod("EndSound");
        CallMethodIn("EndSound", m_currSound.m_fLength);
    }
    /** Czysci wszystko co gra */
    void ClearSound()
    {
        DisableCallMethod("EndSound");
        DisableCallMethod("PlayCyclic");
        if(m_currSound!=null)
            this.DetachAllSounds();	
    }
    
    // -- Przechodzenie trazycji
    public void StartTransition()
    {
        //    LogLine("Jestem w tranzycji");
        StartGraphObject();
        // Wyswietlanie animacji 
        float fNextTime;
        if(m_currTrans.m_animations!=null)
        {
            m_currAnim= (Animation)(m_currTrans.m_animations).FindBest(m_currContext);
            if(m_currAnim!=null)
            {
                fNextTime = this.GetAnimLength(m_currAnim.GetName());
                //					LogLine("JESTEM W TRANZYCJI - animName - "+m_currAnim.GetName());
                //					LogLine("JESTEM W TRANZYCJI - animLength - "+fNextTime);
                //					LogLine("JESTEM W TRANZYCJI - morfTime - "+m_fMorphTime);					
                fNextTime=fNextTime - m_currTrans.m_fMorphTime;
                if(m_currTrans.m_bPhysic)
                {
                    this.SetSpeed(new Vector(0,0,m_currAnim.m_fSpeed));	
                }
                //					LogLine("Wyswietlam animacje tranzycji "+m_currGO.GetName());
                this.PlayAnim(m_currAnim.GetName(),1);
                DisableCallMethod("TransExit");
                CallMethodIn("TransExit", fNextTime);
                //					LogLine("JESTEM W TRANZYCJI - next time - "+fNextTime);
            }
            else
                
                this.TransExit();
        }
        else
            this.TransExit();
    }

    public void TransExit()
    {
        EndGraphObject();
        //usatwienie nastepnego obiektu grafu jako aktualny
        m_currGO = m_currTrans.m_verb;
        m_currVerb=m_currTrans.m_verb;
        //		LogLine("TransExit done = true");
        //		m_bDone = true;
        StartVerb();
    }
    //--- przechodzenie Aktywnoci (Verb)

    public void StartVerb()
    {
        StartGraphObject();
        PlayStartAnim();
    }	
    /** Odgrywa poczatkowa animacje aktywnosci*/
    void PlayStartAnim()
    {
        float fNextTime;
        // Animacja startowa
        if(m_currVerb.m_startAnims!=null)
        {
            m_currAnim=(Animation)(m_currVerb.m_startAnims).FindBest(m_currContext);
            if(m_currAnim!=null)
            {
                //            LogLine(this +" animacja: "+m_currAnim.GetName());
                if(m_currAnim.m_fFrequency>0)                
                    SetAnimFreq(m_currAnim.GetName(),m_currAnim.m_fFrequency);                
                fNextTime = this.GetAnimLength(m_currAnim.GetName());		
                //LogLine(this +" fNextTime  "+fNextTime+" - morph "+m_currVerb.m_fMorphTime);
                fNextTime=fNextTime - m_currVerb.m_fMorphTime;
                //LogLine(this +" next : "+fNextTime);
                if(m_currVerb.m_bPhysic)
                {
                    this.SetLocalSpeed(new Vector(0,0,m_currAnim.m_fSpeed));	
                    //				   LogLine("Gram startowa: "+m_currAnim.m_fSpeed);
                }
                //                LogLine(this + "Gram StART" + m_currVerb.GetName()+" anim: "+m_currAnim.m_sName+" length "+this.GetAnimLength(m_currAnim.GetName())
                //                      +" morph "+  m_currVerb.m_fMorphTime + " next "+fNextTime);
                this.PlayAnim(m_currAnim.GetName(),1);
                m_bAnimationFinished = false;
                DisableCallMethod("PlayInnerAnim");
                CallMethodIn("PlayInnerAnim", fNextTime);
            }
            else
                PlayInnerAnim();
        }
        else
            PlayInnerAnim();
    }
    /** Odgrywa srodkowa animacje*/
    void PlayInnerAnim()
    {
        //   	LogLine(" Jestem w inner"+GetName());
        m_bAnimationFinished = true;
        float fNextTime;
        if(m_currVerb.m_innerAnims!=null)
        {
            m_currAnim=(Animation)(m_currVerb.m_innerAnims).FindBest(m_currContext);
            if(m_currAnim!=null)
            {
                if(m_currAnim.m_fFrequency>0)
                    SetAnimFreq(m_currAnim.GetName(),m_currAnim.m_fFrequency);                                
                fNextTime = this.GetAnimLength(m_currAnim.GetName());		
                fNextTime=fNextTime - m_currVerb.m_fMorphTime;
                CallMethodIn("SetAnimationFinished", fNextTime);
                // LogLine("JESTEM W VERB - animName - "+m_currAnim.GetName());
                //				LogLine("JESTEM W VERBIE - animLength - "+fNextTime);
                //				LogLine("JESTEM W VERBIE - morfTime - "+m_fMorphTime);							
                if(m_currVerb.m_bPhysic)
                {
                    this.SetLocalSpeed(new Vector(0,0,m_currAnim.m_fSpeed));	
                }
                //				LogLine("Odgrywam animacje srodkowa");
                //				LogLine("Gram INNER" + m_currVerb.GetName());				
                this.PlayAnim(m_currAnim.GetName(),-1);
                m_bAnimationFinished = false;
            }
        }
        m_bDone = true;
        
        if(!m_currVerb.m_bStable)
        {
            ChangeActivityRand();
        }
    }
    /** ustawia znacznik ze animacja skonczona     */
    public void SetAnimationFinished()
    {
        DisableCallMethod("SetAnimationFinished");
        m_bAnimationFinished = true;        
    }
    public void OnAnimEnd(int iAnimID)
    {
        m_bAnimationFinished = false;        
    }
    /** Odgrywa koncowa animacje aktywnosci*/
    void PlayEndAnim()
    {
        m_bAnimationFinished = true;        
        float fNextTime;
        // Animacja startowa
        if(m_currVerb.m_endAnims!=null)
        {
            m_currAnim=(Animation)(m_currVerb.m_endAnims).FindBest(m_currContext);
            if(m_currAnim!=null)
            {
                if(m_currAnim.m_fFrequency>0)
                    SetAnimFreq(m_currAnim.GetName(),m_currAnim.m_fFrequency);                                
                fNextTime = this.GetAnimLength(m_currAnim.GetName());		
                float fMorphTime;
                if(m_selectTrans!=null)
                    fMorphTime = m_selectTrans.m_fMorphTime;
                else
                    fMorphTime = 0.0f;
                
                fNextTime=fNextTime - m_currVerb.m_fMorphTime;
                if(m_currVerb.m_bPhysic)
                {
                    this.SetLocalSpeed(new Vector(0,0,m_currAnim.m_fSpeed));	
                }	
                this.PlayAnim(m_currAnim.GetName(),1);
                m_bAnimationFinished = false;
                DisableCallMethod("VerbExit");
                CallMethodIn("VerbExit", fNextTime);
            }
            else
                VerbExit();
        }
        else
            VerbExit();
    }
    /**  wyjscie z aktualnej aktywnosci */
    public void VerbExit()
    {
        m_bAnimationFinished = true;
        EndGraphObject();
        if(m_selectTrans!=null)
        {
            //ustawienie aktualnego obiektu grafu jako tranzycja do 
            //wybranego nastepnika
            m_currGO=m_selectTrans;
            m_currTrans=m_selectTrans;
            // SetAnimMorphTime(m_currTrans.m_fMorphTime);  //TODO odremowac
            StartTransition();  //odpalenie tranzycji
        }
    }
    //**  Incicjuje animacje dla MeshObjecta na podstawie grafu aktywnosci */
    void InitMeshAnimations(Species species)
    {
        /*Verb verb;
        Transition trans;
        Animation anim;
        for(int i=0;i<species.GetVerbCount();i++)
        {
        verb=species.GetVerb(i);
        for(int j=0;j<verb.GetStartAnimCount();j++)
        {
        anim=verb.GetStartAnimation(j);
        this.InitAnimSeq(anim.GetName(), anim.GetStart(), anim.GetEnd());
        }
        for(int j=0;j<verb.GetInnerAnimCount();j++)
        {
        anim=verb.GetInnerAnimation(j);
        this.InitAnimSeq(anim.GetName(), anim.GetStart(), anim.GetEnd());
        }		
        for(int j=0;j<verb.GetEndAnimCount();j++)
        {
        anim=verb.GetEndAnimation(j);
        this.InitAnimSeq(anim.GetName(), anim.GetStart(), anim.GetEnd());
        }				
        
        }
        for(int i=0;i<species.GetTransCount();i++)
        {
        trans=species.GetTransition(i);      
        for(int j=0;j<trans.GetAnimCount();j++)
        {
        anim=trans.GetAnimation(j);
        this.InitAnimSeq(anim.GetName(), anim.GetStart(), anim.GetEnd());
        }		
        }*/
    }
    
    /** zwraca aktywnosc     */
    String GetActivity()
    {
        return m_currVerb.m_sName;  
    }
    boolean IsActivity(String sActivity)
    {
        return m_currVerb.m_sName.equals(sActivity);
    }
    boolean IsContext(String sAdverb, String sValue)
    {
        return m_currContext.IsValue(sAdverb, sValue, m_advSpace);
    }    
    
    String GetCurrContext(String sAdverb)
    {
        return m_currContext.GetValue(sAdverb, m_advSpace);
    }
    
    void SetContext(String sAdverb, String sValue)
    {
        m_currContext.SetValue(sAdverb, sValue,m_advSpace);   
    }
    
    
    //DANE - wewnetrzne
    // Graf aktywnosci
    /** aktywnosc poczatkowa */
    Verb m_initVerb=null;  
    /** aktualny graphObject (aktywnosc lub tranzycja) */  
    GraphObject m_currGO=null;
    /** aktualna  aktywnosc*/  
    Verb m_currVerb=null;
    /**aktualna tranzycja	   */
    Transition m_currTrans=null;
    /**tranzycja do wybranego nastepnika  */
    Transition m_selectTrans=null;	  

    /** biezaca animacja*/
    Animation m_currAnim=null;
    //	int m_currAnimId;
    /** Biezacy dzwiek */
    Sound m_currSound=null;
    int m_currSoundId;
    boolean m_bIsPlaying=false;	
    
    //DANE - dodatkowe
    
    //WORK
    //	m_mesh.InitAnimSeq(anim.GetName(), anim.GetStart(), anim.GetEnd());

    /** zabezpieczenie przed nieustalona czestotliwoscia
     */
    public void SetAnimFreq(String sSeqName, float fFreq)
    {
        if(fFreq>0)
            super.SetAnimFreq(sSeqName, fFreq);
    }
    
    
}
