public class AdverbSpace
{
	//KONSTRUKTORY
	AdverbSpace()
	{
	   m_adverbs = new java.util.Vector();	
	}

	//INTERFEJS
	public int GetIndex(String sName)
	{
       int nIndex = -1;
	   Adverb adverb;
	   int nSize = m_adverbs.size();

	   for(int i=0; i<nSize; i++)
		{
		    	adverb = (Adverb)m_adverbs.elementAt(i);
				if( sName.equals(adverb.m_sName))
			    {
				   nIndex=i;
				   break;
				}
	   }
	   return nIndex;	// jesli nie znalazl to -1
	}
	/** Sprawdza czy zadany przymiotnik jest w przestrzeni
	 */
	
	public boolean IsAdverb(String sVerb)
	{
		return (GetIndex(sVerb) != -1);
	}
	/** Zwraca przymiotnik o nazwie sName lub null gdy nie znajdzie
	 */
	public Adverb GetAdverb(String sName)
	{
	   int nInd	= GetIndex(sName);
	   if(nInd==-1)
		   return null;
	   else
		   return (Adverb)m_adverbs.elementAt(nInd);
	}
	/** Zwraca przymiotnik nIndex*/
	public Adverb GetAdverb(int nIndex)
	{
   	return 	(Adverb)m_adverbs.elementAt(nIndex);
	}
	/** zwraca wymiar przestrzeni 
	 */
	public int GetDimension()
	{
	  return m_adverbs.size();	
	}
	/** Dodaje przymiotnik sName do przestrzeni
	 */
	public void AddAdverb(String sName)
	{
	   Adverb adverb= new Adverb(sName);	
     m_adverbs.addElement(adverb);
	}
	/** Dodaje wartosc sValue dla przymiotnika sAdverb*/
	public void AddValue(String sAdverb, String sValue)
	{
	    Adverb adverb = GetAdverb(sAdverb);
	    adverb.AddValue(sValue);
	}
	/** Zwraca wartosc nIndValue dla przymiotnika nIndAdverb */
	public String GetValue(int nIndAdverb , int nIndValue)
	{
     return (GetAdverb(nIndAdverb)).GetValue(nIndValue);
	}
	/** Sprawdza czy dla przymiotnika sAdverb jest zdefiniwana wartosc sValue*/
	public boolean IsValue(String sAdverb, String sValue)
	{
	    Adverb adverb = GetAdverb(sAdverb);	
	    if (adverb==null)
	    	return false;
	    else	
	       return adverb.IsValue(sValue);
	}
  /** Zwraca liczbe zdefiniwanych wartosci dla przymiotnika sAdverb .Jesli nie ma przymiotnika to -1*/
	public int GetAdverbSize(String sAdverb)
	{
	    Adverb adverb = GetAdverb(sAdverb);	
 	    if (adverb==null)
	    	return -1;
	    else	
	       return adverb.GetSize();
	}
	/** Zwraca liczbe zdefiniwanych wartosci dla przymiotnika nIndex*/
	public int GetAdverbSize(int nIndex)
	{
	  return (GetAdverb(nIndex)).GetSize();	
		
	}
	
	
	/** wyswietla w logu verb's and tran's	 */
	void Show()
	{
		GameObject.LogLine(" ADVERB_SPACE: ");
		if(m_adverbs == null)
		{
			GameObject.LogLine(" = null ");
			return;
		}
		for(int i=0;i<m_adverbs.size();i++)
		{
   		   	Adverb cBuffer = (Adverb)m_adverbs.elementAt(i);			
			GameObject.LogLine(" = "+cBuffer.m_sName);
			cBuffer.Show();
		}
	}
	//DANE
		java.util.Vector m_adverbs;  
        
    void delete()
    {
        if (m_adverbs != null)
        {
            for (int i = 0; i < m_adverbs.size(); i++)
                ((Adverb)m_adverbs.elementAt(i)).delete();
            m_adverbs.removeAllElements();
        }
        m_adverbs = null;
    }
}
