/** Klasa reprezentuje okreslony gatunek zwierzat
 * dane pobierane sa z  z pliku skryptowego */
public class Species //extends GameObject
{
	//PUBLICZNE
    /** Nazwa gatunku*/
  	String m_sName = null;	
	/** przetrzen przymiotnikow*/
	AdverbSpace m_advSpace;
	/**
	 * nazwa pliku z meshem gatunku
	 */
	String m_sMeshFileName;
	
	//KONSTRUKTORY
	Species()
	{
	    m_advSpace = new AdverbSpace();	
		m_verbs = new java.util.Vector();
		m_transitions = new java.util.Vector();
	}
	// INTERFEJS
    public String GetName()
	{
  		return m_sName;	
	}
    /** Wczytuje dane o gatunku z pliku sFileName
     */
    public boolean LoadData(String sFileName)
	{
		ParseKeyword root=GameObject.ParseFile(sFileName);
        
        if(root==null)
        {
            GameObject.CrashLog("No file !\n");
			return false;
        }
        else
		{
		   ParseKeyword key;
		   for(key=root; key!=null; key=key.GetNext())
		   {
			   if(key.Equals("Name"))
				   m_sName = key.GetSParam(0);
			   if(key.Equals("Mesh"))
				   m_sMeshFileName = key.GetSParam(0);
			   if(key.Equals("AdverbSpace"))
				   LoadAdverbSpace(key);
			   if(key.Equals("ActivityGraph"))
				   LoadActivityGraph(key);			   
		   }
           root.delete();
	      return true;	
		}
	}
	
	//INTERFEJS
	/** Wczytuje z pliku przestrzen przymiotnikow
	 */
	public void LoadAdverbSpace(ParseKeyword adverbSpace)
	{
		   ParseKeyword adverb, value;	
		   for(adverb=adverbSpace.GetChild(); adverb!=null; adverb=adverb.GetNext())
           {
               if(adverb.Equals("Adverb"))
			   {
				   m_advSpace.AddAdverb(adverb.GetSParam(0));
				   for(value=adverb.GetChild(); value!=null; value=value.GetNext())
					   if(value.Equals("Value"))
					       m_advSpace.AddValue(adverb.GetSParam(0), value.GetSParam(0));
			   }
		   }
	}
	/** Wczytuje z pliku diagram aktywnosci	 */
	public void LoadActivityGraph(ParseKeyword actGraph)
	{
 	  ParseKeyword object, attrib;
	  Verb verb;
	  Transition trans;
	  String sSource,sName;
	  int p;  //typ fizyki
	  for(object=actGraph.GetChild(); object!=null; object=object.GetNext())
      {
         if(object.Equals("Verb"))
	     {
		     verb = new Verb();//(Verb)CreateObject("Verb");
			 sName=object.GetSParam(0);
			 verb.SetName(sName);
			 
			 for(attrib=object.GetChild(); attrib!=null; attrib=attrib.GetNext())
			 {
			    if(attrib.Equals("StartAnimations"))
					verb.SetStartAnimations(ReadAnims(attrib));
		
			    if(attrib.Equals("InnerAnimations"))
					verb.SetInnerAnimations(ReadAnims(attrib));
			    if(attrib.Equals("EndAnimations"))
					verb.SetEndAnimations(ReadAnims(attrib));
			    if(attrib.Equals("Sounds"))
					verb.SetSounds(ReadSounds(attrib));
				if(attrib.Equals("Stable"))
					verb.m_bStable= (attrib.GetIParam(0)==0)?false:true;
				if(attrib.Equals("MorphTime"))
					verb.m_fMorphTime=attrib.GetFParam(0);
				if(attrib.Equals("AngleSpeed"))
					verb.m_AngleSpeed=attrib.GetFParam(0);
				if(attrib.Equals("Physics"))
			    {
				   verb.m_bPhysic=(attrib.GetIParam(0)==0)?false:true;;
				   verb.m_nPhysicType=attrib.GetIParam(1);
				   // brakuje morfingu
				}
				// brkuje speedAngle
			 }
			 this.AddVerb(verb);
			 
	     }
		 if(object.Equals("Transition"))
	     {
		     trans = new Transition();//(Transition)CreateObject("Transition");  
			 sSource=object.GetSParam(0);
			 sName=object.GetSParam(1);
			 trans.SetVerb( this.GetVerb(sName));
			 trans.SetName(sName);
			 trans.SetPredecessor(sSource);
			 for(attrib=object.GetChild(); attrib!=null; attrib=attrib.GetNext())
			 {
			    if(attrib.Equals("Animations"))
					trans.SetAnimations(ReadAnims(attrib));
			    if(attrib.Equals("Sounds"))
					trans.SetSounds(ReadSounds(attrib));
	 	        if(attrib.Equals("Probability"))
					trans.m_fProbability=attrib.GetFParam(0);
				if(attrib.Equals("MorphTime"))
					trans.m_fMorphTime=attrib.GetFParam(0);				
				if(attrib.Equals("Physics"))
			    {
				   trans.m_bPhysic=(attrib.GetIParam(0)==0)?false:true;
				   trans.m_nPhysicType=attrib.GetIParam(1);
				   // brakuje morfingu
				}
			 }
	
			 this.AddTransition(trans);
			 verb = this.GetVerb(sSource);
			 verb.AddTransition(trans);
			 
			 
	     }
	  }
	}
	/**  Wczytuje liste animacji	 */
	MediaList ReadAnims(ParseKeyword animNode)
	{
		MediaList animations = new MediaList();
		Animation anim;
		ParseKeyword node,subnode;
		int nSizeContext=m_advSpace.GetDimension();  // wymiar kontekstu
		Context context;
		
		for(node=animNode.GetChild(); node!=null; node=node.GetNext())
		{
			if(node.Equals("Animation"))
		    {
			    anim = new Animation(node.GetSParam(0));
//				anim.m_nStart = node.GetIParam(1);
//				anim.m_nEnd=	node.GetIParam(2);	
				context=new Context(nSizeContext);
				for(subnode=node.GetChild(); subnode!=null; subnode=subnode.GetNext())
				{
					if(subnode.Equals("Context"))
					{
               		    context.SetValue(subnode.GetSParam(0),subnode.GetSParam(1)
										   , m_advSpace);
					}	
					if(subnode.Equals("Speed"))
					   anim.m_fSpeed = subnode.GetFParam(0);
					if(subnode.Equals("Frequency"))
					   anim.m_fFrequency = subnode.GetFParam(0);                        
				}
                anim.SetPattContext(context);	            
			    animations.AddObject(anim);	
			}
		}
	    return animations;
	}
	/** Wczytuje muzyke	 */
	MediaList ReadSounds(ParseKeyword soundNode)
	{
		MediaList sounds = new MediaList();
		Sound sound;
		ParseKeyword node,subnode;
		int nSizeContext=m_advSpace.GetDimension();  // wymiar kontekstu
		Context context;
		
		for(node=soundNode.GetChild(); node!=null; node=node.GetNext())
		{
			if(node.Equals("Sound"))
		    {
			    sound = new Sound(node.GetSParam(0));
				context=new Context(nSizeContext);
	            for(subnode=node.GetChild(); subnode!=null; subnode=subnode.GetNext())
				{
					if(subnode.Equals("Context"))
					{
						for(int c=0;c<nSizeContext;c++)
                		  context.SetValue(subnode.GetSParam(0),subnode.GetSParam(1)
										   , m_advSpace);
					}	
					if(subnode.Equals("Length"))
						sound.m_fLength = subnode.GetFParam(0);
					if(subnode.Equals("RangeMin"))
						sound.m_fRangeMin=subnode.GetFParam(0);
					if(subnode.Equals("RangeMax"))
						sound.m_fRangeMax=subnode.GetFParam(0);					
			        if(subnode.Equals("Pause"))
						sound.m_fPause = subnode.GetFParam(0);								
			        if(subnode.Equals("Cyclic"))
						sound.m_bIsCyclic = (subnode.GetIParam(0)==0)?false:true;
				}
    			sound.SetPattContext(context);
			    sounds.AddObject(sound);	
			}
		}
	    return sounds;
	}
	/** Dodaje przymionik	 */
	public void AddVerb(Verb verb)
	{
	    m_verbs.addElement((Object)verb);	
	}
	
	public void AddTransition(Transition trans)
	{
		m_transitions.addElement((Object)trans);	
	}
	
	public Verb GetVerb(String sName)
	{
	   int nIndex = -1;
	   Verb verb;
	   int nSize = m_verbs.size();

	   for(int i=0; i<nSize; i++)
		{
		    	verb = (Verb)m_verbs.elementAt(i);
				if( sName.equals(verb.GetName()))
			    {
				   nIndex=i;
				   break;
				}
	   }
	   if(nIndex==-1)
		   return null;
	   else
	     return (Verb)m_verbs.elementAt(nIndex);	// jesli nie znalazl to -1
	}
	
	public Verb GetVerb(int nIndex)
	{
		if( m_verbs.size()>0)
		   return (Verb)m_verbs.elementAt(nIndex);
		else
			return null;
	}
	/** Szuka tranzycji, ktora laczy sSource oraz sDest
	 */
	public Transition GetTransition(String sSource, String sDest)
	{
	   int nIndex = -1;
	   Transition trans;
	   String sSourceName, sDestName;
	   int nSize = m_transitions.size();

	   for(int i=0; i<nSize; i++)
		{
		    	trans = (Transition)m_transitions.elementAt(i);
				sSourceName = trans.GetPredecessor();
				sDestName = trans.GetName();
				if( sSourceName.equals(sSourceName) && 
					sDest.equals(sDestName))
			    {
				   nIndex=i;
				   break;
				}
	   }
	   if(nIndex==-1)
		   return null;
	   else
	     return (Transition)m_transitions.elementAt(nIndex);	// jesli nie znalazl to -1
	}
	public Transition GetTransition(int nIndex)
	{
		if(m_transitions.size()>0)
		   return (Transition)m_transitions.elementAt(nIndex);
		else
			return null;
	}
	/**
	 */ 
	public int  GetVerbCount()
	{
		return m_verbs.size();
	}
	/**
	 */ 
	public int  GetTransCount()
	{
		return m_transitions.size();
	}
		
	// DANE
	/**Lista aktywwnosci*/
	java.util.Vector m_verbs=null;
	/**Lista tranzycji*/
	java.util.Vector m_transitions=null;
	
	/** wyswietla w logu verb's and tran's	 */
	void Show()
	{
		if(m_advSpace!=null)
			m_advSpace.Show();
		else
			GameObject.LogLine(" No adverb space ");
		
		GameObject.LogLine("VERBS : ");
	    for(int i=0;i<m_verbs.size();i++)
		{
   		   	Verb cVerb = (Verb)m_verbs.elementAt(i);	
			cVerb.Show();
		}
	    GameObject.LogLine("TRANSITIONS : ");
	    for(int i=0;i<m_transitions.size();i++)
		{
   		   	Transition cTrans = (Transition)m_transitions.elementAt(i);	
			cTrans.Show();
		}		

	//   while( GetTrans	
	}
	
    void delete()
    {
        if (m_advSpace != null)
            m_advSpace.delete();
        m_advSpace = null;
        if (m_transitions != null)
        {
            for (int i = 0; i < m_transitions.size(); i++)
                ((Transition)m_transitions.elementAt(i)).delete();
            m_transitions.removeAllElements();
            m_transitions = null;
        }
        if (m_verbs != null)
        {
            for (int i = 0; i < m_verbs.size(); i++)
                ((Verb)m_verbs.elementAt(i)).delete();
            m_verbs.removeAllElements();
            m_verbs = null;
        }
    }
}
