/** klasa reprezentuje polaczenie pomiedzy wezlami w diagramie aktywnosci
 */
public class Transition extends GraphObject
{
    //PUBLICZNE
	
	//String m_sPredecessor;

	// KONSTRUKTORY

	//INTERFEJS
	/** Ustawia aktywanosc do ktorej prowadzi tranzycja */
	public void SetVerb(Verb verb)
	{
	    m_verb=verb;
	}
	/** Ustawia aktywanosc do ktorej prowadzi tranzycja */
	public Verb GetVerb()
	{
	  return m_verb;	
	}
	/** Ustawia aktywanosc z ktorej wychodzi tranzycja */
	public void SetPredecessor(String sName)
	{
	    m_sPredecessor=sName;
	}
	/** Ustawia aktywanosc do ktorej wychodzi tranzycja */
	public String GetPredecessor()
	{
	  return m_sPredecessor;	
	}
	
	/** Dodaje liste animacji*/
	public void SetAnimations(MediaList animationList)
	{
	   m_animations = animationList;	
	}

	/** Dodaje 1 animacje do konca listy animacji */
	public void AddAnimation(Animation animation)
	{
		if( m_animations ==null)
				m_animations= new MediaList();
		
		m_animations.AddObject(animation);
	}
	//** Zwraca animacje nIndex */
	public Animation GetAnimation(int nIndex)
	{
	  return (Animation)m_animations.GetObject(nIndex);	
	}
	/** Zwraca liczbe animacji w obiekcie	 */
	public int GetAnimCount()
	{
		if(m_animations==null)
		   return 0;
	   else
	       return m_animations.GetSize();
	}
	/** zwraca prawdopodobienstwo przejscia	 */
	public float GetProbability()
	{
		return m_fProbability;
	}

	/** wyswietla sie w logu 	 */
	void Show()
	{	
        if(m_verb!=null)
		   GameObject.LogLine("  Transition : "+m_sPredecessor+" -> "+m_verb.m_sName);
		else
           GameObject.LogLine("  Transition : "+m_sPredecessor+"  -> null");		
		GameObject.LogLine("    Animations: ");
		if(m_animations!=null)
		     m_animations.Show();
		
		super.Show();

	}
	
    //DANE
	/** prawdopodobienstwo przejscia przez ta tranzycje */
	float m_fProbability;
	/** aktywnosc do ktorej prowadzi tranzycja	 */
	String m_sPredecessor=null;
	Verb m_verb=null;
	/** lista aniamcji zwiazanych z ta tranzycja */
	MediaList m_animations=null;
    
    void delete()
    {
        if (m_animations != null)
            m_animations.delete();
        m_animations = null;
        if (m_verb != null)
            m_verb.delete();
        m_verb = null;
        super.delete();
    }
    
}
