/** klasa reprezentuje aktywnosc w diagramie aktywnosci
 */
public class Verb extends GraphObject
{
	// KONSTRUKTORY
	Verb()
	{
	   m_successors =new java.util.Vector();
	}

	// INTERFEJS 
	/** dodaje nastepna tranzycje, ktora prowadzi do aktywnosci sName
	 */
	public void AddTransition(Transition trans)
	{
		m_successors.addElement(trans);
	}
	/** Zwraca liczbe bastepnikow */
	public int GetSuccCount()
	{
	  return m_successors.size();	
	}
	/** Zwraca nastepnika nIndex*/
	public Transition GetSuccessor(int nIndex)
	{
       return (Transition)m_successors.elementAt(nIndex);		
	}
	/** Zwraca nastepnika sName*/
	public Transition GetSuccessor(String sName)
	{
       int nIndex = -1;
	   Transition trans;
	   int nSize = m_successors.size();

	   for(int i=0; i<nSize; i++)
		{
		    	trans = (Transition)m_successors.elementAt(i);
				if( sName.equals(trans.m_sName))
			    {
				   nIndex=i;
				   break;
				}
	   }
	   if(nIndex==-1)
		   return null;
	   else
	     return (Transition)m_successors.elementAt(nIndex);	// jesli nie znalazl to -1
	}
	
	//INTERFEJS - ANIAMCJE
	
	// ANIMACJE STARTOWE
	/** Dodaje liste animacji startowych*/
	public void SetStartAnimations(MediaList animationList)
	{
	   m_startAnims = animationList;	
	}

	/** Dodaje 1 animacje do konca listy animacji startowych*/
	public void AddStartAnimation(Animation animation)
	{
		if( m_startAnims ==null)
				m_startAnims= new MediaList();
		
		m_startAnims.AddObject(animation);
	}
	//** Zwraca animacje startowa nIndex */
	public Animation GetStartAnimation(int nIndex)
	{
	  return (Animation)m_startAnims.GetObject(nIndex);	
	}
	public Animation GetStartAnimation(String sName)
	{
	   int nIndex = -1;
	   Animation cAnimation;
	   int nSize = m_startAnims.m_objects.size();

	   for(int i=0; i<nSize; i++)
		{
		    	cAnimation = (Animation)m_startAnims.m_objects.elementAt(i);
				if(sName.equals(cAnimation.GetName()))
			    {
				   nIndex=i;
				   break;
				}
	   }
	   if(nIndex==-1)
		   return null;
	   else
	     return (Animation)m_startAnims.m_objects.elementAt(nIndex);	// jesli nie znalazl to -1
	}    

	/** Zwraca liczbe animacji startowych w obiekcie	 */
	public int GetStartAnimCount()
	{
	   if(m_startAnims==null)
		   return 0;
	   else
	     return m_startAnims.GetSize();
	}
	
	// ANIMACJE WEWNETRZNE
	/** Dodaje liste animacji wewnetrznych */
	public void SetInnerAnimations(MediaList animationList)
	{
	   m_innerAnims = animationList;	
	}

	/** Dodaje 1 animacje do konca listy animacji wewnetrznych*/
	public void AddInnerAnimation(Animation animation)
	{
		if( m_innerAnims ==null)
				m_innerAnims= new MediaList();
		
		m_innerAnims.AddObject(animation);
	}
	//** Zwraca animacje wewnetrzna nIndex */
	public Animation GetInnerAnimation(int nIndex)
	{
	  return (Animation)m_innerAnims.GetObject(nIndex);	
	}
	/** Zwraca liczbe animacji wewnetrznych w obiekcie	 */
	public int GetInnerAnimCount()
	{
	  if(m_innerAnims==null)
		   return 0;
	   else	
	      return m_innerAnims.GetSize();
	}
	
	// ANIMACJE ZAWNETRZNE
	/** Dodaje liste animacji koncowych */
	public void SetEndAnimations(MediaList animationList)
	{
	   m_endAnims = animationList;	
	}

	/** Dodaje 1 animacje do konca listy animacji koncowych*/
	public void AddEndAnimation(Animation animation)
	{
		if( m_endAnims ==null)
				m_endAnims= new MediaList();
		
		m_endAnims.AddObject(animation);
	}
	//** Zwraca animacje koncowa nIndex */
	public Animation GetEndAnimation(int nIndex)
	{
	  return (Animation)m_endAnims.GetObject(nIndex);	
	}
	/** Zwraca liczbe animacji koncowych w obiekcie	 */
	public int GetEndAnimCount()
	{  
	   if(m_endAnims==null)
		   return 0;
	   else
	   return m_endAnims.GetSize();
	}
	
	/** wyswietla sie w logu 	 */
	void Show()
	{
		GameObject.LogLine("  Verb: "+m_sName);
		GameObject.LogLine("    StartAnims: ");
		if(m_startAnims!=null)
		     m_startAnims.Show();
		GameObject.LogLine("    InnerAnims: ");
        if(m_innerAnims!=null)        
		    m_innerAnims.Show();
		GameObject.LogLine("    EndAnims: ");
        if(m_endAnims!=null)        		
		    m_endAnims.Show();				
		
		super.Show();
	}

	//DANE
	/** Czy jest to aktywnosc stabilna (nie opuszcza aktywnosci po 
	 * jednorazowym wykonaniu, tylko czeka na zadanie wyjscia z aktywnosci)
	 */
	boolean m_bStable=true;
	
	float m_AngleSpeed;
	
	/**  listy animacji : faza startowa, srodkowa i koncowa
	 */
	MediaList m_startAnims=null;
	MediaList m_innerAnims=null;
	MediaList m_endAnims=null;
	/** nastepnicy - aktywnosci do ktorych mozna przejsc z tej aktywnosci
	*/	
	protected java.util.Vector m_successors;
    
    void delete()
    {
        if (m_startAnims != null)
            m_startAnims.delete();
        m_startAnims = null;
        if (m_innerAnims != null)
            m_innerAnims.delete();
        m_innerAnims = null;
        if (m_endAnims != null)            
            m_endAnims.delete();
        m_endAnims = null;
        
        if (m_successors != null)
            m_successors.removeAllElements();
        super.delete();
    }
}
