import java.io.*;
//import java.util.Hashtable;
//import java.util.Properties;

//#IGNORE_EXT_IMPL
public class ClassReloader extends ClassLoader
{
	//private Hashtable classes_hash = new Hashtable();
	
	public ClassReloader()
	{
        System.out.println("[ClassReloader.ClassReloader]\n");
	}
	
	public synchronized Class loadClass(String typeName, boolean resolveIt) throws ClassNotFoundException
	{
        System.out.println("[ClassReloader.loadClass] Loading class <"+typeName+">\n");
        
		// sprawdzamy czy klasa juz byla zaladowana loaderem
		Class result = findLoadedClass(typeName);
		if (result != null)
			return result;
		
		// ustalamy czy chcemy ta klase normalnie wczytac
		if (!typeName.endsWith("Special"))
		{
            // normalne wczytanie klasy
			try
			{
				result = super.findSystemClass(typeName);
				return result;
			} catch (ClassNotFoundException e)
			{
			}
		}
		
		// odczytujemy dane z dysku
		byte typeData[] = getType(typeName);
		if (typeData == null)
		{
			throw new ClassNotFoundException();
		}
		
		// tworzymy klase z danych
		result = defineClass(typeName, typeData, 0, typeData.length);
		if (result == null)
		{
			throw new ClassFormatError();
		}
		
        // linkujemy klase jak trzeba
		if (resolveIt)
		{
			resolveClass(result);
		}
		
		return result;
	}
	
    /*
	private byte[] readClassFromDisk(String classname)
	{
		System.out.println("classname="+classname);
		
		byte[] result;
		String complete_classname = classname.replace('.',File.separatorChar)+".class";
		try
		{
			FileInputStream fi = new FileInputStream(complete_classname);
			result = new byte[fi.available()];
			fi.read(result);
			return result;
		} catch (Exception e)
		{
			return null;
		}
	}
    */
	
	private byte[] getType(String typeName)
	{
		FileInputStream fis;
		// sklejamy nazwe pliku do przyladowania
        String fileName = "Java"+File.separatorChar+typeName.replace('.', File.separatorChar) + ".class";
		try
		{
			fis = new FileInputStream(fileName);
		}
		catch (FileNotFoundException e)
		{
			System.out.println("file not found");
			return null;
		}
		
		BufferedInputStream bis = new BufferedInputStream(fis);
		ByteArrayOutputStream out = new ByteArrayOutputStream();
		
		try
		{
			int c = bis.read();
			while (c != -1)
			{
				out.write(c);
				c = bis.read();
			}
		} catch (IOException e)
		{
			System.out.println("io exception");
			return null;
		}
		return out.toByteArray();
	}
}

