/** Obiekt tej klasy zawiera wynik kolizji, czyli wszystkich metod Trace...
 * */
public class Collision implements ISaveGame
{
    /** Punkt kolizji*/
	//Vector vPoint;
    
    /** Normalna w punkcie kolizji*/
	public Vector vNormal;
    
    /**Odleglosc punktu kolizji od wektora vStart podawanego jako 
     * parametr metod Trace...
     * */
    public float fDistance;
    
    /** Obiekt z ktorym nastapila kolizja
     * Dla terenu oraz lasu jest rowne null
     */
    public ControlObject Obstacle;
    
    /** Identyfikator mesh elementu z ktorym skolidowal promien.
     * Gdy obiekt nie ma wlaczonych kolizji per element () to =-1.
     */
    public int ObstacleElement;
    
    /** Identyfikator materialu powierzchni z jaka nastapila kolizja.
     */
    public int nMaterial;

    /** Flagi materialu powierzchni z jaka nastapila kolizja.
     */
    public int nMaterialFlags;

    Collision()
    {
        //SG
    }
    
    Collision(Collision coll)
    {
        if (coll.vNormal != null)
            vNormal = new Vector(coll.vNormal);
        fDistance = coll.fDistance;
        Obstacle = coll.Obstacle;
        ObstacleElement = coll.ObstacleElement;
        nMaterial = coll.nMaterial;
        nMaterialFlags = coll.nMaterialFlags;
    }
    
    public String toString()
    {
        return "Coll("+Obstacle+":"+fDistance+")";
    }    
    
	public void SGSaveChunk(FileChunk cParentFC)
    {
		FileChunk.Log("[Collision.SGSaveChunk]\n");
		
        FileChunk cFC = GameObject.NewChunk(ESGChunks._CHK_COLLISION, cParentFC);
		
        cFC.SaveVector(vNormal);
        cFC.SaveFloat(fDistance);
        cFC.SaveObjectRef(Obstacle);
        cFC.SaveInt(ObstacleElement);
        cFC.SaveInt(nMaterial);
        cFC.SaveInt(nMaterialFlags);
        
        cFC.delete();
    }
    
	public void SGLoadChunk(FileChunk cParentFC)
    {
		FileChunk.Log("[Collision.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunks._CHK_COLLISION)
        {	
            vNormal = cFC.LoadVector();
            fDistance = cFC.LoadFloat();
            Obstacle = (ControlObject) cFC.LoadObjectRef();
            ObstacleElement = cFC.LoadInt();
            nMaterial = cFC.LoadInt();
            nMaterialFlags = cFC.LoadInt();
        }
		
		cFC.delete();
    }
    
	public void SGUpdate()
    {
		FileChunk.Log("[Collision.SGSaveChunk]\n");
    }
}
