/** Kosci dla obiektow biped.
 * Uwaga: Definicje musza byc zgodne z definicjami w BoneDef.hpp
 */
public class EBones
{
    //wrong bone
    final static byte _NON_BONE   = -1;

    //spine
    final static byte _PELVIS     = 0;          // miednica
    final static byte _SPINE      = 1;          // kregoslup
    final static byte _SPINE1     = 2;          // kregoslup 1
    final static byte _SPINE2     = 3;          // kregoslup 2
    final static byte _NECK       = 4;          // szyja
    final static byte _HEAD       = 5;          // glowa
    
    //arms
    final static byte _L_CLAVICLE = 6;          // obojczyk L
    final static byte _L_UPPERARM = 7;          // ramie L
    final static byte _L_FOREARM  = 8;          // przedramie L
    final static byte _L_HAND     = 9;          // dlon L
    final static byte _R_CLAVICLE = 10;         // obojczyk P
    final static byte _R_UPPERARM = 11;         // ramie P
    final static byte _R_FOREARM  = 12;         // przedramie P
    final static byte _R_HAND     = 13;         // dlon P

    //legs
    final static byte _L_THIGH    = 14;         // udo L
    final static byte _R_THIGH    = 15;         // udo R
    
    //hands
    final static byte _L_FINGER2  = 16;         // palec L
    final static byte _R_FINGER2  = 17;         // palec P
    
    //legs
    final static byte _L_CALF     = 18;         // lydka L
    final static byte _R_CALF     = 19;         // lydka R
    final static byte _L_FOOT     = 20;         // stopa L
    final static byte _R_FOOT     = 21;         // stopa R
 
    static String GetNameFromID(byte iID)
    {
        String sResult = "Unknown";
        
        switch (iID)
        {
        case _NON_BONE:     sResult = "NonBone";break;          
        
        case _PELVIS:       sResult = "Pelvis"; break;          
        case _SPINE:        sResult = "Spine"; break;           
        case _SPINE1:       sResult = "Spine1"; break;          
        case _SPINE2:       sResult = "Spine2"; break;          
        case _NECK:         sResult = "Neck"; break;            
        case _HEAD:         sResult = "Head"; break;            
        
        // arms
        case _L_CLAVICLE:   sResult = "L Clavicle"; break;      
        case _L_UPPERARM:   sResult = "L UpperArm"; break;      
        case _L_FOREARM:    sResult = "L Forearm"; break;       
        case _L_HAND:       sResult = "L Hand"; break;          

        case _R_CLAVICLE:   sResult = "R Clavicle"; break;      
        case _R_UPPERARM:   sResult = "R UpperArm"; break;      
        case _R_FOREARM:    sResult = "R Forearm"; break;       
        case _R_HAND:       sResult = "R Hand"; break;          
        
        // legs
        case _L_THIGH:      sResult = "L Thigh"; break;         
        case _R_THIGH:      sResult = "R Thigh"; break;         

        // hands
        case _L_FINGER2:    sResult = "L Finger2"; break;       
        case _R_FINGER2:    sResult = "R Finger2"; break;       

        // legs
        case _L_CALF:       sResult = "L Calf"; break;          
        case _R_CALF:       sResult = "R Calf"; break;          
        case _L_FOOT:       sResult = "L Foot"; break;          
        case _R_FOOT:       sResult = "R Foot"; break;          
        }
        return sResult;
    }

}
