/** Klasy geometrii ODE rozrozniane ze wzgledu na reakcje na kolizjje.
    UWAGA: wartosci musza byc zgodne z enumem CODEPhysics::ECollisionGeomClass
    zdefiniowanym w pliku "ODEPhysics.h".
*/
public class EODECollisionGeomClass
{
    final static int _TERRAIN                   =   0;    // teren
    final static int _TREES                     =   1;    // drzewa
    final static int _NON_ODE_OBJECTS           =   2;    // obiekty statyczne swiata nie bedace obiektami ODE
    final static int _ODE_OBJECTS               =   3;    // obiekty ODE z roznych fizyk
    final static int _ODE_OBJECTS_SAME_PHYSICS  =   4;    // obiekty ODE z tej samej fizyki
    final static int _END_COLLISION_GEOM_CLASS  =   5;    // zawsze ostatni

    static String GetFlagName( int nFlag )
    {
        switch( nFlag )
        {
            case _TERRAIN:
                return "_TERRAIN";
            case _TREES:
                return "_TREES";
            case _NON_ODE_OBJECTS:
                return "_NON_ODE_OBJECTS";
            case _ODE_OBJECTS:
                return "_ODE_OBJECTS";
            case _ODE_OBJECTS_SAME_PHYSICS:
                return "_ODE_OBJECTS_SAME_PHYSICS";
            case _END_COLLISION_GEOM_CLASS:
                return "_END_COLLISION_GEOM_CLASS";
            default:
              return "_ODE_COLLISION_CLASS_UNKNOWN";
        }
    }
}

