/** Klasy geometrii uzywanych w ODE.
    Patrz dokument "Open Dynamic Engine vX.XXX User Guide".
    UWAGA: musi byc synchronizowana z ODE (plik collision.h)!!!
*/
public class EODEGeomClass
{
    final static int _MAX_USER_GEOM_CLASSES     = 4;
    
    final static int _GEOM_SPHERE_CLASS         = 0;	
	final static int _GEOM_BOX_CLASS            = 1;
	final static int _GEOM_CCYLINDER_CLASS      = 2;
    final static int _GEOM_CYLINDER_CLASS       = 3;
	final static int _GEOM_PLANE_CLASS          = 4;
	final static int _GEOM_RAY_CLASS            = 5;
	final static int _GEOM_GEOMTRANSFORM_CLASS	= 6;
	final static int _GEOM_TRIMESH_CLASS        = 7;
	final static int _GEOM_FIRSTSPACE_CLASS     = 8;
	final static int _GEOM_SIMPLESPACE_CLASS    = _GEOM_FIRSTSPACE_CLASS;
	final static int _GEOM_HASHSPACE_CLASS      = 9;
	final static int _GEOM_LASTSPACE_CLASS      = _GEOM_HASHSPACE_CLASS;
	final static int _GEOM_FIRSTUSER_CLASS      = 10;
	final static int _GEOM_LASTUSER_CLASS       = _GEOM_FIRSTUSER_CLASS + _MAX_USER_GEOM_CLASSES - 1;
	final static int _GEOM_LAST_CLASS           = _GEOM_LASTUSER_CLASS + 1;

    static String GetFlagName(int nFlag)
    {
        switch (nFlag)
        {
            case _GEOM_SPHERE_CLASS:        return "_GEOM_SPHERE_CLASS";
            case _GEOM_BOX_CLASS:           return "_GEOM_BOX_CLASS";
            case _GEOM_CCYLINDER_CLASS:     return "_GEOM_CCYLINDER_CLASS";
            case _GEOM_CYLINDER_CLASS:      return "_GEOM_CYLINDER_CLASS";
            case _GEOM_PLANE_CLASS:         return "_GEOM_PLANE_CLASS";
            case _GEOM_RAY_CLASS:           return "_GEOM_RAY_CLASS";
            case _GEOM_GEOMTRANSFORM_CLASS: return "_GEOM_GEOMTRANSFORM_CLASS";
            case _GEOM_TRIMESH_CLASS:       return "_GEOM_TRIMESH_CLASS";
//            case _GEOM_FIRSTSPACE_CLASS:    return "_GEOM_FIRSTSPACE_CLASS";
            case _GEOM_SIMPLESPACE_CLASS:   return "_GEOM_SIMPLESPACE_CLASS";
            case _GEOM_HASHSPACE_CLASS:     return "_GEOM_HASHSPACE_CLASS";
//            case _GEOM_LASTSPACE_CLASS:     return "_GEOM_LASTSPACE_CLASS";
            case _GEOM_FIRSTUSER_CLASS:     return "_GEOM_FIRSTUSER_CLASS";
            case _GEOM_LASTUSER_CLASS:      return "_GEOM_LASTUSER_CLASS";
            case _GEOM_LAST_CLASS:          return "_GEOM_LAST_CLASS";
            default:                        return "_GEOM_LAST_CLASS";
        }
    }
}

