/** Parametry jointow - polaczen i ograniczen ODE.
    Patrz dokument "Open Dynamic Engine vX.XXX User Guide".
    UWAGA: musi byc synchronizowana z ODE - plik (ODE/include/common.h)!!!
*/
public class EODEJointParameters
{
	final static int _PARAM_LO_STOP             = 0x000;
	final static int _PARAM_HI_STOP             = 0x001;
	final static int _PARAM_VEL                 = 0x002;
    final static int _PARAM_FMAX                = 0x003;
	final static int _PARAM_FUDGE_FACTOR        = 0x004;
	final static int _PARAM_BOUNCE              = 0x005;
	final static int _PARAM_CFM		            = 0x006;
	final static int _PARAM_STOP_ERP            = 0x007;
	final static int _PARAM_STOP_CFM            = 0x008;
	final static int _PARAM_SUSPENSION_ERP      = 0x009;
	final static int _PARAM_SUSPENSION_CFM      = 0x00a;

	final static int _PARAM_LO_STOP2            = 0x100;
	final static int _PARAM_HI_STOP2            = 0x101;
	final static int _PARAM_VEL2                = 0x102;
    final static int _PARAM_FMAX2               = 0x103;
	final static int _PARAM_FUDGE_FACTOR2       = 0x104;
	final static int _PARAM_BOUNCE2             = 0x105;
	final static int _PARAM_CFM2	            = 0x106;
	final static int _PARAM_STOP_ERP2           = 0x107;
	final static int _PARAM_STOP_CFM2           = 0x108;
	final static int _PARAM_SUSPENSION_ERP2     = 0x109;
	final static int _PARAM_SUSPENSION_CFM2     = 0x10a;

	final static int _PARAM_LO_STOP3            = 0x200;
	final static int _PARAM_HI_STOP3            = 0x201;
	final static int _PARAM_VEL3                = 0x202;
    final static int _PARAM_FMAX3               = 0x203;
	final static int _PARAM_FUDGE_FACTOR3       = 0x204;
	final static int _PARAM_BOUNCE3             = 0x205;
	final static int _PARAM_CFM3	            = 0x206;
	final static int _PARAM_STOP_ERP3           = 0x207;
	final static int _PARAM_STOP_CFM3           = 0x208;
	final static int _PARAM_SUSPENSION_ERP3     = 0x209;
	final static int _PARAM_SUSPENSION_CFM3     = 0x20a;


    static String GetFlagName(int nFlag)
    {
        switch (nFlag)
        {
            case _PARAM_LO_STOP:
                return "_PARAM_LO_STOP";
            case _PARAM_HI_STOP:
                return "_PARAM_HI_STOP";
            case _PARAM_VEL:
                return "_PARAM_VEL";
            case _PARAM_FMAX:
                return "_PARAM_FMAX";
            case _PARAM_FUDGE_FACTOR:
                return "_PARAM_FUDGE_FACTOR";
            case _PARAM_STOP_ERP:
                return "_PARAM_STOP_ERP";
            case _PARAM_STOP_CFM:
                return "_PARAM_STOP_CFM";
            case _PARAM_SUSPENSION_ERP:
                return "_PARAM_SUSPENSION_ERP";
            case _PARAM_SUSPENSION_CFM:
                return "_PARAM_SUSPENSION_CFM";
            /// 2
            case _PARAM_LO_STOP2:
                return "_PARAM_LO_STOP2";
            case _PARAM_HI_STOP2:
                return "_PARAM_HI_STOP2";
            case _PARAM_VEL2:
                return "_PARAM_VEL2";
            case _PARAM_FMAX2:
                return "_PARAM_FMAX2";
            case _PARAM_FUDGE_FACTOR2:
                return "_PARAM_FUDGE_FACTOR2";
            case _PARAM_STOP_ERP2:
                return "_PARAM_STOP_ERP2";
            case _PARAM_STOP_CFM2:
                return "_PARAM_STOP_CFM2";
            case _PARAM_SUSPENSION_ERP2:
                return "_PARAM_SUSPENSION_ERP2";
            case _PARAM_SUSPENSION_CFM2:
                return "_PARAM_SUSPENSION_CFM2";

            case _PARAM_LO_STOP3:
                return "_PARAM_LO_STOP3";
            case _PARAM_HI_STOP3:
                return "_PARAM_HI_STOP3";
            case _PARAM_VEL3:
                return "_PARAM_VEL3";
            case _PARAM_FMAX3:
                return "_PARAM_FMAX3";
            case _PARAM_FUDGE_FACTOR3:
                return "_PARAM_FUDGE_FACTOR3";
            case _PARAM_STOP_ERP3:
                return "_PARAM_STOP_ERP3";
            case _PARAM_STOP_CFM3:
                return "_PARAM_STOP_CFM3";
            case _PARAM_SUSPENSION_ERP3:
                return "_PARAM_SUSPENSION_ERP3";
            case _PARAM_SUSPENSION_CFM3:
                return "_PARAM_SUSPENSION_CFM3";

            default:
                return "__UNKNOWN FLAG____";
        }
    }


}

