/** Parametry uzywane w metodach: ControlObject::ODE_GetJointType().
    Patrz dokument "Open Dynamic Engine vX.XXX User Guide".
    UWAGA: musi byc synchronizowana z ODE (plik common.h)!!!
*/
public class EODEJointTypes
{
	final static int _JOINT_TYPE_NONE           = 0x000;	
	final static int _JOINT_TYPE_BALL           = 0x001;
	final static int _JOINT_TYPE_HINGE          = 0x002;
    final static int _JOINT_TYPE_SLIDER         = 0x003;
	final static int _JOINT_TYPE_CONTACT        = 0x004;
	final static int _JOINT_TYPE_UNIVERSAL      = 0x005;
	final static int _JOINT_TYPE_HINGE2	        = 0x006;
	final static int _JOINT_TYPE_FIXED          = 0x007;
	final static int _JOINT_TYPE_NULL           = 0x008;
	final static int _JOINT_TYPE_AMOTOR         = 0x009;

    static String GetFlagName(int nFlag)
    {
        switch (nFlag)
        {
            case _JOINT_TYPE_NONE:
                return "_JOINT_TYPE_NONE";
            case _JOINT_TYPE_BALL:
                return "_JOINT_TYPE_BALL";
            case _JOINT_TYPE_HINGE:
                return "_JOINT_TYPE_HINGE";
            case _JOINT_TYPE_SLIDER:
                return "_JOINT_TYPE_SLIDER";
            case _JOINT_TYPE_CONTACT:
                return "_JOINT_TYPE_CONTACT";
            case _JOINT_TYPE_UNIVERSAL:
                return "_JOINT_TYPE_UNIVERSAL";
            case _JOINT_TYPE_HINGE2:
                return "_JOINT_TYPE_HINGE2";
            case _JOINT_TYPE_FIXED:
                return "_JOINT_TYPE_FIXED";
            case _JOINT_TYPE_NULL:
                return "_JOINT_TYPE_NULL";
            case _JOINT_TYPE_AMOTOR:
                return "_JOINT_TYPE_AMOTOR";
            default:
                return "_JOINT_TYPE_NONE";
        }
    }
}

