/** Typ przeszkody z ktora skolidowala bryla sztywna. 
    TERRAIN     - kolizja z terenem;
    TREE        - kolizja z drzewem;
    OBJECT      - MeshObject nie uzywajacy fizyki RigidBody;
    RIGID_BODY  - Bryla sztywna zdefiniowane za pomoca czasteczek;

    Moga byc uzywane jako flagi!
    UWAGA: wartosci musza byc zgodne z enumem RigidBodyCollisionConstraints::EObstacleType 
    zdefiniowanym w pliku "RigidBodyCollisionConstraints.hpp".
*/
public class EObstacleType
{
    final static int TERRAIN    =   0x0001;
    final static int TREE       =   0x0002;
    final static int OBJECT     =   0x0004;
    final static int RIGID_BODY =   0x0008;

    static String GetFlagName( int nFlag )
    {
        switch( nFlag )
        {
            case TERRAIN:
                return "TERRAIN";
            case TREE:
                return "TREE";
            case OBJECT:
                return "OBJECT";
            case RIGID_BODY:
                return "RIGID_BODY";
            default:
                return "__UNKNOWN TYPE____";
        }
    }
}
