/** Klasa bazowa uzywana do definiowania tekstury na potrzeby efektow.
 *  Kazdy tesktura, ktora ma byc uzyta do definicji efektu musi byc potomkiem klasy FXTexture
 * */
public class FXTexture extends GameObject
{
 /**[native] Rozpoczyna definicje nowej tekstury 
    * @param sTextureName nazwa tekstury (<code>String</code>)     
    */ 
    native final void Texture(String sTextureName);
 
/**[native] Definiuje nazwe pliku tekstury 
    * @param sTextureFile nazwa pliku tekstury (<code>String</code>)     
    */ 
    native final void File(String sTextureFile);
    
/**[native] Definiuje nazwe pliku tekstury, tekstura ladowana jest w wysokiej jakosci
    * @param sTextureFile nazwa pliku tekstury (<code>String</code>)     
    */ 
    native final void FileHQ(String sTextureFile);
    
/**[native] Definiuje pojedyncza klatke animacji 
    *@param iMinX okresla wspolrzedna x lewego gornego rogu klatki animacji w teksturze (<code>int</code>)
    *@param iMinY okresla wspolrzedna y lewego gornego rogu klatki animacji w teksturze (<code>int</code>)     
    *@param iMaxX okresla wspolrzedna x lewego dolengo rogu klatki animacji w teksturze (<code>int</code>)     
    *@param iMaxY okresla wspolrzedna y lewego dolnego rogu klatki animacji w teksturze (<code>int</code>)          
     */ 
    native final void Rect(int iMinX, int iMinY, int iMaxX, int iMaxY);
    
/**[native] Definiuje sekwencje klatek animacji 
    *@param iMinX okresla wspolrzedna x lewego gornego rogu obszaru zawierajacego pierwsza klatke animacji w teksturze (<code>int</code>)
    *@param iMinY okresla wspolrzedna y lewego gornego rogu obszaru zawierajacego pierwsza klatke animacji w teksturze (<code>int</code>)     
    *@param iMax1X okresla wspolrzedna x prawego dolengo rogu obszaru zawierajacego pierwsza klatke animacji w teksturze (<code>int</code>)     
    *@param iMax1Y okresla wspolrzedna y prawego dolnego rogu obszaru zawierajacego pierwsza klatke animacji w teksturze (<code>int</code>)          
    *@param iMax2X okresla wspolrzedna x prawego dolnego rogu obszaru zawierajacego ostatnia klatke animacji w teksturze (<code>int</code>)     
    *@param iMax2Y okresla wspolrzedna y prawego dolnego rogu obszaru zawierajacego ostatnia klatke animacji w teksturze (<code>int</code>)          
     */     
    native final void MultiRect(int iMinX, int iMinY,int iMax1X, int iMax1Y,int iMax2X, int iMax2Y );        
}
