/** klasa przycisku scrollbara, ktory moze byc przesuwany myszka
 */
public class ButtonScrollBar extends Button
{
	Cursor m_Cursor = null;
	
	void SetCursor(Cursor cursor)
	{
		m_Cursor = cursor;
	}
	
    public class LMBDown extends Button.LMBDown
    {
		Vector m_vRelativePos = null;
		float m_fCursorX;
		float m_fYMin;
		float m_fYMax;
		
        public void OnEnter()
        {
			m_vRelativePos = m_Cursor.GetPointerPos();
			m_vRelativePos.Sub(GetPos());
			m_fCursorX = m_Cursor.GetPointerPos().fX;
			
			float fParentYPos = wndParent.GetPos().fY;
			float fParentHeight = wndParent.GetSize().fY;
			
			m_fYMin = fParentYPos + ((ListBox) wndParent).btnUpArrow.GetSize().fY + m_vRelativePos.fY;
			m_fYMax = fParentYPos + fParentHeight - 
					  ((ListBox) wndParent).btnDnArrow.GetSize().fY -
					  GetSize().fY +
					  m_vRelativePos.fY;
        }
		
        void OnLBUp(float fMouseX, float fMouseY)
	    {
            if (!CanProcessMouseBtns())
				return;
            SetCheck(false);
			
            ButtonPushed(ButtonScrollBar.this);
            SetHighlight(true, false);

			ListBox listbox = (ListBox) wndParent;
			listbox.ChangeScrollBarPos();
			
			SetState("Idle");
	    }   
        
        void OnMouseEnter(float fMouseX, float fMouseY)
        {
            SetHighlight(true, true);
            SetState("Idle");
        }
        
        void OnMouseLeave(float fMouseX, float fMouseY)
        {
            if (m_Cursor == null)
                return;
            
			float fNewMouseY;
			
			if (fMouseY > m_fYMax)
				fNewMouseY = m_fYMax;
			else
			if (fMouseY < m_fYMin)
				fNewMouseY = m_fYMin;
			else
				fNewMouseY = fMouseY;
			m_Cursor.SetPos(new Vector(m_fCursorX, fNewMouseY, 0));
			UpdateListView( (fNewMouseY - m_fYMin) / (m_fYMax - m_fYMin) );
			SetPos(new Vector(m_fCursorX - m_vRelativePos.fX,
							  fNewMouseY - m_vRelativePos.fY,
							  0));
        }
		
	    void OnMouseMove(float fMouseX, float fMouseY, int iButtonsFlags)
        {
			OnMouseLeave(fMouseX, fMouseY);
		}

		void UpdateListView(float fScrollbarPos)
		{
			ListBox listbox = (ListBox) wndParent;
			
			listbox.nFirstVisible = java.lang.Math.round(fScrollbarPos * (listbox.nItemCount - listbox.nCapacity));
			listbox.UpdateList();
		}
    }
}
