public class ComboBox extends Button
{
    ComboBoxList List_Item;
    Button Button_Arrow;
    final static float P256 = 1.0f/256.0f;
    
    final static int ID_LIST_DES = 20000;
	/**Poczatek ID elementow listy */
	final static int ID_LIST_ITEM = 60000;
	/**Identyfikator strzalki*/
    final static int ID_BTN_ARROW = 20001;
	
	int iCount = 0;
	
	/**czy lista jest aktywna*/
	boolean bListIsActive = false;
	
    /** Maksymalna widocznosc elementow listy */
    int iMaxVisibilityItem = 5;
    float fMaxSizeItem = 16;
	int iIndexSelect = 1;
    
    void Init(UIElement data, Module module)
    {
        super.Init(data,module);
        CreateArrow();
        CreateListCombo();
        List_Item.ShowScroll(false);
    }
    
    void CreateArrow()
    {
        Button_Arrow = (Button)CreateObject("Button");
        AddChildWnd(Button_Arrow,wndRoot);
        AddChild(Button_Arrow);
        Button_Arrow.Init(new UIElement(ID_BTN_ARROW,0,
										new Vector(0,0,0),
										new Vector(32,32,0),            
										"Data/Menu/guzik_dol.png",
										"Data/Menu/guzik2_dol.png",
										"Data/Menu/guzik_dol.png",
										"Data/Menu/guzik2_dol.png",
										EButtonFlags.BTN_TYPE_PUSHBUTTON,
										""
										),
						  module);
        Button_Arrow.Show();
        Vector temp1 = new Vector(GetSize());
        Button_Arrow.SetRelativePos(new Vector(temp1.fX,temp1.fY - Button_Arrow.GetSize().fY,0));
    }
    
    void CreateListCombo()
    {
        Vector temp1 = new Vector(GetSize());
        List_Item = (ComboBoxList)CreateObject("ComboBoxList");
        AddChildWnd(List_Item,wndRoot);
        AddChild(List_Item);
        List_Item.Init(new UIElement(ID_LIST_DES,0,
                                        new Vector(0,temp1.fY,0),
                                        new Vector(temp1.fX + Button_Arrow.GetSize().fX,fMaxSizeItem,0),
                                        "Data/Menu/ComboBox_Bac.png",
                                        //new Rect( 11.0f * P256, 309.0f * 1.0f/512.0f, 251.0f * P256, 387.0f * 1.0f/512.0f),
                                        "",
                                        //new Rect(),
                                        "", 
                                        //new Rect(),
                                        "", 
                                        //new Rect(),
                                        EButtonFlags.BTN_TYPE_LISTBOX,
                                        "")
                                        ,module);
        List_Item.SetCapacity(iMaxVisibilityItem);
		List_Item.SetRelativePos(new Vector(0.0f,temp1.fY,0));
        List_Item.Show();
        List_Item.Owner = this;
        List_Item.Hide();
        //List_Item._SetSize(new Vector(temp1.fX,fMaxSizeItem,0));
        
    }
	
	int AddString(String s)
	{
		Button Button_Item = (Button)CreateObject("Button");
		Button_Item.Init(new UIElement(ID_LIST_ITEM + iCount,0,
									   new Vector(0.0f,0.0f,0.0f),
									   new Vector(List_Item.GetSize().fX,fMaxSizeItem,0.0f),
									   "Data/Menu/ramka_rozwijana.png",
									   "Data/Menu/ramka2_rozwijana.png",
									   "",
									   "",
									   EButtonFlags.BTN_TYPE_LISTBOX_ITEM,
									   s),
						 module);
		int iIndex = List_Item.AddItem(Button_Item);
		iCount++;
        if ( iCount < iMaxVisibilityItem )
        {
            Vector vSize = new Vector(List_Item.GetSize());
            List_Item.SetSize(new Vector(vSize.fX , vSize.fY + fMaxSizeItem ,0.0f)); 
            List_Item.SetCapacity(iCount);
            List_Item.UpdateList();
            //List_Item._SetSize(new Vector(GetSize().fX,fMaxSizeItem,0));
        }
		else 
        {
            //List_Item._SetSize(new Vector(GetSize().fX + Button_Arrow.GetSize().fX ,fMaxSizeItem,0)); 
            List_Item.ShowScroll(true);
        }
        Button_Item.SetTextPosFlags(ESpriteText.VERT_MIDDLE | ESpriteText.HORIZ_MIDDLE);
		Button_Item.DisplayText(s);
		Button_Item.sText = s;
		return iIndex;
	}
	
	boolean SetSelect( int iIndex)
	{
        if ( iIndex > iCount )
        {
            LogLine("nie ma takiego elementu w liscie");
        }
        iIndexSelect = iIndex; 
		sText = ((Button)List_Item.vItems.elementAt(iIndex)).sText;
        SetTextPosFlags(ESpriteText.VERT_MIDDLE | ESpriteText.HORIZ_MIDDLE);
		DisplayText(sText);
		return true;
	}
	
    int GetSelect()
    {
        return iIndexSelect;    
    }
    
	void OnButton(Button btnSender)
    {
		switch( btnSender.nID )
		{
			case ID_BTN_ARROW:
			{
				List_Item.Show();
				List_Item.UpdateList();
				bListIsActive = true;
				SetState("ListActive");
				break;
			}
		}
        //LogLine("wcisnieta togle");
    }
	
	public class ListActive extends Button.Idle 
    {
        public void OnEnter()
        {
            List_Item.CaptureMouse();
        }
		
		void OnButton(Button btnSender)
		{
			if(btnSender.nID >= ID_LIST_ITEM)
			{
				SetSelect(List_Item.GetSelection());
                CallOnButton(ComboBox.this);
                ExitList();
			}
            else
            {
                if (wndParent != null )
                {
                    wndParent.CallOnButton(btnSender);
                    return;
                }
            }
		}
	}
    
    void ExitList()
    {
        List_Item.Hide();
	    bListIsActive = false;
        List_Item.ClearCaptureMouse();
	    SetState("Idle");
    }
    
    public void DumpHeader(ScriptWriter cWriter)
    {
        cWriter.Write("ControlObject(\"" + "UIComboBox\"" + ", \"ID_" + String.valueOf(nID) + "\", \"Specific\")");
    }
    
    public void DumpData(ScriptWriter cWriter)
    {
        super.DumpData(cWriter);
        
        
    }
    
    public void Dump(ScriptWriter cWriter)
    {
        cWriter.NewLine();
        DumpHeader(cWriter);        
        cWriter.Write("{");
        cWriter.IncIndent();
        DumpData(cWriter);
        //dzieci nie zapisujemy
        cWriter.DecIndent();
        cWriter.Write("}");
    }
}
