public class MovingCredits extends GameObject
{
	java.util.Vector m_Sprites = new java.util.Vector();
	java.util.Vector m_Fonts = new java.util.Vector();
	Module m_Module = null;
	
	boolean bUpdate = false;
	float m_fLastTime = 0f;
	float m_fSpeed = 0f;
	float m_fScreenWidth;
	float m_fScreenHeight;
	float m_fLastElemSpacing = -50f;
	
	/** inicjacja, przeparsowanie skryptu z creditsami */
	public void Init(String sScriptFile, Module mod)
	{
		m_Module = mod;
		
		ParseKeyword Root = GameObject.ParseFile(sScriptFile);
												  
		if (Root == null)
		{
			GameObject.CrashLog("No file " + sScriptFile + "!\n");
			return;
		}
		else
		{
			ParseKeyword Key = null;
			ParseKeyword SubKey = null;
			
			Sprite sprText = null;
			float fCurrPos = m_Module.GetScreenHeight();
			m_fScreenWidth = m_Module.GetScreenWidth();
			m_fScreenHeight = m_Module.GetScreenHeight();
			float fDefaultSpace = 0f;
			float fHorizPos = 0.5f * m_fScreenWidth;
			String sDefaultFont = Fonts.GetDefaultFont();
			
			for (Key = Root; Key != null; Key = Key.GetNext())
			{
				if (Key.Equals("LoadFont"))
				{
					CreditsFont font = new CreditsFont(Key.GetSParam(0),
													   Key.GetSParam(1),
													   Key.GetIParam(2),
													   m_Module);
					m_Fonts.addElement(font);
				}
				else
				if (Key.Equals("DefaultFont"))
				{
					sDefaultFont = Key.GetSParam(0);
				}
				else
				if (Key.Equals("DefaultFontRes"))
				{
					int iWidth = Key.GetIParam(0);
					if (m_fScreenWidth == iWidth)
						sDefaultFont = Key.GetSParam(1);
				}
				else
				if (Key.Equals("DefaultSpace"))
				{
					fDefaultSpace = Key.GetFParam(0);
					if (fDefaultSpace < 1f)
						fDefaultSpace *= m_fScreenHeight;
				}
				else
				if (Key.Equals("DefaultSpaceRes"))
				{
					int iWidth = Key.GetIParam(0);
					if (m_fScreenWidth == iWidth)
						fDefaultSpace = Key.GetFParam(1);
					if (fDefaultSpace < 1f)
						fDefaultSpace *= m_fScreenHeight;
				}
				else
				if (Key.Equals("HorizPos"))
				{
					fHorizPos = Key.GetFParam(0);
					if (fHorizPos < 1f)
						fHorizPos *= m_fScreenWidth;
				}
				else
				if (Key.Equals("Speed"))
				{
					m_fSpeed = Key.GetFParam(0);
					if (m_fSpeed < 1f)
						m_fSpeed *= m_fScreenWidth;
				}
				else
				if (Key.Equals("LastLineSpacing"))
				{
					m_fLastElemSpacing = Key.GetFParam(0);
					if (java.lang.Math.abs(m_fLastElemSpacing) < 1f)
						m_fLastElemSpacing *= m_fScreenHeight;
				}
				if (Key.Equals("Line"))
				{
					float fSpace = fDefaultSpace;
					String sFont = sDefaultFont;
					Vector vSize = new Vector(1f, 1f, 0f);
					
					sprText = (Sprite) CreateObject("Sprite");
					m_Module.AddSprite(sprText);
					sprText.MoveTop();
					sprText.DisplayText(Key.GetSParamLocalized(0));
					sprText.SetTextPosFlags(ESpriteText.HORIZ_MIDDLE);
					
			  		for (SubKey = Key.GetChild(); SubKey != null; SubKey = SubKey.GetNext())
			  		{
			  			if (SubKey.Equals("Font"))
						{
							sFont = SubKey.GetSParam(0);
						}
						else
			  			if (SubKey.Equals("FontRes"))
						{
							int iWidth = SubKey.GetIParam(0);
							if (m_fScreenWidth == iWidth)
								sFont = SubKey.GetSParam(1);
						}
						else
						if (SubKey.Equals("Space"))
						{
							fSpace = SubKey.GetFParam(0);
							if (fSpace < 1f)
								fSpace *= m_fScreenWidth;
						}
					}
					
					sprText.SetFont(sFont);
					
					Vector vPos = new Vector(fHorizPos, fCurrPos + fSpace, 0);
					SpriteInfo info = new SpriteInfo(sprText, vPos);
					
					fCurrPos += fSpace + vSize.fY;
					sprText.SetSize(vSize);
					
					m_Sprites.addElement(info);
				}
			}
            Root.delete();
		}
	}
	
	/** pokazanie creditsow, rozpoczecie przemieszczania tekstu */
	public void Start()
	{
		CallMethodEvery("Update", 0.01f);
		InitStartPos();
		m_fLastTime = GetTime();
		if (m_Sprites.size() > 0)
			((SpriteInfo) m_Sprites.elementAt(0)).m_Sprite.Show();
	}
	
	/** schowanie creditsow, usuniecie sprite'ow i fontow, czyszczenie po sobie */
	public void End()
	{
		DisableCallMethod("Update");
		
		ReleaseTexts();
		ReleaseFonts();
	}
	
	private void Update()
	{
		float fDt = GetTime() - m_fLastTime;
		
		float fMove = m_fSpeed * fDt;
		
		for (int i = 0; i < m_Sprites.size(); i++)
		{
			SpriteInfo info = (SpriteInfo) m_Sprites.elementAt(i);
			
			Vector vPos = info.m_Sprite.GetPos();
			vPos.fY -= fMove;
			
			info.m_Sprite.SetPos(vPos);
			
			if ((vPos.fY <= m_fScreenHeight) && (vPos.fY >= m_fLastElemSpacing) )
				info.m_Sprite.Show();
			else
				info.m_Sprite.Hide();
		}
		
		if (m_Sprites.size() > 0)
		{
			SpriteInfo info = (SpriteInfo) m_Sprites.elementAt(m_Sprites.size() - 1);
			Vector vPos = info.m_Sprite.GetPos();
			if (info.m_Sprite.GetPos().fY < m_fLastElemSpacing)
				InitStartPos();
		}
		
		m_fLastTime = GetTime();
	}
	
	private void InitStartPos()
	{
		for (int i = 0; i < m_Sprites.size(); i++)
		{
			SpriteInfo info = (SpriteInfo) m_Sprites.elementAt(i);
			info.m_Sprite.SetPos(info.m_vStartPos);
		}
	}

	private void ReleaseTexts()
	{
		for (int i = 0; i < m_Sprites.size(); i++)
		{
			SpriteInfo info = (SpriteInfo) m_Sprites.elementAt(i);
			info.m_Sprite.DetachFromParent();
			info.m_Sprite.RemoveSprite(info.m_Sprite);
			info.m_Sprite.delete();
			info.m_Sprite = null;
		}
		m_Sprites.clear();
	}
	
	private void ReleaseFonts()
	{
		for (int i = 0; i < m_Fonts.size(); i++)
		{
			CreditsFont font = (CreditsFont) m_Fonts.elementAt(i);
			font.ReleaseFont(m_Module);
		}
		m_Fonts.clear();
	}
	
	class SpriteInfo
	{
		Sprite m_Sprite = null;
		Vector m_vStartPos = new Vector();
		
		SpriteInfo(Sprite sprite, Vector vStart)
		{
			m_Sprite = sprite;
			m_vStartPos.Set(vStart);
		}
	}
	
	class CreditsFont
	{
		String m_sID = null;
		String m_sName = null;
		int m_iHeight = 0;
		
		CreditsFont(String ID, String name, int height, Module module)
		{
			m_sID = ID;
			m_sName = name;
			m_iHeight = height;
			if (!module.LoadFont(m_sID, m_sName, m_iHeight, 0))
				GameObject.CrashLog("Font ID " + m_sID + ", name " + m_sName + " not loaded !!!\n");
		}
		
		void ReleaseFont(Module module)
		{
			module.ReleaseFont(m_sID);
		}
	}
}
