public class UIElement
{
    /**Identyfikator elementu*/
    int nID = 0;
    /**Dodatkowy identyfikator*/
    int nIDExtra = 0;
    int nFlags;
    /**nazwa pliku zawierajacego teksture przycisku w stanie "normalnym"*/
    String sUncheckedTex;
    /**nazwa pliku zawierajacego teksture przycisku w stanie wcisnietym lub "checked"*/
    String sCheckedTex;
    /**nazwa pliku zawierajacego teksture przycisku gdy jest nieaktywny {@link Button#Enable(boolean bEnable)}, moze byc pusty*/
    String sDisabledTex;
    /**nazwa pliku zawierajacego teksture przycisku gdy jest podswietlony*/
    String sHighlightedTex;
    /**wyswietlany tekst, domyslnie ""*/
    String sText;
    /**pozycja elementu*/
    Vector vPos;
    /**rozmiary elementu*/
    Vector vSize;
    /**Pozycja tekstury w wiekszej calosci (0,0,1,1) to cala tekstura*/
    Rect rUncheckedTex;
    Rect rCheckedTex;
    Rect rDisabledTex;
    Rect rHighlightedTex;
    /**Konstruktor gdy tekstury sa w oddzielnych plikach*/
    UIElement(int nIdP, int nIdExtraP, Vector vP, Vector vS, String sTex1, String sTex2, String sTex3, String sTex4, int nFlagsP, String sTxt)
    {
        nID = nIdP;
        nIDExtra = nIdExtraP;
        sUncheckedTex = sTex1;
        sCheckedTex = sTex2;
        sDisabledTex = sTex3;   
        sHighlightedTex = sTex4;
        nFlags = nFlagsP;
        sText = sTxt;
        vPos = vP;
        vSize = vS;
        rUncheckedTex = new Rect(0,0,1,1);
        rCheckedTex = new Rect(0,0,1,1);
        rDisabledTex = new Rect(0,0,1,1);   
        rHighlightedTex = new Rect(0,0,1,1);
    }
    /**Konstruktor, gdy tekstury sa czesciami wiekszego pliku*/
    UIElement(int nIdP, int nIdExtraP, Vector vP, Vector vS, String sTex1, Rect rTex1, String sTex2, Rect rTex2, String sTex3, Rect rTex3, String sTex4, Rect rTex4, int nFlagsP, String sTxt)
    {
        nID = nIdP;
        nIDExtra = nIdExtraP;
        sUncheckedTex = sTex1;
        rUncheckedTex = rTex1;
        sCheckedTex = sTex2;
        rCheckedTex = rTex2;
        sDisabledTex = sTex3;
        rDisabledTex = rTex3;   
        sHighlightedTex = sTex4;
        rHighlightedTex = rTex4;
        nFlags = nFlagsP;
        sText = sTxt;
        vPos = vP;
        vSize = vS;
    }
    /**Konstruktor dla progress bara i editboxa, i nie tylko :)
     * @param sTex1 tekstura tla
     * @param sTex2 tekstura klocka*/
    UIElement(int nIdP, int nIdExtraP, Vector vP, Vector vS, String sTex1, Rect rTex1, String sTex2, Rect rTex2, int nFlagsP)
    {
        nID = nIdP;
        nIDExtra = nIdExtraP;
        sUncheckedTex = sTex1;
        rUncheckedTex = rTex1;
        sCheckedTex = sTex2;
        rCheckedTex = rTex2;
        nFlags = nFlagsP;
        vPos = vP;
        vSize = vS;
    }
    
    UIElement()
    {
        nID = 0;
        nIDExtra = 0;
        rUncheckedTex = new Rect(0,0,1,1);
        rCheckedTex = new Rect(0,0,1,1);
        rDisabledTex = new Rect(0,0,1,1);   
        rHighlightedTex = new Rect(0,0,1,1);
        sUncheckedTex = "";
        sCheckedTex = "";
        sDisabledTex = "";   
        sHighlightedTex = "";
        nFlags = EButtonFlags.BTN_TYPE_LISTBOX_ITEM;
        vPos = new Vector();
        vSize = new Vector();
    }
}
