public class UIComboBox extends UIControlObject
{
    UIListBox m_cList = null;
    UIButton m_cTrigger = null;
    UIStatic m_cText = null;
    boolean m_bExpanded = false;
    
    public void OnInit()
    {
        super.OnInit();
        m_cList = (UIListBox)GetElem("ID_COMBO_LIST");
        m_cList.Reload();
        m_cList.ShowScroll(false);
        m_cList.SetCapacity(1);
        m_cList.Hide();
        m_cList.SetActive(false);
        m_cTrigger = (UIButton)GetElem("ID_COMBO_TRIGGER");
        m_cText = (UIStatic)GetElem("ID_COMBO_TEXT");
        ProcessKb(true);
    }
    
    Vector vPrevSize = null;
    
    public void SetSize(Vector vSize)
    {
        if (!m_bInited)
            return;
        
        if (vPrevSize != null)
        {
            if (vPrevSize.IsEqual(vSize))
                return;
        }
        vPrevSize = new Vector(vSize);
        super.SetSize(vSize);
        
        
        if (!m_bExpanded && m_cTrigger != null)
        {
            Vector vTriggerSize = m_cTrigger.GetSize();
            if (vTriggerSize.Len() == 0)
            {
                m_cTrigger.OnSizeAndPos();
                vTriggerSize = m_cTrigger.GetSize();
            }
            Vector vTriggerPos = new Vector(vSize.fX - vTriggerSize.fX, (vSize.fY - vTriggerSize.fY)/2f, 0);
            m_cTrigger.SetRelativePos(vTriggerPos);
            m_cTrigger.UpdateLogicSizeAndPos(m_cTrigger.GetSize(), m_cTrigger.GetPos());
        
            m_cText.SetSize(vSize);
            m_cText.SetRelativePos(new Vector());
            m_cText.UpdateLogicSizeAndPos(vSize, m_cText.GetPos());
        }
    }
    
    void Expand()
    {
        if (!m_bExpanded)
        {
            m_cList.SetActive(true);
            m_bExpanded = true;
            Vector vSize = GetSize();
            if (vSize.Len() == 0)
            {
                OnSizeAndPos();
                vSize = GetSize();
            }
            Vector vListSize = m_cList.GetSize();
            if (vListSize.Len() == 0)
            {
                m_cList.OnSizeAndPos();
                vListSize = m_cList.GetSize();
            }
            Vector vListPos = new Vector(vSize.fX - vListSize.fX, 0,0);
            m_cList.SetRelativePos(vListPos);
            m_cList.UpdateLogicSizeAndPos(vListSize, m_cList.GetPos());
            m_cList.OnSizeAndPos();
            vListPos = m_cList.GetPos();
            vListPos.Sub(GetPos());
            Vector vNewSize = new Vector(GetSize().fX, vListSize.fY, 0);
            m_cList.Show();
            SetSize(vNewSize);
            m_cList.UpdateList();
            m_cTrigger.SetFocus(false);
            m_cTrigger.SetActive(false);
            CaptureMouse();
            m_cList.MoveTopWithChildren();
            SetSelection(GetSelection());
            MoveTop();
        }
    }
    
    int m_nSelected = -1;
    
    /**Zamkniecie listy*/
    void Collapse()
    {
        if (m_bExpanded)
        {
            m_nSelected = m_cList.GetSelection(); 
            m_bExpanded = false;
            m_cList.Hide();
            ClearCaptureMouse();
            SetSize(m_cText.GetSize());
            UpdateLogicSizeAndPos(GetSize(), GetPos());
            m_cList.SetActive(false);
            m_cTrigger.SetActive(true);
        }
    }
    
    final static int ID_TRIGGER = 17,
                     ID_LIST_BUTTON = 18;
    
    void OnUICommand(UIWindow cSender, int nCommand)
	{
		
		if(nCommand == EUIConst.CM_CLICK)
        {
            int nID = -1;
            //CrashLog("ListBox.OnUICommand from " + cSender.m_sId + " text " + ((UIButton)cSender).m_sText+"\n");
            if (cSender.m_sId.equals("ID_COMBO_TRIGGER"))
            {
                nID = ID_TRIGGER;
            } 
            //przycisk listy
            if (cSender.m_sId.equals("ID_BUTTON"))
            {
                nID = ID_LIST_BUTTON;    
            }
            
            switch(nID)
            {
                case ID_TRIGGER:
                    OnTrigger();
                    break;
                case ID_LIST_BUTTON:
                    m_cList.SetSelection((UIButton)cSender);
                    OnSelection((UIButton)cSender);
                    break;
            }
                
        }
		/*if(nCommand == EUIConst.CM_SEL)
			LogLine("-i--  Sel -----"+ cSender.m_sId+" z menu "
					+(((UIMenuButton)cSender).GetMenu()).m_sId);		
		if(nCommand == EUIConst.CM_SEL_DBCLICK)
						LogLine("-i--  Sel_dbClick -----"+ cSender.m_sId+" z menu "
					+(((UIMenuButton)cSender).GetMenu()).m_sId);		*/
        super.OnUICommand(cSender,nCommand);		
	}
    
    void SetDisabled(boolean bDisabled)
    {
        if(m_bExpanded)
        {
           Collapse();
        } 
        m_cTrigger.SetDisabled(bDisabled);
    }
    
    void OnTrigger()
    {
        //wolana w nastepnej klatce, zeby przycisk na rozwijanej liscie nie dostal info o 
        //kliknieciu
        CallMethodIn("Expand", 0);
    }
    
    void OnLBDownOut(float fX, float fY)
    {
        if (m_bExpanded)
            Collapse();
    }
    
    void OnLBDown(float fX, float fY)
    {
        //jesli klikniemy poza lista ale w listboxie, to tzeba collapsowac
        if (!m_cList.HitTest(new Vector(fX, fY,0)))
            CallMethodIn("Collapse", 0);
    }
    
    int AddItem(String sText, Object data)
    {
        //m_cList.SetActive(true);
        if (m_cList.m_nCapacity <= m_cList.GetItemCount())
        {
            m_cList.SetCapacity(m_cList.GetItemCount() + 1);
            m_cList.OnSetCapacity();
        }
        int nRet = (m_cList.AddItem(sText, data));
        //m_cList.SetActive(false);
        return nRet;
    }
    
    /**Wstawia dany element na podana pozycje, not implemented*/
    int InsertItem(int nIndex, String sText, Object data)
    {
        //TODO zrobic
        return -1;  
    }
 

    int GetItemCount()
    {
        return m_cList.GetItemCount();
    }
    
    UIButton GetItem(int nIndex)
    {
        return m_cList.GetItem(nIndex);
    }
    
    void OnSelection(UIButton btnSelected)
    {
        CallMethodIn("Collapse", 0);
        m_cText.m_cData = (Object)btnSelected;
        m_cText.SetText(btnSelected.m_sText);
    }
    
    /**Zwraca indeks elementu zaznaczonego na liscie, -1 jesli nic nie zaznaczone.*/
    int GetSelection()
    {
        return m_cList.GetIndexOf(GetSelected());
    }
    
    UIButton GetSelected()
    {
        return (UIButton)m_cText.m_cData;
    }
    
    void SetSelected(UIButton btnSel)
    {
        if (btnSel == null)
            return;
        m_cList.SetSelection(btnSel);
        m_cText.m_cData = (Object)btnSel;
        m_cText.SetText(btnSel.m_sText);
    }
    
    void SetSelection(int nIndex)
    {
        SetSelected(m_cList.GetItem(nIndex));
    }

    /*void ForceRefresh()
    {
        super.ForceRefresh();
        m_cText.ForceRefresh();
        m_cList.ForceRefresh();
    }*/
    
}
