public class UICursor extends Sprite
{
    static Vector l_vTemp = new Vector();
    
	/** klasa opisujaca teksture */
	class TextureData
	{
		int m_nNo = 0;
		String m_sName = null;
	};
	
	Sprite toolTip = null;
    String sToolTipTex = null;
    float fToolTipMargin = 2f;
    TextureData cToolTipTex = null;

	Vector vCursorSize = new Vector();    
		
	/** wektor tekstur */
	java.util.Vector m_vTextures = null;
	Sprite m_cCursorPoint = null;
	TextureData m_cCurrTex = null;
 
    void OnCreate()
	{
        ProcessCapturedMouseMove(true);
	    m_vTextures = new java.util.Vector();
	}
	
	void Init(Module mod)
	{
		ProcessMouse(true);
		//SetPos(new Vector(0, 0, 0));
		SetSize(l_vTemp.Set(GetScreenWidth(), GetScreenHeight(), 0));
		mod.AddSprite(this);		
		
		m_cCursorPoint = CreateCursorPoint();
        vCursorSize = m_cCursorPoint.GetSize();
	}
	
    Sprite CreateCursorPoint()
    {
        Sprite cCursorPoint = (Sprite)GetModule().CreateObject("Sprite");
		if (cCursorPoint == null)
		{
			LogLine("Nie moge utworzyc wskaznika");
			return null;
		}
        
		cCursorPoint.SetSize(l_vTemp.Set(32, 32, 0));
		cCursorPoint.SetPos(l_vTemp.Set(0, 0, 0));
		cCursorPoint.ProcessMouse(false);
		GetModule().AddSprite(cCursorPoint);
        cCursorPoint.MoveTop();
        return cCursorPoint;
    }
    
    /** czy kursor ma ustawiona texture wskaznika */
	boolean IsFixed()
	{
		return m_cCurrTex != null; 
	}
	
    /**Ustawia kolor tekstu w tooltipie
     * @param fR wartosc czerwonej skladowej koloru (0..1)
     * @param fG wartosc zielonej skladowej koloru (0..1)
     * @param fB wartosc niebieskiej skladowej koloru (0..1)*/
    void SetToolTipTextColor(float fR, float fG, float fB)
    {
        if (toolTip != null)
        {
            toolTip.SetTextColor(fR, fG, fB, 1);        
        }
        else
        {
            //LogLine("Cursor.SetToolTipTextColor : musisz najpierw utworzyc sprite tooltipa!!!");
            CrashLog("Cursor.SetToolTipTextColor : musisz najpierw utworzyc sprite tooltipa!!!");
        }
           
    }
	
    /**Tworzy okno dla tooltipa, ustawia wszystkie parametry
     * @param mod modul w ktorym jest kursor
     * @param sTexName nazwa pliku z tekstura tla dla tooltipa, moze byc null, wtedy nie ma tla
     * @param rTexPos pozycja w teksturze
     * @param sFontID identyfikator fonta, ktory ma byc uzyty, jesli null to wybrany zostanie "MS Sans Serif" 12
     * @param fR wartosc czerwonej skladowej koloru tekstu (0..1)
     * @param fG wartosc zielonej skladowej koloru tekstu (0..1)
     * @param fB wartosc niebieskiej skladowej koloru tekstu (0..1) 
     * @param fA wartosc alfy (przezroczystosci tekstu) (0 - niewidoczny..1 - nieprzezroczysty)
     * @see Fonts*/
    void InitToolTip(Module mod, String sTexName, Rect rTexPos, String sFontID, float fR, float fG, float fB, float fA)
	{
        if (toolTip == null)
        {
    		toolTip = (Sprite)mod.CreateObject("Sprite");
	    	if (sTexName != null)
            {
                if (sTexName.length() > 0)
                {
                    cToolTipTex = AddTex(sTexName);
	    	        toolTip.SetTexture(cToolTipTex.m_nNo, rTexPos);
                }
            }
		    toolTip.SetSize(Vector.Zero);
		    toolTip.SetPos(Vector.Zero);
		    toolTip.ProcessMouse(false);
		    m_cCursorPoint.AddChild(toolTip);
            toolTip.MoveTop();
        }
        else
        {
            //iTexNum = cursorTex.AddTexture(sTexName, true, true);
		    //toolTip.SetTexture(iTexNum, rTexPos);
        }
        if (m_cCursorPoint != null)
            vCursorSize = m_cCursorPoint.GetSize();
        toolTip.SetTextPosFlags(ESpriteText.HORIZ_MIDDLE|ESpriteText.VERT_MIDDLE);
        if (sFontID == null) toolTip.SetFont(Fonts.FONT_MSSANSSERIF_12);
        else toolTip.SetFont(sFontID);
        toolTip.SetTextColor(fR, fG, fB, fA);
    }

	
	TextureData GetTex(String sName)
	{
	  TextureData cTexSelected=null;
	  for(int i = 0; i < m_vTextures.size(); i++)
	  {
		  TextureData cTex = (TextureData) (m_vTextures.elementAt(i)); 
		  if(sName.equals(cTex.m_sName))
			  cTexSelected = cTex;
	  }
      return cTexSelected; 
   }
	
	TextureData  AddTex(String sName)
	{
	   TextureData cTex = new TextureData();
	   cTex.m_sName = sName;
	   cTex.m_nNo = AddTexture(sName, true, true); 
	   return cTex;
	}

	void SetCursorTex(String sName)
	{
    	if (m_cCursorPoint == null)
		{
			LogLine("Nie utworzony wskaznik");
			return;
        }
        if (sName == null)
        {
            Tools.CrashLogWarning("Setting null cursor \n");
            return;
        }
        
        //CrashLog("Setting texture for a UICursor... \n");
		TextureData cTex = GetTex(sName);
		if(cTex == null)
	       cTex = AddTex(sName);
		m_cCursorPoint.SetTexture(cTex.m_nNo, new Rect(0, 0, 1, 1));
        //CrashLog("... Done\n");
		m_cCurrTex = cTex;
	}
	
	/** zdejmuje aktualna teksture */
	void ClearTexture()
	{
		if(m_cCursorPoint!=null)
	        m_cCursorPoint.SetNoTexture();
		m_cCurrTex = null;
	}
	
	/** zwraca nazwe ustawione tekstury */
	String GetTextureName()
	{
		if (m_cCurrTex != null)
	       return m_cCurrTex.m_sName;
		else
			return null;
	}
    
    /** nalezy wolac ta funkcje przy zmianie rozdzielczosci ekranu */
    void OnChangeResolution()
    {
        l_vTemp.Set(GetScreenWidth(), GetScreenHeight(), 0);
        SetSize(l_vTemp);
    }
	
	void OnMouseMove(float fMouseX, float fMouseY, int iButtonsFlags)
	{
        
		if (m_cCursorPoint != null)
		{
            l_vTemp.Set(fMouseX, fMouseY, 0f);
		    m_cCursorPoint.SetPos(l_vTemp);
		}
		else
			LogLine("Sprajt dla kursora jest null: nie moge go przesunac wiec ");
	}
	
	public void Hide()
	{
	  if (m_cCursorPoint != null) 	
		  m_cCursorPoint.Hide();	
	}
	
	public void Show()
	{
	  if (m_cCursorPoint != null) 			
		  m_cCursorPoint.Show();	
	}
    
    public void MoveTop()
    {
        super.MoveTop();
        if (toolTip != null)
           toolTip.MoveTop();
        if (m_cCursorPoint != null)
           m_cCursorPoint.MoveTop();
    }
    
    /**Wyswietla tooltip. 
     * @param sText wyswietlany tekst
     * @see Window#SetToolTip(String sText)*/
    void DisplayToolTip(String sText)
    {
        float fScreenWidth = 0f;
        float fScreenHeight = 0f;
        if (sText.length() > 0)
        {
            Vector vCursorPos = m_cCursorPoint.GetPos();
            Vector vToolTipPos = new Vector(vCursorPos.fX + vCursorSize.fX, vCursorPos.fY + vCursorSize.fY,0);
            fScreenWidth = GetScreenWidth();
            fScreenHeight = GetScreenHeight();
            Vector vTextSize = toolTip.GetTextExtent(sText);
            vTextSize.fX += 2f * fToolTipMargin;
            vTextSize.fY += 2f * fToolTipMargin;
            toolTip.SetSize(vTextSize);
            if ((vToolTipPos.fY + vTextSize.fY) > fScreenHeight)
            {
                vToolTipPos.fY -= vCursorSize.fY;
            }
            if ((vToolTipPos.fX + vTextSize.fX) > fScreenWidth)
            {
                vToolTipPos.fX = fScreenWidth - vTextSize.fX;
            }
            toolTip.SetPos(vToolTipPos);
            
            toolTip.DisplayText(sText);
            toolTip.Show();        
                
        }
        else
            toolTip.Hide();
    }
    
    public void SetPos(Vector vPos)
    {
        SetCursorPos(vPos);
        if (m_cCursorPoint != null)
            m_cCursorPoint.SetPos(vPos);
    }

	public Vector GetPos()	
	{
       return m_cCursorPoint.GetPos();
	}
    
    void Destroy()
    {
        if (GetModule() != null)
        {
            if (toolTip != null)
            {
                GetModule().RemoveSprite(toolTip);
                toolTip.delete();
                toolTip = null;
            }
            if (m_cCursorPoint != null)
            {
				ReleaseTextures();
                if(m_cCursorPoint!=null) GetModule().RemoveSprite(m_cCursorPoint);
                GetModule().RemoveSprite(this);
                
                //Co za durny komentarz!
                m_cCursorPoint.delete();  //TODO odremowac gdzy usuwanie sprajtow bedzie naprawione
                m_cCursorPoint = null;
            }
        }
    }
	
	void ReleaseTextures()
	{
	  while(m_vTextures.size() > 0)
	  {
		  TextureData cTex = (TextureData) (m_vTextures.elementAt(0)); 
		  if(cTex.m_nNo != 0)
		     ReleaseTexture(cTex.m_nNo);
          cTex.m_nNo = 0;
		  m_vTextures.removeElement(cTex);
	  }
	}
    
    void OnDestroy()
    {
        Destroy();
    }
    
    void Logtofile()
    {
        CrashLog("Cursor " + this + "\n" +
                 "m_cCursorPoint " + m_cCursorPoint + "\n" +
                 " " + "\n" +
                 "" + "\n" +
                 "" + "\n" +
                 "" + "\n" +
                 "" + "\n" +
                 "" + "\n" +
                 "" + "\n");
    }
}
