public class UIEdit extends UIButton
{  
	// znaczniki wcisniecia klawiszy specjalnych	
	boolean m_bLCtrl = false;
	boolean m_bRCtrl = false;
	boolean m_bLAlt = false;
	boolean m_bRAlt = false;
	boolean m_bLShift = false;
	boolean m_bRShift = false;

    /**Margines dla maksymalnego tekstu (z lewej i prawej)*/
    float m_fMargin = 5f;
	String m_sEditText = new String();
	String m_sOldText = "NO_DEFINED";
	String m_sCursorSign = "_";
    /**niedozwolone znaki*/
    String m_sForbiddenChars = "";
	
	/**dozwolone znaki, jesli null, to dozwolone wszystkie oprocz m_sForbiddenChars*/
	String m_sAllowedChars = null;
	
    Sprite m_cCursorSprite = null;
	float m_fCursorBlinkPeriod = 0.5f;
	//	boolean m_bEditState = false;
    /** maksymalna liczba wprowadzonych znakow */
    int m_nMaxChar = -1;
    
    int m_nCountChar = 0;
	
	boolean m_bBackSpacePressed = false;
	
    /**zmienna mowiaca, czy klikniecie poza oknem w trakcie edycji oznacza potwierdzenie
     * (true) czy rezygnacje (false).
     */
    boolean m_bMouseBtnOutAsEnter = true;
    
	void OnCreate()
	{
        if (m_sText == null)
            m_sText = "";   
		m_sOldText = m_sText;
		m_sEditText = m_sText;		
		m_bMouseLeaveDestroyFocus = false;
		super.OnCreate();
	}
	
    public void SetTextPosFlags(int nFlags)
    {
        super.SetTextPosFlags(nFlags);
        if (m_cCursorSprite == null)
            InitCursorSprite();
        m_cCursorSprite.SetTextPosFlags(nFlags);
    }
    
    public boolean SetFont(String sFont)
    {
        boolean bRet = super.SetFont(sFont);
        if (m_cCursorSprite == null)
            InitCursorSprite();
        m_cCursorSprite.SetFont(sFont);
        m_cCursorSprite.DisplayTextFitSize(m_sCursorSign);
        return bRet;
    }
    
    public void SetFontScale(float fScale)
    {
        super.SetFontScale(fScale);
        if (m_cCursorSprite == null)
            InitCursorSprite();
        m_cCursorSprite.SetFontScale(fScale);
        m_cCursorSprite.DisplayTextFitSize(m_sCursorSign);
    }
    
    public void OnInit()
    {
        super.OnInit();
        InitCursorSprite();
    }
    
    void InitCursorSprite()
    {
        if (m_cCursorSprite != null)
            return;
        m_cCursorSprite = (Sprite)CreateObject("Sprite");
        AddChild(m_cCursorSprite);
        m_cCursorSprite.SetSize(new Vector(20,20,0));
        m_cCursorSprite.Hide();
        m_cCursorSprite.SetFont(Fonts.GetDefaultFont());
    }
    
	boolean Load(ParseKeyword key)
	{
		ParseKeyword  paramKey;	  
		for(paramKey=key.GetChild(); paramKey!=null; paramKey=paramKey.GetNext())
		{
			if(paramKey.Equals("TextureEdit"))	// jak zaznaczona
			{
				m_cCheckedTex = new UITexture(this);
				m_cCheckedTex.m_sFileName = paramKey.GetSParam(0);
				m_cCheckedTex.m_rRect = null;
				LoadTexture(m_cCheckedTex);			
			}
			if(paramKey.Equals("TextEditColor"))	//jak zaznaczona
			{
				float r,g,b;
				r = paramKey.GetFParam(0);
				g = paramKey.GetFParam(1);
				b = paramKey.GetFParam(2);
				m_vCheckedTxtColor = new Vector(r,g,b);		  			 			 
			}
		}
		super.Load(key);
		return true;
		
	}
    
	void SetCheck(boolean bCheck)
	{
        //CrashLog("SetCheck " + bCheck);
		if(!m_bActive)
			return;			
		if(!m_bChecked && bCheck)
		{
			m_bChecked=true;
            m_sOldText = new String(m_sEditText);
            //CrashLog("UIEdit capturing mouse");
            CaptureMouse();
			RegisterKeyRequestExclusive();
            
		}
		if(m_bChecked && !bCheck) 
		{
			m_bChecked=false;
			ClearKeys();
            //CrashLog("UIEdit clearing capture mouse");
            ClearCaptureMouse();
			UnregisterKeyRequestExclusive();
		}		
        OnTextureChange();
        UpdateText();
	}

	
	void SetFocus(boolean bActive)
	{
		if(!m_bActive)
			return;			
		if(!m_bFocus && bActive)
		{
			ProcessKb(true);
            
			//		   LogLine("Wlaczam KLAWIATURE EDIT ");		   					  
		}
		if(m_bFocus && !bActive)
		{
			ProcessKb(false);
			//		   LogLine("Wylaczam KLAWIATURE EDIT ");		   			
			SetCheck(false);
		}
		super.SetFocus(bActive);
	}
	
	void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
        if (bKeyState)
			OnKeyPressed(nKeyCode, nKeyAscii);
        else
			OnKeyReleased(nKeyCode, nKeyAscii);
	}
	
    public void SetText(String sNewText)
    {
        m_sOldText = new String (m_sEditText);
        m_sEditText = new String (sNewText);
        super.SetText(m_sEditText);
    }
    
    public void ClearTexts()
    {
        m_sOldText = "";
        m_sEditText = "";
        SetText("");
    }
    
	void UpdateText()
	{
		if(!m_bActive)
			return;			
        super.SetText(m_sEditText);			
		if(m_bChecked)
        {
            ShowTextCursor(true);
            UpdateTextCursorPos();
        }
        else
        {
            ShowTextCursor(false);
        }
        m_nCountChar = m_sEditText.length();
	}
    
    void SetMaxChar(int nCount)
    {
        m_nMaxChar = nCount;
    }
    
    void ShowTextCursor(boolean bShow)
    {
        DisableCallMethod("BlinkCursor");
        if (bShow)
        {
            m_cCursorSprite.Show();
            CallMethodEvery("BlinkCursor", m_fCursorBlinkPeriod);
        }
        else
        {
            m_cCursorSprite.Hide();
        }
    }
    
    void UpdateTextCursorPos()
    {
        if (!m_bInited)
            return;
        
        Vector vCursorPos = new Vector();
        if (m_sEditText.length() != 0)
        {
            vCursorPos = GetTextExtent(m_sEditText);
            vCursorPos.fY = 0;
            vCursorPos.Add(GetTextPos());
            
        }
        else
        {
            Vector vLetterSize = GetTextExtent("N");
            //TODO przetestowac
            if ((m_nTextPosFlags & ESpriteText.HORIZ_LEFT) == ESpriteText.HORIZ_LEFT)
            {
                vCursorPos.fX = 0;
            }
            if ((m_nTextPosFlags & ESpriteText.HORIZ_MIDDLE) == ESpriteText.HORIZ_MIDDLE)
            {
                vCursorPos.fX = GetSize().fX/2f;
            }
            if ((m_nTextPosFlags & ESpriteText.HORIZ_RIGHT) == ESpriteText.HORIZ_RIGHT)
            {
                vCursorPos.fX = GetSize().fX;
            }
            if ((m_nTextPosFlags & ESpriteText.VERT_TOP) == ESpriteText.VERT_TOP)
            {
                vCursorPos.fY = 0;
            }
            if ((m_nTextPosFlags & ESpriteText.VERT_MIDDLE) == ESpriteText.VERT_MIDDLE)
            {
                vCursorPos.fY = GetSize().fY/2f - vLetterSize.fY/2f;
            }
            if ((m_nTextPosFlags & ESpriteText.VERT_BOTTOM) == ESpriteText.VERT_BOTTOM)
            {
                vCursorPos.fY = GetSize().fY - vLetterSize.fY;
            }
        }
        m_cCursorSprite.SetRelativePos(vCursorPos);
    }
    
    void BlinkCursor()
    {
        if (m_cCursorSprite.IsVisible())
        {
            m_cCursorSprite.Hide();
        }
        else
        {
            m_cCursorSprite.Show();
        }
    }
    
	void ClearKeys()
	{
		m_bLCtrl = false;
		m_bRCtrl = false;
		m_bLAlt = false;
		m_bRAlt = false;
		m_bLShift = false;
		m_bRShift = false;
	}
	
	/**Sprawdza, czy tekst miesci sie na szerokosc w edicie
	 */
	boolean CheckExtent(String sText)
	{
		String sTmpTest = new String(sText);
		Vector vText = GetTextExtent(sTmpTest);
		if (vText.fX + 2f * m_fMargin >= GetSize().fX ) 
			return false;
		else
			return true;
	}

    
	public class Idle extends State 
	{
		public void OnEnter()
		{
		}
		
		void OnLBDown(float fMouseX, float fMouseY)
		{
			
		}
		void OnLBUp(float fMouseX, float fMouseY)
		{
            if(!m_bActive)
				return;			   
			if(!m_bActive)
				return;			   
			if(!m_bFocus)
				SetFocus(true);
            if (!CanProcessMouse())
                return;
            SetCheck(true);		   			
			
		}
	}
    

    void OnLBUpOut(float fMouseX, float fMouseY)
	{
        //CrashLog("OnLBUpOut");
		if(!m_bActive)
			return;	
        if (m_bChecked)
        {
            if(m_bMouseBtnOutAsEnter)
                OnKeyEnter();
		    else
                OnKeyEscape();
        }
	}
    
	void OnKeyBackspace()
	{  
		
		if(!m_bActive)
			return;			
		int nLen = m_sEditText.length();
		if (nLen > 0)
		{
			String sNewText = m_sEditText.substring(0, nLen - 1);
			m_sEditText = sNewText;
			UpdateText();
		}
		m_bBackSpacePressed = true;
		CallMethodIn("OnKeyBackspace",0.2f);
	}
	
	void OnKeyEnter()
	{
		if(!m_bActive)
			return;			
		Command(this, EUIConst.CM_EDIT_ENTER);
		SetFocus(false);
        SetCheck(false);
	}
	
	void OnKeyEscape()
	{
		if(!m_bActive)
			return;			
		Command(this, EUIConst.CM_EDIT_ESC);
		m_sEditText = m_sOldText;
        UpdateText();
		SetFocus(false);
        SetCheck(false);
	}
    
	void CheckBackSpace()
	{
		if(m_bBackSpacePressed)
		{
			DisableCallMethod("OnKeyBackspace");
			m_bBackSpacePressed = false;
		}
	}
		
	
	void OnKeyPressed(int nKey, char nAsci)
	{
		if(!m_bActive || !m_bChecked)
			return;			
		//		LogLine("Wcisnieto klawissz EDIT !!");
		CheckBackSpace();
		char ch=' ';
		String sChar="";
		switch(nKey)
		{
		case EKey._LCONTROL :
			m_bLCtrl = true;
			break;
		case EKey._RCONTROL :
			m_bRCtrl = true;
			break;
		case EKey._LSHIFT :
			m_bLShift = true;
			break;
		case EKey._RSHIFT :
			m_bRShift = true;
			break;
		case EKey._LMENU :
			m_bLAlt = true;
			break;
		case EKey._RMENU :
			m_bRAlt = true;
			break;
        case EKey._BACK:
            OnKeyBackspace();
            break;
		case EKey._RETURN:
        case EKey._NUMPADENTER:
			if(m_bChecked)
				CallMethodIn("OnKeyEnter",0);
			/*else
				SetCheck(true);*/
			break;
        case EKey._ESCAPE:
			if(m_bChecked)
				OnKeyEscape();
			break;            
        case EKey._TAB:
            //tab tylko przeszkadza
            break;
		default: if(m_bChecked)
				 {
                     boolean bNumPad = true;
                     //obsluga cyfr klawiatury numerycznej
                     //todo uwzglednienie numlocka
                     switch(nKey)
                     {
                     case EKey._NUMPAD0:
                         nAsci = '0';
                         break;
                     case EKey._NUMPAD1:
                         nAsci = '1';
                         break;
                     case EKey._NUMPAD2:
                         nAsci = '2';
                         break;
                     case EKey._NUMPAD3:
                         nAsci = '3';
                         break;
                     case EKey._NUMPAD4:
                         nAsci = '4';
                         break;
                     case EKey._NUMPAD5:
                         nAsci = '5';
                         break;
                     case EKey._NUMPAD6:
                         nAsci = '6';
                         break;
                     case EKey._NUMPAD7:
                         nAsci = '7';
                         break;
                     case EKey._NUMPAD8:
                         nAsci = '8';
                         break;
                     case EKey._NUMPAD9:
                         nAsci = '9';
                         break;
                     case EKey._DECIMAL:
                         nAsci = '.';
                         break;
                     case EKey._DIVIDE:
                         nAsci = '/';
                         break;
                         
                     default:
                         bNumPad = false;
                     }
                     
                     if(m_nCountChar >= m_nMaxChar && m_nMaxChar != -1)
                         return;
                     
                     if ((int)nAsci == 0)
                         return;
                     
                     if(bNumPad)
                        ch = (char)nAsci;
                     else
					    ch = GetKeyAscii(nKey);//(char)nAsci;
                     
					 sChar += ch;

                     //LogR(m_sEditText + " + nAsci " + nAsci + " sChar " + sChar);
                     
 					 if (!m_bLAlt && !m_bRCtrl && !m_bLCtrl && !m_bRAlt)
					 {
						 /*if (m_bLShift || m_bRShift)
							 sChar = TextToUpperCase(sChar);
						 else 
							 sChar = TextToLowerCase(sChar);*/
                         
						 //LogR("upper/lower " + sChar);
						 
						 if (m_sAllowedChars != null)
						 {
							 if (m_sAllowedChars.indexOf(sChar) == -1)
								 return;
						 }
						 else
						 {
							if (m_sForbiddenChars.indexOf(sChar) != -1)
								 return;
						 }
                         
						 if (CheckExtent(m_sEditText + ch + m_sCursorSign))
                         {
							 m_sEditText += sChar;
                         }
					 }	
                     
				 }
		}
        UpdateText();
	}	
    
        
	void OnKeyReleased(int nKey, char nAsci)
	{
		if(!m_bActive || !m_bChecked)
			return;	
		CheckBackSpace();
		switch(nKey)
		{
		case EKey._LCONTROL :
			m_bLCtrl = false;
			break;
		case EKey._RCONTROL :
			m_bRCtrl = false;
			break;
		case EKey._LSHIFT :
			m_bLShift = false;
			break;
		case EKey._RSHIFT :
			m_bRShift = false;
			break;
		case EKey._LMENU :
			m_bLAlt = false;
			break;
		case EKey._RMENU :
			m_bRAlt = false;
			break;
		                              
		}
		//        sText = sText.toLowerCase();
		
	}	
    
    void OnDestroy()
    {
        super.OnDestroy();
        if (m_cCursorSprite != null)
        {
            RemoveSprite(m_cCursorSprite);
            m_cCursorSprite.delete();
            m_cCursorSprite = null;
        }
    }
}
