public class UIMenu extends UIControlObject
{

	void OnCreate()
	{
		super.OnCreate();
	}

	boolean Load(ParseKeyword wndKey)
	{
		//LogLine("Menu---------------------------------------");
		ParseKeyword  paramKey;
		for(paramKey=wndKey.GetChild(); paramKey!=null; paramKey=paramKey.GetNext())
		{
			if(paramKey.Equals("MenuButton"))
			{
				//LogLine("Menu button ------------");
				LoadOption(paramKey);
			}
		}
		super.Load(wndKey);
		return true;
	}
	/** wczytuje opcje, tworzone na podstawie wzorcow    */
	UIMenuButton LoadOption(ParseKeyword key)
	{
		//		LogLine("Bede ladowal menuButton");
		UIMenuButton btn;
        String sClassName = key.GetSParam(0);
	    btn = (UIMenuButton)CreateUIObject(sClassName); 
		btn.m_sClassName = sClassName;
		
		btn.m_sId = key.GetSParam(1);
		btn.m_sText = key.GetSParam(2);
		btn.m_sDefType = key.GetSParam(4);
		//LogLine("Przydzielilem paramsy");
		
		btn.m_cSupervisor = this;

		//LogLine("Button prams: "+btn.m_sId+" "+btn.m_sText+" "+btn.m_sRole
				//+" "+btn.m_sDefType);
		
		// Jesli wzorzec standardowego buttona (informacja w m_sId)
		if(btn.m_sId.equals(EUIConst.sMENUBUTTON) ||
           btn.m_sDefType.equals(EUIConst.strPATTERN))
		{
			if(btn.m_sDefType.equals(EUIConst.strREGULAR))
			{
				UIButton cPattBtn = (UIButton)m_cSupervisor.GetPattern(EUIConst.sMENUBUTTON); 
				if(cPattBtn!=null)
				{
					cPattBtn.Copy((UIButton)btn, cPattBtn);			
					btn.Load(key);
					this.AddPattern(btn);
				}
			}
			if(btn.m_sDefType.equals(EUIConst.strSPECIFIC) ||
               btn.m_sDefType.equals(EUIConst.strPATTERN))		   
			{
				if(btn.Load(key))
					this.AddPattern(btn);
			}
		}
		else
		{
            //LogLine("Przycisk Standardowy "+ btn.m_sId);
            // jesli to przycisk normalny, ktorypobiera wzorzec
            if(btn.m_sDefType.startsWith(EUIConst.strREGULAR))
            {
                btn.m_sPatternName = ParsePatternName(btn);
                UIButton cPattBtn = (UIMenuButton)this.GetPattern(btn.m_sPatternName);					 
                if(cPattBtn==null)
                    cPattBtn = (UIButton)this.GetPattern(EUIConst.sBUTTON);					 
                if(cPattBtn!=null)
                {
                    cPattBtn.Copy(btn,cPattBtn);
                    btn.Load(key);
                    AddChild(btn);
                }
                else
                {
                    CrashLog("ERROR " + this + " couldn't find pattern " + btn.m_sPatternName);
                }
                
            }
            // jesli to przycisk normalny , definiowany indyvidualnie 
            if(btn.m_sDefType.equals(EUIConst.strSPECIFIC))
            {
                //LogLine("Przycisk individualny "+ btn.m_sId);
                if(btn.Load(key))
                {
                    AddChild(btn);
                }
            }
		}
		return btn;
	}
	
	
	boolean CanFocus(UIWindow wnd)
	{
		if(!m_bActive)
			return false;	 
		if(wnd instanceof UIMenuButton)
		{
			if(((UIMenuButton)wnd).m_bCanFocus &&
               wnd.m_bActive &&
               wnd.IsActuallyVisible())
			{
                if( ((UIButton)wnd).m_bDisabled )
                    return false;
                else
    				return true;	    
			}
		}
		return false;
	}
	
	void OnUICommand(UIWindow cSender, int nCommand)
	{
		if(!m_bActive)
			return;		  
		super.OnUICommand(cSender,nCommand);		
		if(nCommand == EUIConst.CM_CLICK)
			if(m_cCurrMember!=null)
				Command(m_cCurrMember, EUIConst.CM_SEL);
		if(nCommand == EUIConst.CM_DBCLICK)
			if(m_cCurrMember!=null)
				Command(m_cCurrMember, EUIConst.CM_SEL_DBCLICK);
		if(nCommand == EUIConst.CM_RETURN)
			Command(cSender, EUIConst.CM_SEL);
	}
	
	
	
	
}
