/**W progress barze tekstura tla to tekstura okna, a tekstura postepu to tekstura focusowa*/
public class UIProgressBar extends UIControlObject
{
    //TODO poprawic dyskretny, bo nie dziala
    final static int _TYPE_DISCRETE = 0, 
        
                     _TYPE_CONTINUOUS = 1;
    
    /**Wektor elementow progressa, jesli progress ciagly to 
     * zawiera tylko jeden element*/
    java.util.Vector vProgress = new java.util.Vector();
    /**Rodzaj progressu, mozliwosci: ciagly lub dyskretny {@link EButtonFlags}*/
    int m_nProgressType;
    /**Ilosc pozycji progressa, 0 to pierwsza*/
    int m_nRange = 0;
    /**Odstep pomiedzy kropami dyskretnego progressa*/
    int m_nSeparator = 1;
    /**Szerokosc kropy dyskretnego progressa*/
    float m_fDiscreteWidth;
    /**Aktualna pozycja progressa*/
    int m_nCurPos = 0;
    
    //===================OBSLUGA PARSERA
	boolean Load(ParseKeyword key)
	{
        super.Load(key);	
        //TODO ladowac parametry z parsera i je ustawiac
        //Init(_TYPE_CONTINUOUS, 100);
		return true;
	}
    
    /**Ustala dane progress bara.*/
    void Init(int nProgressType, int nRange)
    {
        m_bCanFocus = false;
        if (m_cFocusTexture == null)
            return;
        if (m_cFocusTexture.m_rRect == null)
            m_cFocusTexture.m_rRect = new Rect(0,0,1,1);
        
        m_nProgressType = nProgressType;
        SetRange(nRange);
    }
    /**Ustawia zakres progressa od 0 do nNewRange. Na jego podstawie wyliczana jest szerokosc
     * kropy progressa dyskretnego
     */
    void SetRange(int nNewRange)
    {
        if (vProgress.size() != nNewRange)
        {
            if (m_nProgressType == _TYPE_CONTINUOUS)
            {//progress ciagly
                if (vProgress.size() == 0)
                {
                    Window progress = (Window)CreateObject("Window");
                    AddChild(progress);
                    progress.SetSize(new Vector(100, 100,0));
                    if (m_vFrameCornerSize != null && m_vFrameCornerSize.Len() > 0)
                    {
                        if (!progress.SetFrameTexture(m_cFocusTexture.m_nId, m_cFocusTexture.GetLogicRect(), (int)m_vFrameCornerSize.fX, (int)m_vFrameCornerSize.fY) && !m_bReloadingTexture)
                        {
                            CrashLog("SetTexture: false " + m_cFocusTexture.m_nId);
                            m_bReloadingTexture = true;
                            LoadTexture(m_cFocusTexture);
                            SetRange(nNewRange);
                            return;
                        }
                    }
                    else
                    {
                        if (!progress.SetTexture(m_cFocusTexture.m_nId, m_cFocusTexture.GetLogicRect()) && !m_bReloadingTexture)
                        {
                            
                            CrashLog("SetTexture: false " + m_cFocusTexture.m_nId);
                            
                            m_bReloadingTexture = true;
                            LoadTexture(m_cFocusTexture);
                            
                            CrashLog("  po przeladowaniu " + m_cFocusTexture.m_nId);
                            
                            SetRange(nNewRange);
                            return;
                        }
                    }
                    progress.SetRelativePos(new Vector());
                    progress.Show();
                    progress.ProcessMouse(false);
                    vProgress.addElement((Object)progress);
                }
            }
            else
            {
                int i, nPrgCount = vProgress.size();
                Window progress;
                Vector size = GetSize();
                if (size.Len() == 0)
                {
                    OnSizeAndPos();
                    size = GetSize();
                }
                
                //wyliczam szerokosc kropy
                m_fDiscreteWidth = (size.fX - (nNewRange - 1)*m_nSeparator)/ nNewRange;//((float)size.fX * (float)nNewRange - ((float)nNewRange - 1f)*(float)m_nSeparator)/(float)nNewRange;
                Vector pos = new Vector();
                for (i = 0; i < nPrgCount; i++)
                {
                    ((Window)vProgress.elementAt(i)).Hide();
                }
                
                for (i = nPrgCount; i < nNewRange; i++)
                {
                    progress = (Window)CreateObject("Window");
                    AddChild(progress);

                    if (!progress.SetTexture(m_cFocusTexture.m_nId, m_cFocusTexture.GetLogicRect()) && !m_bReloadingTexture)
                    {
                        CrashLog("SetTexture: false " + m_cFocusTexture.m_nId);
                        
                        m_bReloadingTexture = true;
                        LoadTexture(m_cFocusTexture);
                        
                        CrashLog("  po przeladowaniu " + m_cFocusTexture.m_nId);
                        
                        SetRange(nNewRange);
                        return;
                    }
                    progress.Hide();
                    progress.ProcessMouse(false);
                    vProgress.addElement((Object)progress);
                    
                }
                
                for (i = 0; i < nNewRange; i++)
                {
                    progress = (Window)vProgress.elementAt(i);
                    progress.SetSize(new Vector(m_fDiscreteWidth, size.fY, 0));
                    progress.SetRelativePos(pos);
                    pos.fX = pos.fX + m_fDiscreteWidth + m_nSeparator;
                }

            }
        }
        m_nRange = nNewRange;
        UpdateProgress();
    }
    
    /**Ustala pozycje na progresie, jesli pozycja nie wychodzi poza zakres, to ustawiana na
     * koniec, a jesli mniejsza od 0 to ustawiana na 0.
     * @param nNewPos nowa pozycja na progresie
     */
    void SetProgressPos(int nNewPos)
    {
        if (nNewPos == m_nCurPos) return;
        if (nNewPos > m_nRange) nNewPos = m_nRange;
        if (nNewPos < 0) nNewPos = 0;
        m_nCurPos = nNewPos;
        UpdateProgress();
    }

    String RectToString(Rect rect)
    {
        return new String("(l:" + rect.fLeft + " t: " + rect.fTop + " r: " + rect.fRight + " b: " + rect.fBottom + ")");
    }
    
    void UpdateProgress()
    {
        Window progress = null;
        if (m_nProgressType == _TYPE_CONTINUOUS)
        {
            Vector size = GetSize();
            float fTexUnitWidth = ((m_cFocusTexture.m_rRect.fRight - m_cFocusTexture.m_rRect.fLeft)/m_cFocusTexture.m_fWidth)/(float)m_nRange;
            float fUnitWidth = size.fX / (float)m_nRange;
            progress = (Window)vProgress.elementAt(0);
            if (progress != null)
            {
                if (m_vFrameCornerSize == null)
                {
                    Rect rect = new Rect(m_cFocusTexture.m_rRect.fLeft/m_cFocusTexture.m_fWidth, 
                                         m_cFocusTexture.m_rRect.fTop/m_cFocusTexture.m_fHeight,
                                         m_cFocusTexture.m_rRect.fLeft/m_cFocusTexture.m_fWidth + (float)m_nCurPos * fTexUnitWidth,
                                         m_cFocusTexture.m_rRect.fBottom/m_cFocusTexture.m_fHeight);
                    progress.SetTextureCoords(rect);
                }
                progress.SetSize(new Vector(fUnitWidth * (float)m_nCurPos, size.fY, 0));
                progress.Show();
                //progress.MoveTop();
            }
        }
        else
        {
            for (int i = 0; i < m_nRange; i++)
            {
                progress = (Window)vProgress.elementAt(i);
                if (progress != null)
                {
                    if (i < m_nCurPos) progress.Show();
                    else progress.Hide();
                }
            }
        }
    }
    
    public void OnDestroy()
    {
		for (int i = 0; i < vProgress.size(); i++)
		{
			Window progress = (Window)vProgress.elementAt(i);
			if (progress != null)
			{
				progress.DetachFromParent();
				progress.delete();
				progress = null;
			}
		}

		vProgress.removeAllElements();
        super.OnDestroy();
    }
    
    
}                        

