class UIStatic extends UIWindow
{
	String m_sText = null;
    String m_sLocalizedText = null;
    /**Aktualny kolor tekstu*/
    Vector m_vCurTextColor = null;
    /**Kolor tekstu wczytany ze skryptu*/
	Vector m_vTextColor = null;

    // alpha dla textu
    float m_fTextAlpha = 1f;
    
    // aktualna alpha tekstu
    float m_fCurTextAlpha = 1;
   
	/** identyfikator fontu */
	String m_sFontId = null;	
    
    /**Skala fontu*/
    float m_fFontScale = 1;

	/**Flagi pozycjonowania tekstu, domyslnie centrowany na srodku w pionie i poziomie*/
    int m_nTextPosFlags = ESpriteText.VERT_MIDDLE|ESpriteText.HORIZ_MIDDLE;
    
    /** latajacy tekst    */
    UIFlyText m_cFlyText = null; 
    
    boolean m_bFitTextSize = false;
    Vector m_vFitTextSizeMargin = new Vector();
    
	void OnCreate()
	{
       m_vCurTextColor = new Vector(1,1,1);
	   m_vTextColor = new Vector(1,1,1);  //czarny
	   super.OnCreate();
	}
	
    public void SetTextColor(float fR, float fG, float fB)
    {
        m_vCurTextColor.fX = fR;
        m_vCurTextColor.fY = fG;
        m_vCurTextColor.fZ = fB;
        DisplayText();
    }
    
    public void SetFontScale(float fScale)
    {
        m_fFontScale = fScale;
        super.SetFontScale(fScale);
    }
    
    //  ustawienie  aktualnej alphy 
    void SetTextAlpha(float fA)
    {
        m_fCurTextAlpha = fA;    
        DisplayText();
    }
    //Ustawianie alphy dla standrdowego tekstu
    void SetAlphaForText(float fA)
    {
        m_fTextAlpha = fA;     
    }
    
    float GetAlphaForText()
    {
        return m_fTextAlpha;     
    }    
    
    public void SetTextPosFlags(int nFlags)
    {
        m_nTextPosFlags = nFlags;
        DisplayText();
    }
    
    /** odswiezanie statica     */	
	public void OnFrame()
	{
		if( !m_bInited)
			return;		
		
        super.OnFrame();
        
	}
    
	public void Reload()
	{
	    super.Reload();
		SetFont(m_sFontId );
        SetFontScale(m_fFontScale);
        SetTextPosFlags(m_nTextPosFlags);
        SetTextColor(m_vCurTextColor.fX, m_vCurTextColor.fY, m_vCurTextColor.fZ, m_fCurTextAlpha);
        DisplayText();
	}
	public void OnInit()
	{
		super.OnInit();
        if (m_sFontId == null)
        {
            m_sFontId = Fonts.GetDefaultFont();
            SetFont(m_sFontId);	 
        }
    }
	
	//===================OBSLUGA PARSERA
	boolean Load(ParseKeyword key)
	{
		ParseKeyword  paramKey;
		for(paramKey=key.GetChild(); paramKey!=null; paramKey=paramKey.GetNext())
		{
		  if(paramKey.Equals("Text"))
		  {
 			  m_sText = paramKey.GetSParam(0);
              SetText(m_sText);
		  }
          if(paramKey.Equals("TextAlpha"))
		  {
              SetAlphaForText(paramKey.GetFParam(0));
			  SetTextAlpha(paramKey.GetFParam(0));
          }
                  
 	      if(paramKey.Equals("TextColor"))	
	      {
     		  float r,g,b;
		      r = paramKey.GetFParam(0);
		      g = paramKey.GetFParam(1);
		      b = paramKey.GetFParam(2);
 	          m_vTextColor = new Vector(r,g,b);		  
	          SetTextColor(m_vTextColor.fX,m_vTextColor.fY,m_vTextColor.fZ, m_fTextAlpha);				  
	      }
          
          if (paramKey.Equals("FitTextSizeWithMargin"))
          {
              m_bFitTextSize = true;
              m_vFitTextSizeMargin = new Vector(paramKey.GetFParam(0), paramKey.GetFParam(1), 0);
          }
          
 	      if(paramKey.Equals("Font"))	
	      {
		      m_sFontId = paramKey.GetSParam(0);
              SetFont(m_sFontId);
              SetFontScale(m_fFontScale);
	      }			
          if (paramKey.Equals("FontScale"))
          {
              m_fFontScale = paramKey.GetFParam(0);
              SetFontScale(m_fFontScale);
          }
		  if(paramKey.Equals("TextPosFlags"))
          {
              m_nTextPosFlags = paramKey.GetIParam(0);
              SetTextPosFlags(m_nTextPosFlags);
          }
        
		}
        super.Load(key);	
        
		return true;
	}

	void SetText(String sText)
	{
        m_sText = sText;
        
        if (sText != null)
        {
            if (sText.startsWith("&&"))
            {
                String sTemp = new String(sText);
                sTemp = sText.substring(1, sText.length() - 1);
                m_sLocalizedText = Text.Get(sTemp);
            }
            else
            {
                m_sLocalizedText = Text.Get(sText);    
            }
        }      
        else
        {
            m_sLocalizedText = null;
        }
        DisplayText();
	}
	
	String GetText()
	{
       return m_sText;
    }
	
    
    /**Wyswietla tekst zapamietany w zmiennej m_sText, jesli tekst ten wyglada &&tekst&&, to 
     * pobierany jest z ze skryptu ( Text.Get("&tekst&")), ustala tez wszystkie atrybuty fontu, 
     * te ktore sa zapisane w zmiennych
     * return wynik metody SetFont(m_sFontId), lub false w przypadku innych nieprawidlowosci;
     */
	void DisplayText()
	{
        if(!m_bActive || !m_bInited)
            return ;		
        if (m_sFontId == null)
            return ;
        boolean bRet = false;        
        if(m_sText != null && m_sLocalizedText != null)	
        {
            bRet = super.SetFont(m_sFontId );
            super.SetFontScale(m_fFontScale);
            super.SetTextPosFlags(m_nTextPosFlags);
            super.SetTextColor(m_vCurTextColor.fX, m_vCurTextColor.fY, m_vCurTextColor.fZ, m_fCurTextAlpha);
          
            
            
            DisplayText(m_sLocalizedText);
            
            if (m_bFitTextSize)
            {
                Vector vTextSize = GetTextExtent(m_sLocalizedText);
                vTextSize.fX += 2f * m_vFitTextSizeMargin.fX;
                vTextSize.fY += 2f * m_vFitTextSizeMargin.fY;
                
                Vector RealPos = GetPos();
                Vector RealSize = GetSize();
                if (RealSize.IsEqual(vTextSize))
                    return ;
                if ((m_nTextPosFlags & ESpriteText.HORIZ_MIDDLE) == ESpriteText.HORIZ_MIDDLE)
                {
                    RealPos.fX += (RealSize.fX - vTextSize.fX) * 0.5f;
                }
                else
                    if ((m_nTextPosFlags & ESpriteText.HORIZ_RIGHT) == ESpriteText.HORIZ_RIGHT)
                    {
                        Vector vTopRight = new Vector(RealPos.Add2(RealSize).fX, RealPos.fY, 0);
                        RealPos.fX = vTopRight.fX - vTextSize.fX;
                    }
                
                if ((m_nTextPosFlags & ESpriteText.VERT_MIDDLE) == ESpriteText.VERT_MIDDLE)
                {
                    RealPos.fY += (RealSize.fY - vTextSize.fY) * 0.5f;
                }
                else
                    if ((m_nTextPosFlags & ESpriteText.VERT_BOTTOM) == ESpriteText.VERT_BOTTOM)
                    {
                        Vector vBottomRight = new Vector(RealPos.fX, RealPos.Add2(RealSize).fY, 0);
                        RealPos.fY = vBottomRight.fY - vTextSize.fY;
                    }
                SetRealPos(RealPos);
                SetRealSize(vTextSize);
                DisplayText(m_sLocalizedText);
            }
            
        }
        return ;
	}
    
	void Copy(UIWindow cWndDest, UIWindow cWndSrc)
	{
  	  UIStatic cDest = (UIStatic)cWndDest;
	  UIStatic cSrc = (UIStatic)cWndSrc;
   	  super.Copy(cDest,cSrc);
      if(cSrc.m_vTextColor !=null)
	  {
	      cDest.m_vTextColor=new Vector(cSrc.m_vTextColor);
		  cDest.SetTextColorV(cDest.m_vTextColor);
	  }
	  else
		  cDest.m_vTextColor=null;
	  cDest.m_sFontId = cSrc.m_sFontId;
      cDest.SetFontScale(cSrc.m_fFontScale);
      cDest.SetTextPosFlags(cSrc.m_nTextPosFlags);
            
      cDest.m_bFitTextSize = cSrc.m_bFitTextSize;
      if (cSrc.m_vFitTextSizeMargin != null)
          cDest.m_vFitTextSizeMargin = new Vector(cSrc.m_vFitTextSizeMargin);
      
      cDest.SetAlphaForText(cSrc.m_fTextAlpha);
	  cDest.SetTextAlpha(cSrc.m_fTextAlpha);
      cDest.SetText(cSrc.m_sText);
	  
	}
    
    public boolean SetFont(String sFontID )
    {
        //printStackTrace("SetFont");
        //CrashLog("SetFont " + sFontID + " " + this + "\n");
        ((Fonts)GetModule().fonts).UIStaticSetFont(this, sFontID);
        
        return true;
    }
    
    public void _SetFont(String sFontID)
    {
        m_sFontId = new String(sFontID);
        DisplayText();
    }
    
    /**Ustala aktualny kolor tekstu*/
    public void SetTextColor( float r, float g, float b, float a )
    {
        m_vCurTextColor.fX = r;
        m_vCurTextColor.fY = g;
        m_vCurTextColor.fZ = b;
        m_fCurTextAlpha = a;
        DisplayText();      
    }
    
    public void SetTextAllColors(float r, float g, float b)
    {
        m_vCurTextColor.Set(r, g, b);
        if (m_vTextColor != null)
        {
            m_vTextColor.Set(r, g, b);
        }
        DisplayText();
    }
    
    public void SetTextAllAlpha(float fAlpha)
    {
        m_fCurTextAlpha = m_fTextAlpha = fAlpha;
        DisplayText();
    }
    
    void SetTextAlphaForAll(float fAlpha)
    {
        SetTextAlpha(fAlpha);
        
        UIWindow wnd = null;
        
        int cnt = m_vChildWindows.size();
        for(int i = 0; i < cnt; i++)
        {
            wnd = (UIWindow)m_vChildWindows.elementAt(i);
            if (wnd != null && wnd instanceof UIStatic)
                ((UIStatic)wnd).SetTextAlphaForAll(fAlpha);			
        }		        
    }
    
    public void SetTextColorV( Vector color )
    { 
        m_vCurTextColor.Set(color);
        DisplayText();
    }


    //pt:.-------- efekty Effect
    public void OnEffectSizeStart()
    {
        super.DisplayText("");        
    }
    public void OnEffectSizeEnd()
    {
        DisplayText();
    }        
    //pt:.-------------   efekt przlatujacego tekstu przez okno
    /**
     * Ustawienie przelatujacego tekstu
     * sText - tekst
     * nFlyMode - w jaki spsob tekst ma przelatywac
     * vBorderSize - rozmiar ruchomego sprita na ktorym umieszczony jest tekst,
     *               wazne by obejmowal on caly tekst 
     */
    void SetFlyText(String sText, int nFlyMode, Vector vBorderSize)
    {
       LogLine(" SetFlyText ");
       
       if(m_cFlyText==null)
            CreateFlyText();
       m_cFlyText.m_nFlyTextMode = nFlyMode;         
       m_cFlyText.SetTextColor(0,0,0);       
       m_cFlyText.SetText(sText);        
       m_cFlyText.SetLogicSize(vBorderSize);
       m_cFlyText.Fly();
    }
    void CreateFlyText()
    {
          m_cFlyText = (UIFlyText)CreateObject("UIFlyText");
          AddChild(m_cFlyText);
          m_cFlyText.OnInit();
    }
    /** uruchamia ruchomy tekst , jesli jest zainicjowany     */
    void SetFlyText()
    {
       if(m_cFlyText!=null)
            m_cFlyText.Fly();
    }
    /** usuwa ruchomy tekst     */
    void StopFlyText()
    {
        if(m_cFlyText!=null)
            m_cFlyText.StopFly();
    }
    
    /** ustawienie parametrow plywaacego tekstu
     */    
    void SetFlyTextParam(int nFlyTextMode,boolean bFlyWrap,float fFlyWrapTime, float fFlyTextTime )
    {
       if(m_cFlyText==null)
            CreateFlyText();        

        m_cFlyText.m_nFlyTextMode = nFlyTextMode;
        m_cFlyText.m_bFlyWrap = bFlyWrap;
        m_cFlyText.m_fFlyWrapTime = fFlyWrapTime;
        m_cFlyText.m_fFlyTextTime = fFlyTextTime;
    }
    
    
    void DisplayTextFitSizeWithMargin(String sText, Vector vMargin)
    {
        m_bFitTextSize = true;
        m_vFitTextSizeMargin.Set(vMargin);
		SetText(sText);
        
    }
    
    void DisplayTextTest()
    {
        DisplayTextFitSizeWithMargin("TEST TESTOWY", new Vector());
    }
    
}
