abstract public class Behavior extends GameObject implements ICritical
{
    /** Warunek jaki ma byc spelniony, aby wyslac to zachowanie do obiektu
     * poruszajacego sie po sciezce */
    public Condition cCondition = null;//#\BEHAVIOR;Condition to start the behavior

    /** czy Behavior jest krytyczne - czy ma sie wykonac bez wzgledu
     * na okolicznosci */
    public boolean bCritical = false;//#\BEHAVIOR;Can current Behavior be interrupted (and resumed later)
    
    /** Implementacja interface'u ICritical */
    public boolean IsCritical()
    {
        return bCritical;
    }
    
    public void SetCritical(boolean bCritical)
    {
        this.bCritical = bCritical;
    }

    
    public void OnDestroy()
    {
        if(cCondition != null)
        {
            cCondition.delete();
            cCondition = null;
        }
    }
}
