/** Warunek */
abstract public class Condition extends GameObject
{	
    /** Nastepny warunek tworzacy z aktualnym cale wyrazenie logiczne */
    public Condition and = null;//#;Next evaluted condition. It's result is anded with current codition giving final result.

    /** Znacznik, ze zwracana jest zanegowana wartosc Conditiona */
    public boolean bNegate = false;//#;Evaluation returns negated value of Condition (after evaluating 'and' condition chain)
    
    /** Metoda wyliczajaca wartosc warunku logicznego z przejsciem po polach cAND */
    boolean Evaluate()
    {
        boolean bPositive = !EvaluateInternal() ? false : (and==null ? true : and.Evaluate());
        return bPositive != bNegate; //(XOR)
    }
    
    /** Wyliczenie warunku na podstawie atrybutow warunku
     */
	abstract boolean EvaluateInternal();
    
    /** Zeruje stan warunku, wymagany do jego obliczenia.
     * Wolane w Trigerze przy wlaczaniu go, przydaje sie w warunku czasowym.
     */
    void Clear()
    {
    }
    
    public void OnDestroy()
    {
        if(and != null)
        {
            and.delete();
            and = null;
        }
    }
	
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {
		FileChunk.Log("[Condition.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);
		
        if (cFC.GetID() == ESGChunks._CHK_CONDITION)
        {
			super.SGLoadChunk(cFC);
			// Nastepny warunek tworzacy z aktualnym cale wyrazenie logiczne.
			and = (Condition)cFC.LoadObjectRef();
			// Znacznik, ze zwracana jest zanegowana wartosc Conditiona.	
			bNegate = cFC.LoadBool();			
        }
		
		cFC.delete();
	}
	
    /** Metoda zapisujaca dane do Save gracza
     */		
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[Condition.SGSaveChunk]\n");
		
		FileChunk cFC = NewChunk(ESGChunks._CHK_CONDITION, cFCParent);
		
        super.SGSaveChunk(cFC);
		
		// Nastepny warunek tworzacy z aktualnym cale wyrazenie logiczne.
		cFC.SaveObjectRef(and);
		// Znacznik, ze zwracana jest zanegowana wartosc Conditiona.	
		cFC.SaveBool(bNegate);			
			
		cFC.delete();
	}			
}