public class Waypoint extends EditorRenderableObject	
{
    /** Warunek wejscia tzn. warunek ten ma byc spelniony, aby obiekt
     * szedl do tego punktu */
    public Condition cEnterCondition = null;//#\WAYPOINT;When this condition is true object starts motion to this waypoint
    
    /** Zachowanie podczas poruszania sie do tego punktu */
    public MotionType cMotion = null;//#\WAYPOINT;Type of motion used to achive waypoint
    
    /** Zachowanie obiektu po wejsciu w ten punkt */
    public Behavior[] aBehaviors = null;//#\WAYPOINT;Behaviors of object when it enters waypoint
    
    /** Akcja wykonywana po wejsciu w punkt */
    public Action[] aActions = null;//#\WAYPOINT;Actions performed when objects enters waypoint

    /** Referencja do nastepnego Waypointa */
    public Waypoint cNext = null;//#\WAYPOINT;Next waypoint on path

    Waypoint()
	{		
		bSG = false;
		iRenderType = EEditorRenderType._MESH;
		EditorMeshName = "data\\interface\\choragiewka.3da";
	}
    
    public void OnCreate()
    {
        super.OnCreate();
        
        ClearFlag(EFlags._NOT_STATIC);
    }

    // wolane gdy edytor dodaje ten obiekt
    public void OnEditorObjectAdd(ControlObject[] aSelectedObject)
    {
        CrashLog("[Waypoint.OnEditorObjectAdd] aSelectedObject.length="+aSelectedObject.length+"\n");
        
        if(aSelectedObject == null) return;
        
        // ustawiamy pole cNext w obiektach wyselekcjonowanych
        for(int i=0; i<aSelectedObject.length; ++i)
        {
            ControlObject cObj = aSelectedObject[i];
            if(cObj == null) continue;
            
            CrashLog("[Waypoint.OnEditorObjectAdd] cObj="+cObj.GetName()+"\n");
            
            // ustawienie nastepnego punktu w waypointie
            if( cObj.IsAssignable("Waypoint") )
                cObj.SetEditorAttribute("cNext", this);
            
            //TODO poprawic to, zeby w enginie nie bylo odwolan do klas z innych gier
            if( cObj.IsAssignable("NewAI") )
                cObj.SetEditorAttribute("cWaypoint", this);
            
            if( cObj.IsAssignable("FlyingTransporter") )
                cObj.SetEditorAttribute("cWaypoint", this);
        }
    }
    
    // wolane gdy edytor kasuje ten obiekt
    public void OnEditorObjectDel()
    {
    }
    
    //
    public boolean UpdateDataByMatrix(){ return false;}
    
    //
	public boolean UpdateMatrixByData(){ return false;}
    
    // definiujemy rysowanie kresek miedzy kolejnymi Waypointami
    public static void DefineVisualisation()
    {
        DefineDebugArrow("cNext", new Vector(1,0,0), true);
    }
	
    //*********************************************************
	//					SaveGame
    //*********************************************************
/*	
    // Metoda wczytujaca zapisane dane w Save gracza
    public void SGLoadChunk(FileChunk cParentFC)
    {
		FileChunk.Log("[Waypoint.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);
		
        if (cFC.GetID() == ESGChunks._CHK_WAYPOINT)
        {
			super.SGLoadChunk(cFC);
		
            //???
        }
		
		cFC.delete();
	}
	
    // Metoda zapisujaca dane do Save gracza
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[Waypoint.SGLoadChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunks._CHK_WAYPOINT, cFCParent);
		
		super.SGSaveChunk(cFC);

        //???
        
		cFC.delete();
	}
*/	
	/** Metoda teleportuje gracza w pozycje waypointa
	 */
	public void SuckPlayer()
	{
        Module cModule = GetModule();
        GameObject[] aPlayers = GetObjectsOfClass("PlayerSingle");
        
        for(int i=0; i < aPlayers.length; ++i)
        {
            ControlObject cObj = (ControlObject)aPlayers[i];
            cObj.SetPosition( GetPositionVectorVolatile() );
            //cModule.PortalSystemActive( cModule.GetActiveCamera(), true );
        }
    }
}
