/**Czesc skladowa gry, najmniejszy jej element. Zawiera teren, obiekty 
 * itd.
 */
public class Module extends GameObject
{
	/** numer chunka ze sciezka */
	static int CHK_JAVA_AIED_PATH2 = 10042;
	/** numer chunka z punktami */
	static int CHK_JAVA_AIED_PATH_POINT = 10041;
	
    ///////////////////////////////////
    // OGOLNE
    ///////////////////////////////////

    public float fIndoorAmbientR = 0.5f;//#AMBIENT_COLOR
    public float fIndoorAmbientG = 0.5f;//#AMBIENT_COLOR
    public float fIndoorAmbientB = 0.5f;//#AMBIENT_COLOR
    
    /**[native] Uaktywniania modul jako biezacy do renderowania.
     * Po uaktywnieniu modul jest symulowany i renderowany (obiekty w 
     * nim umieszczone wykonuja OnFrame())
     */
    native void Activate();
    
    /**[native] Deaktywuje modul - nie jest on rysowany.*/
    native void Deactivate();
	
	// Wycisz wszystkie dzwieki na levelu
	native void MuteAllSounds();
	// Przywraca wszystkie dzwieki na levelu
	native void UnMuteAllSounds();

    /**[native] Ustawia maksymalne ziarno update'u fizyki dla danego level'u.
     * @param maksymalny przedzial czasu. (<code>Vector</code>)
     */
    final native void SetPhUpdateGranularity(float fMaxUpdateTime);
    
    /**[native] Pobiera maksymalne ziarno update'u fizyki dla danego level'u.
     * @return maksymalny przedzial czasu. (<code>Vector</code>)
     */
    final native float GetPhUpdateGranularity();
    
    /**[native] Pobiera czas ostatniego updateu fizyki na levelu.
	 * @return czas gry w sekundach (<code>float</code>)*/
	public native float GetPhysicsLastUpdateTime();
        
    /**[native] Ustawia czas ostatniego updateu fizyki na levelu.
	 * @param fTime czas w sekundach	 */
	public native void SetPhysicsLastUpdateTime(float fTime);

    /**[native] Dodaje obiekt do modulu.
     * @param Obj dodawany obiekt (<code>ControlObject</code>)
     */
    native void AddControlObject(ControlObject Obj);

    /**[native] Usuwa obiekt z modulu.
     * @param Obj usuwany obiekt (<code>ControlObject</code>)
     */
    native void RemoveControlObject(ControlObject Obj);

    /** Wlacza/wylacza fizyke ODE (update tej fizyki)
     */
    native void ODEEnable(boolean bEnable);
    
    /** Czy fizyka ODE jest wlaczona (update tej fizyki)
     */
    native boolean IsODEEnable();

    /** Wlacza/wylacza rendering geometrii i kontaktow fizyki ODE
     */
    native void ODERenderEnable(boolean bEnable);
    
    /** Czy rendering geometrii i kontaktow fizyki ODE jest wlaczony
     */
    native boolean IsODERenderEnable();

    /**[native] Ustawia sposob przeplotu updatu ODE z updatem zwyklej fizyki 
     * @param bInterlace:
     * false - brak przeplotu (w ramce wywolaja sie 3 updaty zwyklej fizyki i potem np. 5 updateow ODE)
     *         czyli te dwie fizyki dzialaja zupelnie ziezaleznie
     * true - przeplot (po jednym wywolaniu zwyklej fizyki nastepuje jedno wywolanie ODE)
     */
    native void EnableODEWithPhysicsUpdateInterlace(boolean bInterlace);
    
    /**[native] Ustawia rodzaj ziarna ODE
     * @param bFixedStep:
     * false - zmienne ziarno
     * true - stale ziarno
     */
    native void EnableODEFixedUpdateTime(boolean bFixedStep);
    
    /**[native] Ustawia czas updatu dla stalego ziarna
     */
    native void SetODEFixedUpdateTime(float fFixedUpdateTime);
    
    /**[native] Ustawia minimalny i maksymalny czas updatu dla zmiennego ziarna
     */
    native void SetODEMinMaxUpdateTime(float fMinUpdateTime, float fMaxUpdateTime);
    
    ////////////////////////////////////////////////
    // INICJALIZACJA I LADOWANIE ELEMENTOW LEVELU
    ////////////////////////////////////////////////
    
    /**[native] Laduje teren w stylu starego firezona. Nie powinno byc
     * wolane przez kogokolwiek. 
     */
    final native void LoadTerrain(String sTerrainScript, float size);
    
    /**[native] Laduje drzewa. Patrz {@link #LoadTerrain(String sTerrainScript, float size)}
     */
    native void LoadTrees(String sTerrainScript);
    
    final native void InitFXSystem();

    /**[native] Inicjalizacja grida do ustawiania ControlObjectow na levelu.
     */
    final native void InitGrid(float fSizeX, float fSizeY, float fSizeZ);
    
    /**[native] Inicjalizacja grida do ustawiania ControlObjectow na levelu.
     */
    final native void InitGrid(float fSizeX, float fSizeZ, float fMinX, float fMaxX, float fMinY, float fMaxY, float fMinZ, float fMaxZ);
    
    
    ///////////////////////////////////
    // ZMIANA PAREMETROW LEVELU
    ///////////////////////////////////

    /**[native] Ustawia parametr sterujacy wplywem zoomowania na wybieranie
     * lodow terenu. Domyslna wartosc to 1.0 */
    native void Terrain_SetZoomFactor(float fZoomFactor);
    
    /**[native] Pobiera parametr sterujacy wplywem zoomowania na wybieranie
     * lodow terenu. Domyslna wartosc to 1.0 */
    native float Terrain_GetZoomFactor();
	
	/**[native] ustawia parametr okreslajacy minimalna wielkosc obiektu ktory sie moze narysowac
	 * jesli obiekt ma wielkosc na ekranie ponizej wartosci parametru nie zostanie narysowany
	 * zobacz: MeshObject::SetMeshCullSizeEnable(..) 
	 * @param size - wielkosc w pixelach na ekranie
	 */
	native void SetMeshCullSize( float size );
    
    /**[native] Wlacza/Wylacza rysowanie horyzonu 
     * (quady doklejane do krawedzi ternu)
     */
    native void Terrain_EnableHorizon( boolean state );

    /**[native] Zwraca stan rysowania horyzonu
     * (quady doklejane do krawedzi ternu)
     */
    native boolean Terrain_IsHorizonEnabled();
	
	/**[native] Wymusza przeliczenie informacji potrzebnych 
	 * do liczenie level of detail dla terenu
	 * @param errTreshold maxsymalny blad tolerowany przy zmianie LOD'a (default: 5)
	 * @return false gdy wszytsko w porzadku
	 */	
	native boolean Terrain_RecalcErrors( float errTreshold );
	
	/**[native] ustawia zasieg widocznosci wysokiej jakosci kawalkow mapy koloru
	 */
	native void Terrain_SetTileColorDist( float dist );
	
   
    /**[native] Ustawa kolor tla w levelu.
     * @param Red skladowa R (<code>float</code>)
     * @param Green skladowa G (<code>float</code>)
     * @param Blue skladowa B (<code>float</code>)
     */
    native void SetBackgroundColor(float Red, float Green, float Blue);
    
    /**[native] Ustawia materialy dla billboardow
     */
    native public void SetTreesBBMaterials(String sBlendedMat, String sOpaqueMat);
    
    /**[native] Ustawia materialy dla billboardow przy renderingu odbic
     */
    native public void SetTreesBBReflMaterials(String sBlendedMat, String sOpaqueMat);
    
    /**[native] Ustawia wspolczynnik LOD dla drzew
     * @param fLODCoeff wspolczynnik LOD
     */
    native public void SetTreesLODSelectionFactor(float fLODCoeff);
    
    /**[native] Ustawia zakres wycinania dla drzew i parametry blendowania (blendEnd = range)
     * @param blendStart poczatek blendowania billboardow
     * @param blendEnd koniec blendowania billboardow i zarazem zakres widocznosci
     */
    native public void SetTreesVisibilityRange( float blendStart, float blendEnd );
	
    /**[native] Pobiera zakres wycinania dla drzew
     * @return odleglosc wycinania drzew
     */
    native public float GetTreesVisibilityRange();
	
    /**[native] Pobiera zakres wyblendowywania dla drzew
     * @return odleglosc wycinania drzew
     */
    native public float GetTreesVisibilityBlendRange();
    
	/**[native] Ustawia czas w ktorym nastepuje zmiana miedzy poziomami detalu
	 * &param fTime czas w sekundach
	 */
	native public void SetTreesLODMorphTime( float fTime );

    /**[native] Dodanie drzewa do systemu drzew o podanym meshu i na podanej pozycji
     * @param sMeshName nazwa mesha drzewa
     * @param vPos pozycja mesha
     * @param fScale skala drzewa
     * @param fRot kat obrotu drzewa
     * @param fDepth glebokosc na jaka drzewo ma byc wkopane w ziemie
     * @param fRangePercent zasieg widzenia drzewa
     * @param bCollision flaga mowiaca czy ma byc kolizja z drzewem
     */
    native public void AddTree(String sMeshName, Vector vPos, float fScale, float fRot, float fDepth, float fRangePercent, boolean bCollision);
    
    /**[native] Dodanie drzewa do systemu drzew o podanym meshu i na podanej pozycji
     * @param sMeshName nazwa mesha drzewa
     * @param cObj obiekt z ktorego pobrana zostanie macierz do ustawienia drzewu
     * @param fDepth glebokosc na jaka drzewo ma byc wkopane w ziemie
     * @param fRangePercent zasieg widzenia drzewa
     * @param bCollision flaga mowiaca czy ma byc kolizja z drzewem
     */
    native public void AddTree(String sMeshName, ControlObject cObj, float fDepth, float fRangePercent, boolean bCollision);
    
    /**[native] Usuniecie drzewa z systemu drzew o podanym meshu i na podanej pozycji
     * oraz podanych innych parametrach
     * @param sMeshName nazwa mesha drzewa
     * @param vPos pozycja mesha
     * @param fScale skala drzewa
     * @param fRot kat obrotu drzewa
     * @param fDepth glebokosc na jaka drzewo ma byc wkopane w ziemie
     * @param fRangePercent zasieg widzenia drzewa
     * @param bCollision flaga mowiaca czy ma byc kolizja z drzewem
     */
    native public void RemoveTree(String sMeshName, Vector vPos, float fScale, float fRot, float fDepth, float fRangePercent, boolean bCollision);
    
    /**[native] Usuniecie drzewa z systemu drzew o podanym meshu i na podanej pozycji
     * oraz podanych innych parametrach
     * @param sMeshName nazwa mesha drzewa
     * @param cObj obiekt z ktorego pobierana jest macierz do okreslenia pozycji drzewa
     * @param fDepth glebokosc na jaka drzewo ma byc wkopane w ziemie
     * @param fRangePercent zasieg widzenia drzewa
     * @param bCollision flaga mowiaca czy ma byc kolizja z drzewem
     */
    native public void RemoveTree(String sMeshName, ControlObject cObj, float fDepth, float fRangePercent, boolean bCollision);
    
	/**[native] ustawia material dla traw na module, ktore maja w swojej nazwie ciag zgodny z zawartoscia 
	 * parametru pattern
	 * @param nalez podawac malymi literam
	 */
	native public void ReplaceGrassMaterial(String pattern, String matName);
	
    /**[native] Ustawia zakres wycinania dla traw
     * @param fRange odleglosc wycinania traw
     */
    native public void SetGrassVisibilityRange(float fRange);
	
    /**[native] Pobiera zakres wycinania dla traw
     * @return odleglosc wycinania traw
     */
    native public float GetGrassVisibilityRange();

    /**[native] Ustala rozmiar polowy
     *  boxa do renderowania obiektow.
     * @param vExtents wielkosc boxa (<code>Vector</code>)*/
    final native void SetExtents(Vector vExtents);
    
    /**[native] Ustala rozmiar polowy boxa do symulowania obiektow.
     * @param fX wilekosc w fX
     * @param fY wilekosc w fY
     * @param fZ wilekosc w fZ
     */
    final native boolean SetExtents(float fX, float fY, float fZ);
    
    /**[native] Pobiera rozmiar polowy boxa do symulowania obiektow.
     * @return wielkosc boxa*/
    final native Vector GetExtents();
    
    /**[native] Powoduje, ze symulowane sa wszystkie obiekty na levelu */
    final native void SetSimulateAllObjects(boolean bEnable);
    
    /**[native] Zwraca true jesli symulowane sa wszystkie obiekty na levelu */
    final native boolean GetSimulateAllObjects();
    
    /*[native] Wlacza/wylacza rendering levelu */
    final native void SetRenderFlag(boolean bEnable);
    
    /*[native] Zwraca true jesli rendering levelu jest wlaczony*/
    final native boolean GetRenderFlag();
    
    /**Przechowalnia fontow dla sprite'ow, nalezy utworzyc javovo (zwykle new) i 
     * zainicjowac ({@link Fonts#Init(Module module)})przy tworzeniu modulu*/
    static Fonts fonts = null;
    
	/** Kolejnosc wolan OnCreate / OnPostCreate dla levelu / obiektow 
	 * 1. OnCreate dla levelu.
	 * 2. OnCreate dla obiektow.
	 * 3. OnPostCreate dla obiektow.
	 * 4. OnPostCreate dla levelu.
	 */
    void OnCreate()
    {
		bSG = true;
        SetMeshCullSize(8.f);
        InitFonts();
        
        SetDefaultLightColor(new Vector(fIndoorAmbientR, fIndoorAmbientG, fIndoorAmbientB));
    }

	void OnPostCreate()
	{
		bSG = true;

        InitRainManager();
	}
	
    void InitFonts()
    {
        if (fonts == null)
        {
            fonts = new Fonts();
            fonts.Init(this);
        }
    }

    
    /**Zwraca wskaznik na kursor, musi byc zaimplementowana, jesli
     * chcemy miec tooltipy przy kursorze.*/
    Cursor GetCursor()
    {
        return null;
    }

    /**[native] Ustawia klase obiektow, ktore maja byc widoczne podczas uzywania
     * efektow vision.
     */
    public native void SetVisionClass(String sVisionClass);
    
    //////////////////////////
    // NIEBO
    //////////////////////////
    
    /**[native] ustawia kolor przez ktory beda modulowane komponenty
     * nieba (chmury, mesh, slonce, lens flary)
     */
    native void SkySetColor( float Red, float Green, float Blue );
    
    /**[native]
     */
    native Vector SkyGetColor();
    
    /**[native] ustawia kierunek do slonca, nie trzeba normalizowac podanego wektora
     */
    native void SkySetSunDir( float x, float y, float z );
    
    /**[native] zwraca wektor kierunku do slonca
     */
    native Vector SkyGetSunDir();
    
    /**[native] ustawia kierunek do slonca uzywany przy generacji cieni
     * nie trzeba normalizowac podanego wektora
     */
    native void SkySetSunShadowDir( float x, float y, float z );
    
    /**[native] zwraca wektor kierunku do slonca uzywany przy generacji cieni
     */
    native Vector SkyGetSunShadowDir();
    
    /**[native] ustawia stopien przezroczystosci textury slonca, 1 - nieprzezroczyste
     * 0 - zupelnie przezroczyste
     */
    native void SkySetSunOpaque( float opaque );
    
    /**[native] Ustawia kolor oswietlenia od slonca
     */
    native void SkySetSunColor( float r, float g, float b );
	
    /**[native] ustawia flage oslepiac/nieoslepiac true/false 
     */
    native void SkySetBlinding( boolean bOnOff );
	
	/**[native] ustawia flage czy rysowac slonce 
	 */
	native void SkySunEnable( boolean enable );
	
	/**[native] ustawia naze FX'a uzywanego jako slonce
	 */
	native void SkySunFXName( String sunFXName );

	/**[native] ustawia naze FX'a oslepienia od slonca
	 */
	native void SkyBlindFXName( String blindFXName );
    
    //////////////////////////
    // WODA
    //////////////////////////
    
    /**[native] Laduje wode. Patrz {@link #LoadTerrain(String sTerrainScript, float size)}
     */
    native public void LoadWater(String sWaterScript, float fWaterLevel);
    
    /**[native] ustawia poziom wody na levelu
     * NIEAKTUALNE! Poziom wody ustawia sie teraz przy LoadWater
     */
    native public void SetWaterLevel(float Level);
    
    /**[native] pobiera poziom wody na levelu
     */
    native public float GetWaterLevel();

    /**[native] Ustawia numer loda drzew renderowanych do odbicia w wodzie
     */
    native public void SetWaterTreeLOD(int iLod);
    
    /**[native] Ustawia parametry falowania FOVa w widoku pod woda
     * @param fSpeedLR szybkosc falowania w poziomie
     * @param fSpeedTB szybkosc falowania w pionie
     * @param fAmplitude amplituda falowania (w ulamkach normalnego frustuma, domyslnie 0.01)
     */
    native public void SetUnderWaterFOVWave(float fSpeedLR, float fSpeedTB, float fAmplitude);

    /**[native] Ustawia parametry mgly w widoku pod woda
     * @param bEnable wlacza mgle
     * @param fR, fG, fB - kolor mgly
     * @param fNear - poczatek zakresu mgly
     * @param fFar - koniec zakresu mgly
     */
    native public void SetUnderWaterFog(boolean bEnable, float fR, float fG, float fB, float fNear, float fFar);
    
    /**[native] Ustawia parametry widoku pod woda
     * @param fR, fG, fB, fA - kolor 'barwienia' wody
     * @param bSkyVisible czy pod woda widac niebo
     */
    native public void SetUnderWaterParams(float fR, float fG, float fB, float fA, boolean bSkyVisible);
    
    /** handler wolany, gdy zmienia sie polozenie kamery (pod woda/nad woda) */
    void OnCameraEnvironmentChange(int iEnv)
    {
        if (iEnv == 2)
        {
            //LogR("underwater\n");
            SetSoundEnvironment(ESoundEnv.SOUNDENV_UNDERWATER, 0.5f);
        }
        else
        if (iEnv == 1)
        {
            //LogR("indoor\n");
            SetSoundEnvironment(ESoundEnv.SOUNDENV_STONECORRIDOR, 0.5f);
        }
        else
        {
            //LogR("outdoor\n");
            SetSoundEnvironment(ESoundEnv.SOUNDENV_FOREST, 0.5f);
        }
    }
    
    //////////////////////////
    // MGLA
    //////////////////////////
    
    /**[native] ustawia kolor mgly + kolor czyszczenia ekranu
     */
    native void FogSetColor( float Red, float Green, float Blue );
    
    /**[native] pobranie koloru mgly 
     */
    native Vector FogGetColor();

    native float FogGetFar();
    native void FogSetFar(float fFar);
    
    native float FogGetNear();
    native void FogSetNear(float fNear);

    /* Ustawia typ mgly
     * 0 - none, 1 - linear, 2 - exp, 3 - exp2 
     */
    native void FogSetType(int iType);
    
    /* Pobiera typ mgly */
    native int FogGetType();

    /* Ustawia gestosc mgly exponencjalnej */
    native void FogSetDensity(float fDensity);

    /* Pobiera gestosc mgly exponencjalnej */
    native float FogGetDensity();

    ///////////////////////////////////
    // PATHMAPA
    ///////////////////////////////////

    /**[native] Dodaje do modulu mape kolizji dla obiektow.
     * @param sFileName nazwa pliku z mapa kolizji (<code>String</code>)*/
    final native void SetPathMap(String sFileName);

    /**[native] Zapisuje mape kolizji dla obiektow dla modulu.
     * @param sFileName nazwa pliku gdzie ma byc zapisana mapa. (<code>String</code>)*/
    final native void SavePathMap(String sFileName);

    /**[native] Sprawdzenie, czy mozna nalozyc stampa o podanym numerze
     * na pathmape.
     * @param pozycja (srodek obiektu, dla ktorego stamp zostal wygenerowany. (<code>Vector</code>)
     * @param numer wczytanego stampa. (<code>int</code>)
     */
    final native boolean IsOverlapped(Vector vPos, int iStampNo);

    /**[native] Nalozenie stampa na pathmape. Jezeli nie ma pathmapy, nic sie nie dzieje
     * @param pozycja (srodek) obiektu, dla ktorego stamp zostal wygenerowany. (<code>Vector</code>)
     * @param numer wczytanego stampa. (<code>int</code>)
     */
    final native void PutStamp(Vector vPos, int iStampNo);
    
    /**[native] Usuniecie stampa z pathmapy. Jezeli nie ma pathmapy, nic sie nie dzieje
     * @param pozycja (srodek) obiektu, dla ktorego stamp zostal wygenerowany. (<code>Vector</code>)
     * @param numer wczytanego stampa. (<code>int</code>)
     */
    final native void RemoveStamp(Vector vPos, int iStampNo);
    
    /**[native] Laduje wygenerowany wczesniej obrys obiektu uzywany przy pathmapie.
     * Jezeli obrys nie istnieje, zwracane jest -1. Jezeli istnieje, zwracany jest
     * jego identyfikator. Stamp sie usuwa sam przy okazji kasowania levelu.
     * @param nazwa pliku ze stampem.
     */
    public native int LoadStamp(String sStampName);

    //////////////////////////
    // MAPA TYPU TERENU
    //////////////////////////

    /**[native] Laduje mape typu terenu
     * @param sciezka do mapy (tekstura 8-bit z paleta)
     * @param rozmiar mapy w swiecie w osi x
     * @param rozmiar mapy w swiecie w osi z
     * @param pozycja x poczatku mapy w swiecie
     * @param pozycja z poczatku mapy w swiecie
     * @return true jesli OK
     */
    public native boolean InitTerrainTypeMap(String sMapPath, 
                                             float fSizeX, float fSizeZ, 
                                             float fOriginX, float fOriginZ);
    
    //////////////////////////
    // KAMERY
    //////////////////////////
    
    /**[native] Uaktywnia podana kamere na levelu. Oznacza to ze 
     * bedzie renderowal z punktu widzenia tej kamery.
     * @param newCamera aktywowana kamera (<code>Camera</code>)*/
    native void ActivateCamera(Camera newCamera);

    /**[native] Pobiera aktywna kamera
     * @return aktywna kamera (<code>Camera</code>)*/
    native Camera GetActiveCamera();
    
    
    ///////////////////////////////////
    // WIDOKI
    ///////////////////////////////////
    
    /**[native] Dodaje i aktywuje nowy widok levelu, nalezy pamietac, ze poprzedni widok 
     * nie jest automatycznie deaktywowany ani kasowany, trzeba o to zadbac wlasnorecznie 
     * (jesli nie chcemy miec kilku aktywnych widokow)
     * @param cam kamera dla tworzonego widoku
     * @param iOriginX pozycja x (na ekranie) lewego dolnego rogu widoku
     * @param iOriginY pozycja y (na ekranie) lewego dolnego rogu widoku
     * @param iSizeX rozmiar x widoku
     * @param iSizeY rozmiar y widoku
     * @return zwraca identyfikator widoku
     */
    public native int AddView(Camera cam, int iOriginX, int iOriginY, int iSizeX, int iSizeY);

    /**[native] Dodaje i aktywuje nowy widok levelu, nalezy pamietac, ze poprzedni widok 
     * nie jest automatycznie deaktywowany ani kasowany, trzeba o to zadbac wlasnorecznie 
     * (jesli nie chcemy miec kilku aktywnych widokow)
     * @param cam kamera dla tworzonego widoku
     * @param fOriginX pozycja x (0-1 szerokosci ekranu) lewego dolnego rogu widoku
     * @param fOriginY pozycja y (0-1 wysokosci ekranu) lewego dolnego rogu widoku
     * @param fSizeX rozmiar x (0-1 szerokosci ekranu) widoku
     * @param fSizeY rozmiar y (0-1 wysokosci ekranu) widoku
     * @return zwraca identyfikator widoku
     */
    public native int AddView(Camera cam, float fOriginX, float fOriginY, float fSizeX, float fSizeY);

    /**[native] Deaktywuje i usuwa widok levelu
     * UWAGA: Po usunieciu widoku nie wolno sie juz do niego odwolywac
     * @param ViewHandle identyfikator widoku
     */
    public native void RemoveView(int ViewHandle);
	
	/**[native] Pobiera ID widoku sluzace do blokowania renderingu poszczegolnych obiektow
	 */
	public native int GetViewID(int ViewHandle);

    /**[native] Aktywuje widok levelu (renderuja sie tylko widoki aktywne)
     * @param ViewHandle identyfikator widoku
     */
    public native void ActivateView(int ViewHandle);

    /**[native] Deaktywuje widok levelu
     * @param ViewHandle identyfikator widoku
     */
    public native void DeactivateView(int ViewHandle);

    /**[native] Przenosi widok ponad wszystkie inne widoki
     * @param ViewHandle identyfikator widoku
     */
    public native void MoveViewToTop(int ViewHandle);

    /**[native] Przenosi widok pod wszystkie inne widoki
     * @param ViewHandle identyfikator widoku
     */
    public native void MoveViewToBottom(int ViewHandle);

    /**[native] Zmienia pozycje widoku
     * @param ViewHandle identyfikator widoku
     * @param iOriginX pozycja x (na ekranie) lewego dolnego rogu widoku
     * @param iOriginY pozycja y (na ekranie) lewego dolnego rogu widoku
     */
    public native void SetViewOrigin(int ViewHandle, int iOriginX, int iOriginY);
    public native int GetViewOriginX(int ViewHandle);
    public native int GetViewOriginY(int ViewHandle);

    /**[native] Zmienia pozycje widoku
     * @param ViewHandle identyfikator widoku
     * @param fOriginX pozycja x (0-1 szerokosci ekranu) lewego dolnego rogu widoku
     * @param fOriginY pozycja y (0-1 wysokosci ekranu) lewego dolnego rogu widoku
     */
    public native void SetViewOrigin(int ViewHandle, float fOriginX, float fOriginY);

    /**[native] Zmienia rozmiar widoku
     * @param ViewHandle identyfikator widoku
     * @param iSizeX rozmiar x widoku
     * @param iSizeY rozmiar y widoku
     */
    public native void SetViewSize(int ViewHandle, int iSizeX, int iSizeY);
    public native int GetViewSizeX(int ViewHandle);
    public native int GetViewSizeY(int ViewHandle);
    
    /**[native] Zmienia rozmiar widoku
     * @param ViewHandle identyfikator widoku
     * @param fSizeX rozmiar x (0-1 szerokosci ekranu) widoku
     * @param fSizeY rozmiar y (0-1 wysokosci ekranu) widoku
     */
    public native void SetViewSize(int ViewHandle, float fSizeX, float fSizeY);

    /**[native] Zmienia kamere dla widoku
     * @param ViewHandle identyfikator widoku
     * @param cam nowa kamera
     */
    public native void SetViewCamera(int ViewHandle, Camera cam);
    
    /**[native Pobiera kamere, ktora jest aktywana w danym widoku
     * @param ViewHandle identyfikatow widoku
     * @return aktywna kamera
     */
    public native Camera GetViewCamera(int ViewHandle);

    /**[native] Wymusza czyszczenie frame i z-bufora dla widoku
     * @param ViewHandle identyfikator widoku
     * @param bForceClear wymusza czyszczenie jesli true
     */
    public native void ForceClearView(int ViewHandle, boolean bForceClear);

    /**[native] Wymusza czyszczenie frame i/lub z-buffera dla widoku
     * @param ViewHandle identyfikator widoku
     * @param bClearColor wymusza czyszczenie frame buffera jesli true
     * @param bClearDepth wymusza czyszczenie z-buffera jesli true
     */
    public native void ForceClearViewIndependent(int ViewHandle, boolean bClearColor, boolean bClearDepth);

    /**[native] Metody ustalaja, czy w danym widoku ma byc renderowany dany element gry
     * @param ViewHandle identyfikator widoku
     * @param bRender true jesli renderowac
     */
    public native void ViewRenderTerrain(int ViewHandle, boolean bRender);
    public native void ViewRenderTrees(int ViewHandle, boolean bRender);
    public native void ViewRenderGrass(int ViewHandle, boolean bRender);
    public native void ViewRenderWater(int ViewHandle, boolean bRender);
    public native void ViewRenderSky(int ViewHandle, boolean bRender);
    public native void ViewRenderObjects(int ViewHandle, boolean bRender);
	
	
	/**[native] Ustawia vision effect dla zdanego widoku
	 * @param ViewHandle identyfikator widoku
	 * @param type widoku ( EVision.VE_*.* )
	 */
	public native void ViewVisionEffect( int ViewHandle, int enum_VisionType );

    /**[native] Ustawia, czy dany widok ma miec aktywnego sluchacza
     * @param ViewHandle identyfikator widoku
     * @param bRender true jesli ma byc aktywny sluchacz
     */
    public native void ListenerOnViewActive(int ViewHandle, boolean bRender);
    
    /**[native] Ustawia, czy na danym widoku system portali jest aktywny
     * @param ViewHandle identyfikator widoku
     * @param bActive true jesli aktywny
     */
    public native void PortalSystemActive(int ViewHandle, boolean bActive);
    
    /**[native] Podaje czy system portali jest aktywny na widoku
     */
    public native boolean IsPortalSystemActive(int ViewHandle);
    
    /**[native] Sprawdza czy nalezy przelaczyc aktywnosc systemu portali
     * dla kamery w zadanej pozycji
     * @returns -1 nic sie nie zmienia, 0 wylaczony, 1 wlaczony
     */
    public native int CheckPortalSystemActive(Vector vCamPos);

    /**[native] Updateuje aktywnosc systemu portali w zadanym widoku 
     * dla kamery w podanej pozycji
     */
    public void UpdatePortalSystemActive(Vector vCamPos, int ViewHandle)
    {
        int change = CheckPortalSystemActive(vCamPos);
        
        if (change >= 0)
        {
            PortalSystemActive(ViewHandle, change == 1);
        }
    }
    
    ///////////////////////////////////
    // OBSLUGA TRIGGEROW
    ///////////////////////////////////
    
    /** metoda wolana gdy zostanie zawolane Execute na jakims TriggerObject'cie z levelu */
    public void TriggerExecuted(TriggerObject cTrigger, Actor cExecutor)
    {
    }

    
    ///////////////////////////////////
    // ODGRYWANIE MUZYKI Z CD
    ///////////////////////////////////
    
    /**Zmienna okreslajaca czy gra muzyka*/
    boolean bCDMusicPlaying = false;
    /**Okresla, czy muzyka jest spauzowana*/
    boolean bCDMusicPaused = false;
    
    /**Funkcja uruchamia odgrywanie muzyki z CdAudio, jesli muzyka juz gra, to 
     * nic sie nie zmienia.
     * @param sGroupName nazwa grupy sciezek audio, zdefiniowana w pliku data/CD.scr
     */
    public void PlayCDMusic(String sGroupName)
    {
        if (bCDMusicPlaying && !bCDMusicPaused) 
            return;
        if (sGroupName != null) 
        {
            if (!((GameObject)this).CDIsInitialized())
            {
                ((GameObject)this).CDInitialize();
            }
            if (bCDMusicPaused)
            {
                ((GameObject)this).CDPlayGroup(sGroupName);
            }
            else
            {
                ((GameObject)this).CDPlayGroup(sGroupName);
            }
            bCDMusicPlaying = true;
            bCDMusicPaused = false;
        }
        else
        {
            bCDMusicPlaying = false;
        }
    }
    
    /**Zatrzymuje aktualnie odtwarzana muzyke z CDAudio
     * @param bPause jesli true, to po ponownym wlaczeniu bedzie grac od miejsca pauzy*/
    public void StopCDMusic(boolean bPause)
    {
        if (bCDMusicPlaying)
        {
            if (!bPause)
                ((GameObject)this).CDStop();
            else
            {
                ((GameObject)this).CDPause();
                bCDMusicPaused = true;
            }
        }
    
        bCDMusicPlaying = false;
    }
    
    ///////////////////////////////////
    // FILMY
    ///////////////////////////////////

    int iMovieViewID = 0;

    protected void MovieCreateView()
    {
        iMovieViewID = AddView(null, 0.0f, 0.0f, 1.0f, 1.0f);
        ForceClearView(iMovieViewID, true);
        ListenerOnViewActive(iMovieViewID, true);
        
        SetMovieView(iMovieViewID);
        CrashLog("[MovieCreateView]\n");
    }
    
    protected void MovieDestroyView()
    {
        RemoveView(iMovieViewID);
        iMovieViewID = 0;
    }
    
    Sprite cSubtitle = null;

    int nSubtitlesLeftMargin = 10;
    int nSubtitlesDownMargin = 5;

    protected void MovieCreateSubtitles()
    {
        cSubtitle = (Sprite)CreateObject("Sprite");
		cSubtitle.SetNoTexture();
		cSubtitle.ProcessMouse(false);
        cSubtitle.SetTextColor( 1.0f, 1.0f, 1.0f, 1.0f );
		cSubtitle.SetSize(new Vector(1024.0f, 768.0f,0));
		cSubtitle.SetPos(new Vector(10.0f, 455.0f, 0));
        cSubtitle.SetTextPosFlags(ESpriteText.MULTILINE);
        cSubtitle.SetFont(sMovieSubtitlesFont);
        
		cSubtitle.MoveTop();
		AddSprite(cSubtitle);
        cSubtitle.Hide();
    }
    
    protected void MovieDestroySubtitles()
    {
        cSubtitle.Hide();
        RemoveSprite(cSubtitle);

        cSubtitle.delete();
        cSubtitle = null;
    }
    
    // flaga powoduje, ze filmy nie wlaczaja widoku
    protected boolean bMovieSubtitles = true;

    protected String sMovieSubtitlesFont = Fonts.FONT_MSSANSSERIF_12;
    
    /** Ustawienie parametrow odgrywania filmow
     * @param bSubtitles okresla czy film ma byc odpalany z subtitlami
     */
    public void SetMovieParams(boolean bSubtitles)
    {
        bMovieSubtitles = bSubtitles;
    }

    /** Ustawia fonta jakim pisane sa teksty w subtitlach
     */
    public void SetMovieSubtitleFont(String sFont)
    {
        sMovieSubtitlesFont = sFont;
    }
    
    public void OnStartMovie()
    {
        MovieCreateView();
        if(bMovieSubtitles) MovieCreateSubtitles();
    }

    public void OnEndMovie()
    {
        if(bMovieSubtitles) MovieDestroySubtitles();
        MovieDestroyView();
    }
    
    public void OnLevelViewsActivated(boolean bActivated)
    {
    }
    
    // unikalny numer ostatnio wyswietlonego subtitla
    protected int iSubtitleNumber = -1;
    
    public void OnShowSubtitle(String sText, int iSubNumber)
    {
        iSubtitleNumber = iSubNumber;
        
        if (cSubtitle != null)
        {
            LogR("Subtitle: " + sText + ", number: " + iSubNumber + "\n");
        
            int nSizeX = GetScreenWidth() - 2*nSubtitlesLeftMargin;
            cSubtitle.SetSize(new Vector(nSizeX,GetScreenHeight(),0));
            
            int nSizeY = (int)cSubtitle.GetTextExtent(Text.Get(sText)).fY;
            cSubtitle.DisplayText(sText);
            cSubtitle.SetSize(new Vector(nSizeX, nSizeY, 0));
            int nPosY = GetScreenHeight() - nSizeY - nSubtitlesDownMargin;
            cSubtitle.SetPos(new Vector(nSubtitlesLeftMargin,nPosY,0));//new Vector(nSubtitlesLeftMargin, GetScreenWidth() - nSizeY - nSubtitlesDownMargin, 0.0f));
            cSubtitle.MoveTop();
            cSubtitle.Show();
        }
    }
    
    public void OnHideSubtitle(int iSubNumber)
    {
        LogR("HideSubtitle number: " + iSubNumber + "\n");

        // nie kasujemy subtitla jezeli w miedzyczasie pokazany byl juz nastepny
        if (iSubNumber != iSubtitleNumber) return;
        
        if (cSubtitle != null)
            cSubtitle.Hide();
    }
    
    
    //////////////////////////
    // POBIERANIE OBIEKTOW
    //////////////////////////
    
    /** Metoda pobiera obiekt z levelu o podanym unikalnym identyfikatorze.
     * @param nID identyfikator obiektu
     * @return obiekt
     */
    public native GameObject GetObjectByID(int nID);

    //////////////////////////
    // CIENIE
    //////////////////////////

    /**[native] Ustawia jasnosc cienia z shadowmapy (0-1) */
    public native void SetShadowMapBrightness(float fBrightness);

    /**[native] Ustawia parametry kamery generujacej shadow mape
     * Domyslne wartosci fFOV = 20, fNear = 10, fFar = 10000
     */
    public native void SetShadowMapFrustum(float fFOV, float fNear, float fFar);

    /**[native] Ustawia obiekt celu, na ktory patrzy kamera mapy cienia
     * Jesli poda sie null, wtedy kamera patrzy na obiekt najblizszy do kamery widoku
     */
    public native void SetShadowMapTarget(ControlObject Target);
    
    /**[native] Ustawia flage mowiaca o tym czy level ma sie renderowac w 
     * normalnym trybie, czy dopiero po spriteach
     */
    public native void SetRenderAfterSprites( boolean bRenderAfterSprites );
    
    /**[native] POzwala na pokazanie/ukrycie wszystkich spriteow na levelu.
     */
    public native void ShowSprites( boolean bShow );

    public native void EnableIndoorLighting(boolean bEnable);

    //////////////////////////////
    // CZAS
    //////////////////////////////

    /**[native] Ustawia skale zegara
    * @param fSpeedUp nowa predkosc zegara (<code>float</code>)
    */
    public native final void TimerSetSpeedUp(float fSpeedUp);

    /**[native] Ustawia wspolczynnik "wygladzania delt czasu"
    * @param iFactor im wiekszy tym bardziej "smooth", 1 wylacza wygladzanie
    */
    public native final void TimerSetSmoothing(int iFactor);

    /**[native] Zatrzymuje licznik czasu levelu.
     */
    public final native void TimerStop();
    
    /**[native] Startuje licznik czasu levelu po zrobieniu TimerStop().
     */
    public final native void TimerStart();
    
    /**[native] Ustawia timer levelu w tryb pracy, w ktorym 
     * "na zywca" pobierany jest (i ustawiany) czas z game timera
     * Domyslnie ustawione na false
     * Przydatne w sieci, gdyz kompensator czasu umiejscowiony
     * jest w game timerze i level gry musi z niego czerpac aktualna wartosc
     */
    public final native void TimerSetForceFromGameTimer(boolean bForce);

    /////////////////////////////
    
    /**Zasieg widzenia blobow = "BlobsVisibilityRangeFactor" * "ObjectsVisibilityRange", 
     * domyslnie mnoznik jest 0.35*/
    public native void SetBlobsVisibilityRangeFactor(float fFactor);
    public native float GetBlobsVisibilityRangeFactor();
    
    /**[native] Ustawia zakresy widocznosci swiatel dynamicznych. Swiatlo plynnie
     * wygasza sie w zakresie odleglosci fStart do fEnd
     * @param fStart do tej odleglosci swiatlo widac normalnie
     * @param fEnd powyzej tej odleglosci swiatlo jest w pelnie wygaszone (nie renderuje sie)
     */
    public final native void SetDynLightVisibilityRanges(float fStart, float fEnd);

	/** pobranie sciezki do pliku z modulem */
	public native String GetModulePath();

    /**[native] Reinicjalizuje grid drzew
     * @param fSizeX fSizeZ - rozmiary komorki grida
     * @param fXMin fZMin fXMax, fZmax - extenty grida
     */
    public final native void ReinitializeTreeGrid(float fSizeX, float fSizeZ, float fXMin, float fZMin, float fXMax, float fZMax);
    
    /**[native] Reinicjalizuje wielkosc komorek grida drzew
     * @param fSizeX fSizeZ - rozmiary komorki grida
     */
    public final native void ReinitializeTreeGridSize(float fSizeX, float fSizeZ);
    
    ///////////////////////////////////////////
    // OBSLUGA SCIEZEK
    ///////////////////////////////////////////
    
	/** manager sciezek - w nim sa przechowywane informacje o wszystkich sciezkach */
	PathsManager cPathsManager = new PathsManager();
	
    /** Zawraca tablice sciezke identyfikowana przez id ze stringa.
     * @param sPathID lista identyfikatorow sciezek oddzielona znakiem ';'
     * @return tablica sciezek, ale gdy id sciezki niepoprawny to null jest
     * elementem tablicy
     */
    public Path[] GetPathListByIDs(String sPathIDs)
	{
        String sID = null;
        java.util.StringTokenizer cST = new java.util.StringTokenizer(sPathIDs, ";");
        Path[] aPath = new Path[cST.countTokens()];
        int i = 0;
        while(cST.hasMoreTokens())
        {
            sID = cST.nextToken();
            aPath[i++] = cPathsManager.GetPathById( Integer.getInteger(sID).intValue() );
        }
		return aPath;
	}
	
	/** Ladowanie sciezek z edytora
	 */
	public void OnLoadChunk(int ChkID, int nDataSize, MapInputStream cDataStream)
	{
		if (ChkID == CHK_JAVA_AIED_PATH2)
		{
			cPathsManager.LoadPath(cDataStream);
		}
	}

	/** Przemapowywanie fontow
	 */
	public void LoadTextMappingScript(String fileName)
	{
		ParseKeyword Root = GameObject.ParseFile(fileName);
												  
		if (Root == null)
		{
			GameObject.CrashLog("No file " + fileName + "!\n");
			return;
		}
		else
		{
			ParseKeyword Key, SubKey;
			
			Sprite sprText = (Sprite) CreateObject("Sprite");
			AddSprite(sprText);
			
			for (Key = Root; Key != null; Key = Key.GetNext())
			{
				if (Key.Equals("Font"))
				{
					String sCurrFont = new String(Key.GetSParam(0));

			  		for (SubKey = Key.GetChild(); SubKey != null; SubKey = SubKey.GetNext())
			  		{
						char aChar;
						String sTemp = null;
						
			  			if (SubKey.Equals("MapL"))
						{
							sTemp = SubKey.GetSParam(0);
							if (sTemp == null || sTemp.length() == 0)
								continue;
							aChar = sTemp.charAt(0);
							
							sprText.ChangeFontCharMapping(sCurrFont, aChar, true, SubKey.GetIParam(1));
						}
						
			  			if (SubKey.Equals("MapR"))
						{
							sTemp = SubKey.GetSParam(0);
							if (sTemp == null || sTemp.length() == 0)
								continue;
							aChar = sTemp.charAt(0);
							
							sprText.ChangeFontCharMapping(sCurrFont, aChar, false, SubKey.GetIParam(1));
						}
					}
				}
			}

			Root.delete();
			RemoveSprite(sprText);
			sprText.delete();
			sprText = null;
		}
	}	
	
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    public native static void NativeSGLoadInteractionMap(FileChunk cFC);
    public native static void NativeSGSaveInteractionMap(FileChunk cFC);
    
	public native void LoadExpressionVarMan(FileChunk cFC);
	public native void SaveExpressionVarMan(FileChunk cFC);	
	
	public native void LoadInput(FileChunk cFC);
	public native void SaveInput(FileChunk cFC);	
	
	boolean bIsMoviePlayingSG = false;
		
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {
		FileChunk.Log("[Module.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);
		
        if (cFC.GetID() == ESGChunks._CHK_MODULE)
        {
			super.SGLoadChunk(cFC);

			// Zmienna okreslajaca czy gra muzyka.
			bCDMusicPlaying = cFC.LoadBool();
			// Okresla, czy muzyka jest spauzowana.
			bCDMusicPaused = cFC.LoadBool();						
			
			bIsMoviePlayingSG = cFC.LoadBool();
			
			Module.this.StopMovie();
			
			if (bIsMoviePlayingSG)
				LoadMovieState(cFC);
		}
		
		cFC.delete();
	}
	
    /** Metoda zapisujaca dane do Save gracza
     */		
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[Module.SGSaveChunk]\n");
		
		FileChunk cFC = NewChunk(ESGChunks._CHK_MODULE, cFCParent);
		
        super.SGSaveChunk(cFC);
		
		// Zmienna okreslajaca czy gra muzyka.
		cFC.SaveBool( bCDMusicPlaying );
		// Okresla, czy muzyka jest spauzowana.
		cFC.SaveBool( bCDMusicPaused );		
		
		cFC.SaveBool(IsMoviePlaying());
		
		if (IsMoviePlaying())
			SaveMovieState(cFC);
        
		cFC.delete();
	}		
	
	public void SGUpdate()
	{
		FileChunk.Log("[Module.SGUpdate]\n");
		
		super.SGUpdate();
		
		if (bIsMoviePlayingSG)
			UpdateMovieState();
	}
	
	public long GetSaveVersion() { return -1; }	
    
    /** Handler wolany bezposrednio przed rozpoczeciem renderowania levelu
     */
    void OnRender()
    {
    }
    
    /** Handler wolany bezposrednio po zakonczeniu renderowania levelu
     */
    void OnPostRender()
    {
    }
	
	public native String GetComment();
	
	public native int GetNextIDValue();
	public native void SetNextIDValue(int nValue);
	public native void DisableAllCallMethods();


    ///********************************************
    ///*        Zarzadca Deszczu
    ///********************************************

    /// --------- parametry do edycji ----------

    /// -----Grupa Rain_Basic - podstawowe parametry deszczu-----
    /// czy uzywac deszczu?
    public boolean m_bRainEnabled = false;//#Rain_Basic
    /// najwieksza dopuszczalna ilosc kropel
    public int m_iRainDropsNumber = 0;  //#Rain_Basic
    /// ilosc pokazywanego deszczu w procentach
    public float m_fRainDensity = 100.f;  //#Rain_Basic
    /// kierunek padania
    public Vector m_vRainDirection = new Vector( 0.f, -1.f, 0.f );//#Rain_Basic
    /// kat rozrzutu kierunkow ruchu kropel(stozek)
    public float m_fRainDirVariationAngle;//#Rain_Basic
    /// zakres predkosci kropli
    public float m_fRainMinVelocity;//#Rain_Basic
    public float m_fRainMaxVelocity;//#Rain_Basic
    /// pudlo w ktorym pada deszcz
    public float m_fRainCubeSize = 1000;//#Rain_Basic
    /// turbulencja
    public float m_fRainTurbulencyAmplitude;//#Rain_Basic
    public float m_fRainTurbulencySpeed;//#Rain_Basic

    /// -----Grupa Rain_Appearance - parametry rysowania-----
    /// sposob rysowania kropel
    public int m_iRainDrawMode = ERainMode._DRAW_DIRECTED_QUADS;//#Rain_Appearance
    public float m_fRainDropWidth = 10.f;//#Rain_Appearance
    public float m_fRainDropHeight = 10.f;//#Rain_Appearance
    /// nazwa skryptu z materialem uzywanego dla rysowania kropli
    public String m_sRainMaterialName = "data\\materials\\fx\\rain.mat";//#Rain_Appearance
    /// ilosc pionowych ramek w teksturze
    public int m_iRainTextureFramesY = 1;//#Rain_Appearance
    /// ilosc poziomych ramek w teksturze
    public int m_iRainTextureFramesX = 1;//#Rain_Appearance
    /// czy sortowac krople wzgledem kamery
    public boolean m_bRainSortDrops = true;//#Rain_Appearance
    /// alfa domnazana do alfy kazdej kropli
    public float m_fRainAlpha = 1.f;//#Rain_Appearance
    /// odleglosc do jakiej alfa kropel ma wartosc 1.0, dalej zaczyna sie 
    /// zmniejszac az osiagnie wartosc 0.0 w odleglosci m_fRainCubeSize/2
    public float m_fRainFadeDistanceStart = 100.f;//#Rain_Appearance
    /// minimalna i maksymalna szybkosc obrotu sprajta wokol jego srodka.
    /// dziala tylko dla sprajtow! [obroty/sekunde]
    public float m_fRainDropsRotationMin = 0.f;//#Rain_Appearance
    public float m_fRainDropsRotationMax = 0.f;//#Rain_Appearance

    /// -----Grupa Rain_Splash - plusk w momencie upadku kropli-----

    /// ile procent kropel wywoluje efekt plusku? [%]
    public float m_fRainSplashProbability = 0.f;//#RainSplash
    /// nazwa fx-a odpalanego w chwili uderzenia o wode.
    public String m_sRainWaterSplashFX = "";//#RainSplash
    /// nazwa fx-a odpalanego w chwili uderzenia o ziemie/budynek/drzewo.
    public String m_sRainConcreteSplashFX = "";//#RainSplash

    /// -----Grupa Rain_Lightings&Thunders - pioruny i grzmoty-----

    /// srednia produkcja piorunow[pioruny/minuta]
    public int m_iRainLightningsPerMinute = 0;//#Rain_LightningAndThunder
    /// burza bez blyskow, ale z gromami
    public boolean m_bRainLightningShowFlash = false;//#Rain_LightningAndThunder
    /// prawdopodobienstwo ze kazdej blyskawicy towarzyszy dzwiek gromu[%].
    public float m_fRainThunderProbability = 0.f;//#Rain_LightningAndThunder
    /// minimalne opoznienie gromu wzgledem blyskawicy [s]
    public float m_fRainMinThunderDelay = 0.f;//#Rain_LightningAndThunder
    /// maksymalne opoznienie gromu wzgledem blyskawicy [s]
    public float m_fRainMaxThunderDelay = 0.f;//#Rain_LightningAndThunder
    /// najmniejsza glosnosc gromu [%]
    public float m_fRainMinThunderVolume = 100.f;//#Rain_LightningAndThunder
    /// najwieksza glosnosc gromu [%]
    public float m_fRainMaxThunderVolume = 100.f;//#Rain_LightningAndThunder
    /// dzwieki gromu do losowania
    public String m_sRainThunderSound1 = "";//#Rain_LightningAndThunder
    public String m_sRainThunderSound2 = "";//#Rain_LightningAndThunder
    public String m_sRainThunderSound3 = "";//#Rain_LightningAndThunder
    public String m_sRainThunderSound4 = "";//#Rain_LightningAndThunder

    /// ----- Grupa Rain_EnvironmentSound - dzwieki srodowiska -----
    public boolean m_bRainPlayEnvSound = false;//#Rain_EnvironmentSound
    /// glosnosc [%]
    public float m_fRainEnvironmentSoundVolume = 100.f;//#Rain_EnvironmentSound
    /// nazwa zapetlonego sampla srodowiska
    public String m_sRainEnvironmentSound = "";//#Rain_EnvironmentSound

    /// Zarzadca deszczu
    private RainManager m_RainManager;

    RainManager GetRainManager()
    {
        return m_RainManager;
    }
    
    void InitRainManager()
    {
        if( !m_bRainEnabled )
            return;
        m_RainManager = (RainManager)CreateObject("RainManager");
        m_RainManager.Init( this );
    }

    /// fMin - odleglosc przy ktorej dzwiek zaczyna slabnac
    /// fMax - odleglosc od ktorej dzwiek jest nieslyszalny
    void RegisterRainObserver( Camera observer, float fMin, float fMax )
    {
        if (m_bRainEnabled)
            CrashLog( "RegisterRainObserver!..." );
        if( m_RainManager != null )
        {
            m_RainManager.RegisterRainObserver( observer, fMin, fMax );
            if (m_bRainEnabled)
                CrashLog( "Succees!" );
        }
        else
            if (m_bRainEnabled)
                CrashLog( "Failure!" );
    }

    public void ListenerGoesInToBuilding()
    {
        if( m_RainManager != null )
            m_RainManager.ListenerGoesInToBuilding();
    }

    public void ListenerGoesToOpenSpace()
    {
        if( m_RainManager != null )
            m_RainManager.ListenerGoesToOpenSpace();
    }
    
    /* Ustawia poprawny kierunek cienia */
    void SkySetProperShadowDir()
    {
        Vector dir = SkyGetSunDir();
        if (dir == null) return;

        if (dir.fY < 1)
        {
            // kosinus kata maksymalnego odchylenia od pionu kierunku
            // shadowmapy
            float A = 0.707f;
            
            if (dir.fY < A)
            {
                float xz = dir.fX*dir.fX + dir.fZ*dir.fZ;
                dir.fY = A*(float)Math.sqrt(xz / (1 - A*A));
                dir.Normalize();
            }
        }
        
        SkySetSunShadowDir(dir.fX, dir.fY, dir.fZ);
    }
    
    //do walidacji odpowiedzi na liste zyczen - wykorzystanie ModuleNet
    public boolean ValidateCRC(int iQueryNum, int iCRC)
    {
        return false;
    }
    
    //do wyrzucenia klienta z serwera = wykorzystanie ModuleNet
    public void KickNetClient(int iClientID)
    {
    }
    
    public float fMinDistToCalculateRelevant =  1500.0f;
    public float fMaxDistToCalculateRelevant = 10000.0f;

    ////////////////////////////////////////////////////////
    // INPUTY
    ////////////////////////////////////////////////////////

    /* [native] Wlacza/wylacza wolanie handlerow z inputami
     * dla wszystkich obiektow na levelu */
    public native void EnableInputs(boolean bEnable);
    
    /* [native] Sprawdza, czy wlaczone jest wolanie handlerow z inputami
     * dla obiektow na levelu */
    public native boolean InputsEnabled();

    ////////////////////////////////////////////////////////
    // UNIMPORTANCE
    ////////////////////////////////////////////////////////

    /* [native] Ustawia wartosc czynnika nieistotnosci 
     * dla wszystkich obiektow na levelu */
    public native void SetLevelUnImportanceFactor(float fFactor);
    
    /* [native] Pobiera wartosc czynnika nieistotnosci 
     * dla wszystkich obiektow na levelu */
    public native float GetLevelUnImportanceFactor();

    
}
