/** Klasa reprezentuje slowo kluczowe wczytane z pliku skryptowego w formacie TCParse.
 */
public class ParseKeyword
{
    /** Identyfikator keyworda w CPP
     */
    public int nID;
    
    /** [native] Pobranie keyworda
     * @return keyword
     */
    public native String GetName();

    /** [native] Pobranie wartosci keyworda o typie Int.
     * @param nParam numer parametru do pobrania
     * @return Wartosc keyworda typu int
     */
    public native int GetIParam(int nParam);

    /** [native] Pobranie wartosci keyworda o typie String.
     * @param nParam numer parametru do pobrania
     * @return Wartosc keyworda typu String
     */
    public native String GetSParam(int nParam);

    /** [native] Pobranie wartosci keyworda o typie String. Jesli string zawiera
     * znaki narodowe, to zostana zachowane.
     * @param nParam numer parametru do pobrania
     * @return Wartosc keyworda typu String
     */
    public native String GetSParamLocalized(int nParam);
    
    /** [native] Pobranie wartosci keyworda o typie Float.
     * @param nParam numer parametru do pobrania
     * @return Wartosc keyworda typu Float
     */
    public native float GetFParam(int nParam);
    
    /** [native] Pobranie pierwszego dziecka keyworda.
     * @return Zwraca keyword dziecka, gdy nie ma dzieci to zwraca null
     */
    public native ParseKeyword GetChild();
    
    /** [native] Pobranie nastepnego keyworda na poziomie tego wierzcholka.
      @return Zwraca keyword, gdy nie ma nastepnego to zwraca null
     */
    public native ParseKeyword GetNext();
    
    /** [native] Sprawdza czy keyword ma nazwe taka jak podana.
     * @return true gdy nazwa sie zgadza, gdy nie oczywiscie false
     */
    public native boolean Equals(String sKeyName);
    
    /** Skasowanie calej galezi drzewa, ktorego rootem jest ten wierzcholek
     */
    public native void delete();
}
