
/** Umozliwia ustalenie polozenia punktu.
 *  Punkt moze byc staly, moze wskazywac na meshObject 
 *  albo element meshObjectu.
 */
public class Position
{

    Vector vPos = new Vector();
    MeshObject cMeshObject = null;
    int nElementID = -1;

    byte nMode = -1;

    Position()
    {
        Set(0, 0, 0);
    }
    Position(float fX, float fY, float fZ)
    {
        Set(fX, fY, fZ);
    }
    Position(MeshObject cMesh)
    {
        Set(cMesh);
    }
    Position(MeshObject cMesh, int nElem)
    {
        Set(cMesh, nElem);
    }

    public void Set(Vector vPos)
    {
        this.vPos.Set(vPos);
        nMode = 0;
    }
    public void Set(float fX, float fY, float fZ)
    {
        this.vPos.Set(fX, fY, fZ);
        nMode = 0;
    }
    public void Set(MeshObject cMesh)
    {
        cMeshObject = cMesh;
        nMode = 1;
    }
    public void Set(MeshObject cMesh, int nElem)
    {
        cMeshObject = cMesh;
        nElementID = nElem;
        nMode = 2;
    }

    public Vector Get()
    {
        if (nMode == 0)
            return new Vector(vPos);
        else if (nMode == 1)
            return cMeshObject.GetPosition();
        else if (nMode == 2)
            return cMeshObject.GetElementPos(nElementID);
        else 
            return new Vector(0, 0, 0);
    }
}
