/** Kontroluje dzialanie deszczu na levelu.
@author Rafal Kamraj
@date 2003-04-12

-posiadal atrybuty ktore mozna edytowac w ChromEdzie, teraz siega po nie do levelu.
hmmm..., nie podoba mi sie to.
odpowiada za:
-uruchamianie deszczu FXRain o odpowiednich wlasnosciach;
-odgrywanie dzwiekow deszczu;
-dynamiczne zmienianie parametrow deszczu w zaleznosci od programu;
-uruchamianie piorunow i towarzyszacych im grzmotow;
-zakonczenie deszczu;

@date 2003-05-07
-obracanie sprajtow wokol srodka: m_fRainDropsRotationMax, m_fRainDropsRotationMin;

@date 2003-06-02
-obiekt glosnik poruszajacy sie za obserwatorem(kamera) lecz na wysokosci HeightMapy dla deszczu.
ma pomoc w sytuacjach gdy kamera znajduje sie w budynku lub pod obiektem zaslaniajacym deszcz.



*/
public class RainManager extends GameObject
{
    Module m_Module = null;
    /// kamera do ktorej podpiety jest glosnik z efektami.
    /// bez kamery nie ma dzwiekow deszczu i grzmotow
    Camera m_RainListener = null;
    /// glosnik odtwarzajacy dzwieki deszczu.
    /// przemieszcza sie po levelu pobierajac (X,Z) z kamery, a wysokosc
    /// z mapy wysokosci deszczu. Dzieki temu dzwiek ma cichnac 
    /// im glebiej kamera zejdzie ponizej poziomu ziemi/dachu budynku.
    RainSpeaker m_RainSpeaker = null;

    int m_nEnvironmentSoundID = 0;

    float m_fMinEnvSoundRange = 0;
    float m_fMaxEnvSoundRange = 0;
    
    /// By deszcz wydawal dzwieki nalezy zarejestrowac sluchacza
    /// fMin - od jakiej odleglosci dzwiek zaczyna slabnac
    /// fMax - od jakiej odleglosci dzwiek jest nieslyszalny
    public void RegisterRainObserver( Camera observer, float fMin, float fMax )
    {
//        CrashLog( "Registering Rain Observer!\n" );

        Module module = GetModule();

        if( !m_Module.m_bRainEnabled )
            return;

        /// odlaczyc dzwieki od poprzedniego sluchacza
        if( m_RainSpeaker != null )
        {
            m_RainSpeaker.DeInit();
            m_RainSpeaker = null;
        }

        if( observer == null )
            return;

        /// tworzy nowy glosnik
//        CrashLog( "RainSpeaker created!\n" );
        m_RainSpeaker = (RainSpeaker)m_Module.CreateObject("RainSpeaker");
        observer.GetPosition( m_RainSpeaker.m_vWorldPosition );
        m_RainSpeaker.SetPositionWorld( m_RainSpeaker.m_vWorldPosition );
        m_RainSpeaker.ActivateOnModuleGridIndependent();

        m_RainSpeaker.m_RainObserver = observer;
        m_RainSpeaker.m_fSampleRadius = 200.f;

        if( m_Module.m_bRainPlayEnvSound )
        {
            if( m_Module.m_sRainEnvironmentSound.length() != 0 )
            {
                m_fMinEnvSoundRange = fMin;
                m_fMaxEnvSoundRange = fMax;
                CrashLog( "Attaching rain's environment sound " + m_Module.m_sRainEnvironmentSound + " to speaker!\n" );
                m_nEnvironmentSoundID = m_RainSpeaker.AttachSound( m_Module.m_sRainEnvironmentSound, fMin, fMax );
    //            int iEnvironmentSoundID = m_RainSpeaker.AttachSound( m_Module.m_sRainEnvironmentSound );
                m_RainSpeaker.SetSoundVolume( m_nEnvironmentSoundID, m_Module.m_fRainEnvironmentSoundVolume * 0.01f );
            }
            else
                CrashLog( "Can't find rain's environment sound!\n" );
        }
    }

    /// Wywolac gdy sluchacz wchodzi do budynku
    public void ListenerGoesInToBuilding()
    {
/*
        if( !GetModule().m_bRainEnabled )
            return;
        if( m_bIsListenerInside )
            return;
        m_bIsListenerInside = true;

        /// wylaczenie dzwieku srodowiska
        if( m_iEnvironmentSoundID != -1 && m_RainSoundsListener != null )
        {
            m_RainSoundsListener.StopSound( m_iEnvironmentSoundID );
        }
        DeleteThundersQueque();
*/
    }

    /// Wywolac gdy sluchacz wychodzi na otwarty teren
    public void ListenerGoesToOpenSpace()
    {
/*
        if( !GetModule().m_bRainEnabled )
            return;
        if( !m_bIsListenerInside )
            return;
        m_bIsListenerInside = false;

        if( m_iEnvironmentSoundID != -1 &&
            m_RainSoundsListener != null )
        {
            m_RainSoundsListener.PlaySound( m_iEnvironmentSoundID );
        }
*/
    }

    /// kopiuje nazwy gromow do tablicy by latwiej losowac
    java.util.Vector m_vstThunderSounds = new java.util.Vector(0);
    int m_iNumThunderSounds = 0;
    boolean m_bTSoundsArrayReady = false;
    java.util.Vector m_vstThundersQueque = new java.util.Vector(0);   ///< kolejka dzwiekow do odegrania

    void BuildThunderSounds()
    {
        Module module = GetModule();
        if( m_Module.m_sRainThunderSound1.length() > 0 )
            m_vstThunderSounds.add( m_Module.m_sRainThunderSound1 );
        if( m_Module.m_sRainThunderSound2.length() > 0 )
            m_vstThunderSounds.add( m_Module.m_sRainThunderSound2 );
        if( m_Module.m_sRainThunderSound3.length() > 0 )
            m_vstThunderSounds.add( m_Module.m_sRainThunderSound3 );
        if( m_Module.m_sRainThunderSound4.length() > 0 )
            m_vstThunderSounds.add( m_Module.m_sRainThunderSound4 );
        m_bTSoundsArrayReady = true;
    }

    String GetRandomThunderSound()
    {
        if( !m_bTSoundsArrayReady )
            BuildThunderSounds();
        int iRandSound = RandomInt( m_vstThunderSounds.size() );
        if( m_vstThunderSounds.size() == 0 )
            return null;
        return (String)m_vstThunderSounds.get( iRandSound );
    }

    void AddThunderToQueque( String sThunderSound, float fDelay, float fVolume )
    {
        ThunderInfo ti = new ThunderInfo();
        ti.fCreationTime = m_fLastTime;
        ti.fDelay = fDelay;
        ti.fVolume = fVolume;
        ti.sSound = sThunderSound;
        m_vstThundersQueque.add( ti );
    }

    void DeleteThundersQueque()
    {
        m_vstThundersQueque.clear();
    }

    void PlayThundersQueque()
    {
        for( int i = 0; i < m_vstThundersQueque.size(); )
        {
            ThunderInfo ti = (ThunderInfo)m_vstThundersQueque.get( i );
            if( m_fLastTime >= ( ti.fCreationTime + ti.fDelay ) )
            {
                if( m_RainSpeaker != null )
                    m_RainSpeaker.AttachOneShotSound( ti.sSound, ti.fVolume );
                m_vstThundersQueque.remove( i );
            }
            else
                ++i;
        }
    }

    float m_fLastTime;  ///< czas ostatniego odswiezenia
    boolean m_bFXRainStarted = false;    ///< czy FXRain zostal zainicjowany?
    String m_sRainName = "RainManagerRain";

    /** Inicjuje system deszczu*/
    public void Init( Module module )
    {
        m_Module = module;
        m_fLastTime = m_Module.GetTime();
        CallMethodEvery( "Update", 1.f );
    }

    public void Deinit()
    {
        if( m_RainSpeaker != null )
        {
            m_RainSpeaker.DeInit();
            m_RainSpeaker = null;
        }

        m_Module = null;
    }

private
    void Update()
    {
        if( !m_Module.m_bRainEnabled )
            return;

        float fTime = GetTime();
        float fDeltaTime = fTime - m_fLastTime;
        m_fLastTime = fTime;

        /// Czy nie zachodzi potrzeba odpalenia FX-a deszcz?
        if( !m_bFXRainStarted )
        {
            StartFXRain();
        }

        /// pioruny
        if( m_Module.m_iRainLightningsPerMinute > 0 )
        {
            /// czy nalezy wygenerowac piorun
            float fProbability = m_Module.m_iRainLightningsPerMinute * fDeltaTime / 60.f;
            if( RandomFloat(1.f) <= fProbability )
            {
                if( m_Module.m_bRainLightningShowFlash )
                {
                    ShowLightningFlash();
                }

                if( RandomFloat(100.f) <= m_Module.m_fRainThunderProbability )
                {
                    float fDelay = m_Module.m_fRainMinThunderDelay + RandomFloat( m_Module.m_fRainMaxThunderDelay - m_Module.m_fRainMinThunderDelay );
                    float fVolume = m_Module.m_fRainMinThunderVolume + RandomFloat( m_Module.m_fRainMaxThunderVolume - m_Module.m_fRainMinThunderVolume );

                    String sThunderSound = GetRandomThunderSound();
                    if( sThunderSound != null )
                        AddThunderToQueque( sThunderSound, fDelay, fVolume );
                }
            }

            /// Odtwarzanie gromow
            PlayThundersQueque();
        }

        if( m_RainListener == null )
            return;

        /// TODO: program dynamicznej zmiany kierunku deszczu


        /// Jezeli nie widac deszczu to ustawiam gestosc na 0, i vice versa.
        Vector vCameraPos = m_RainListener.GetPosition();
        float fHalfCube = m_Module.m_fRainCubeSize * 0.5f;
        float fMinHeight = FXRainHMapGetMinimalHeight( 
            vCameraPos.fX - fHalfCube, vCameraPos.fX - fHalfCube,
            vCameraPos.fZ + fHalfCube, vCameraPos.fZ + fHalfCube );
        if( fMinHeight - fHalfCube > vCameraPos.fY )
        {
            FXRainSetDensity( m_sRainName, 0.f );
        }
        else
        {
            FXRainSetDensity( m_sRainName, m_Module.m_fRainDensity );
        }
    }

    void StartFXRain()
    {
        AddRain( m_sRainName );

        ///
        FXRainSetCapacity( m_sRainName, m_Module.m_iRainDropsNumber );
        FXRainSetDensity( m_sRainName, m_Module.m_fRainDensity );

        FXRainSetDrawMode( m_sRainName, m_Module.m_iRainDrawMode );
        FXRainSetSortDrops( m_sRainName, m_Module.m_bRainSortDrops );

        FXRainSetMinVelocity( m_sRainName, m_Module.m_fRainMinVelocity );
        FXRainSetMaxVelocity( m_sRainName, m_Module.m_fRainMaxVelocity );

        FXRainSetDropsRotation( m_sRainName, m_Module.m_fRainDropsRotationMin,
            m_Module.m_fRainDropsRotationMax );

        FXRainSetDirection( m_sRainName, m_Module.m_vRainDirection );
        FXRainSetDirVariationAngle( m_sRainName, m_Module.m_fRainDirVariationAngle );

        FXRainSetMaterial( m_sRainName, m_Module.m_sRainMaterialName );
        FXRainSetTextureFrames( m_sRainName, m_Module.m_iRainTextureFramesX, 
            m_Module.m_iRainTextureFramesY );

        FXRainSetDropSize( m_sRainName, m_Module.m_fRainDropWidth, m_Module.m_fRainDropHeight );
        FXRainSetAlpha( m_sRainName, m_Module.m_fRainAlpha );
        FXRainSetFadeDistanceStart( m_sRainName, m_Module.m_fRainFadeDistanceStart );
        FXRainSetTurbulencyAmplitude( m_sRainName, m_Module.m_fRainTurbulencyAmplitude );
        FXRainSetTurbulencySpeed( m_sRainName, m_Module.m_fRainTurbulencySpeed );
        FXRainSetCubeSize( m_sRainName, m_Module.m_fRainCubeSize );

        /// pluski
        FXRainSetSplashProbability( m_sRainName, m_Module.m_fRainSplashProbability );
        FXRainSetWaterSplash( m_sRainName, m_Module.m_sRainWaterSplashFX );
        FXRainSetConcreteSplash( m_sRainName, m_Module.m_sRainConcreteSplashFX );

        StartRain( m_sRainName );
        m_bFXRainStarted = true;
    }

    void ShowLightningFlash()
    {
        /// TODO: pokaz blysk pioruna!
    }

    public void OnAudioReinitialize()
    {
        LogR(this + " OnAudioReinitialize");
        if( m_Module.m_bRainPlayEnvSound )
        {
            if( m_Module.m_sRainEnvironmentSound.length() != 0 )
            {
                m_nEnvironmentSoundID = m_RainSpeaker.AttachSound( m_Module.m_sRainEnvironmentSound, m_fMinEnvSoundRange, m_fMaxEnvSoundRange );
                m_RainSpeaker.SetSoundVolume( m_nEnvironmentSoundID, m_Module.m_fRainEnvironmentSoundVolume * 0.01f );
            }
        }
    }
        
    public void OnAudioPreReinitialize()
    {
        LogR(this + " OnAudioPreReinitialize");
        if (m_nEnvironmentSoundID != 0)
        {
            StopWave(m_nEnvironmentSoundID);
            m_nEnvironmentSoundID = 0;
        }
        
    }
    
}



class ThunderInfo
{
    String sSound;
    float fCreationTime, fDelay, fVolume;
}

