/** Glosnik odgrywajacy efekty dzwiekowe burzy. 
@author Rafal Kamraj
@date 2003-06-02
    Podaza za kamera, ustawia swoja wysokosc na poziomie mapy wysokosci.
*/
public class RainSpeaker extends ControlObject
{
    public float m_fSampleRadius = 200.f;  ///< w jakim promieniu samplowac mape wysokosci?
    public Camera m_RainObserver = null;
    public Vector m_vWorldPosition = new Vector();  ///< aktualna pozycja na swiecie

    /// identyfikator aktualnie odtwarzanego dzwieku srodowiska
    int m_iEnvironmentSoundID = 0;

    void DeInit()
    {
        m_iEnvironmentSoundID = 0;
        DetachAllSounds();
        DeactivateOnModuleAlways();
        m_RainObserver = null;
    }

    void OnFrame()
    {
        if( m_RainObserver == null )
        {
            CrashLog( "\tObserver is null!\n" );
            return;
        }

        m_RainObserver.GetPosition( m_vWorldPosition );
        /// by uniknac zabawnych sytuacji pobiera najmniejsza wysokosc z wiekszego obszaru.
        float fTestRadius = m_fSampleRadius;
        float fAreaHeight = FXRainHMapGetMinimalHeight( 
            m_vWorldPosition.fX - fTestRadius, m_vWorldPosition.fX + fTestRadius,
            m_vWorldPosition.fZ - fTestRadius, m_vWorldPosition.fZ + fTestRadius );
        float fPointHeight = FXRainHMapGetHeight( m_vWorldPosition.fX, m_vWorldPosition.fZ );
        float fHeightCombined = ( fPointHeight + fAreaHeight ) * 0.5f;

//        CrashLog( "RainSpeaker Heights: observer " + m_vWorldPosition.fY + " combined " + fHeightCombined + "\n" );
//        m_vWorldPosition.fY = fAreaHeight;
//        if( m_vWorldPosition.fY < fHeightCombined )
//            m_vWorldPosition.fY = fHeightCombined;

        if( m_vWorldPosition.fY < fPointHeight )
            m_vWorldPosition.fY = fPointHeight;

        SetPosition( m_vWorldPosition );
    }

}

