/** Klasa wspomagajaca localizacje stringow w grze
 */
public class Text extends GameObject
{
    /**[native] Zwraca tekst z lokalizowany poprzez zastapienie w podnym stringu wszystkich wystapien
     * ciagu &id_tekstu_w_zasobach_lokalizacji& odpowiednim ciagiem znakow. Np. gdy
     * sText="&PLAYER_NAME& stefan &LEFT_GAME&." zostanie w polskiej lokalizacji zmieniony na
     * "Gracz stefan oposcil gre."
     * @param sText string zawierajacy tekst do konwersji
     */
    public native static String Get(String sText);
    
    /**[native] Wczytanie podanego pliku z definicjami stringow lokalizowanych.
     * @param sFileName nazwa pliku skryptowego w formacie TCParse z definicja stringow
     * @return gdy plik wczyta sie pomyslnie zwraca true
     */
    public native static boolean FromFile(String sFileName);
    
    /**[native] Unloades all strings that have matching ids with strings
     * in given file.
     * @param sFileName name of file with string definitions
     * @return if file is successfuly parsed returns true
     */
    public native static boolean UnloadFromFile(String sFileName);
}
