public class TrackCamera extends Camera
{
    /**[native] Rozpoczyna odtwarzanie animowanej kamery
     * @param playFrom okresla, od ktorego miejsca rozpoczac odtwarzanie (w ramkach) (<code>float</code>)     
     */ 
    native final void Play(float playFrom);
    
    /**[native] Rozpoczyna odtwarzanie animowanej kamery
     * @param playFrom okresla, od ktorego miejsca rozpoczac odtwarzanie (w ramkach) (<code>float</code>)
     * @param playTo okresla, w ktorym miejscu przerwac odtwarzanie(w ramkach) (<code>float</code>)          
     */ 
    native final void Play(float playFrom, float playTo);
    
    /**[native] Rozpoczyna odtwarzanie od konca animowanej kamery
     * @param playFrom okresla, w ktorym miejscu zakonczy sie odtwarzanie  (w ramkach) (<code>float</code>)  
     */ 
    native final void PlayReverse(float playFrom);
    
    /**[native] Rozpoczyna odtwarzanie od konca animowanej kamery
     * @param playFrom okresla, w ktorym miejscu zakonczy sie odtwarzanie  (w ramkach) (<code>float</code>)
     * @param playTo okresla, w ktorym rozpocznie sie odtwarzanie(w ramkach) (<code>float</code>)          
     */ 
    native final void PlayReverse(float playFrom, float playTo);
    
    /**[native] Zatrzymuje odtwarzanie kamery  (jezeli kamera byla odtwarzana)
     */ 
    native final void Stop();
    
    /**[native] Informuje czy kamera jest aktualnie odtwarzana
     */ 
    native final boolean IsPlaying();
    
    /**[native] Zwraca dlugosc animacji (w ramkach)
     */ 
    native final float GetAnimationLength();
    
    /**[native] Zwraca ilosc ramek na sekunde ustwiona dla animacji (domyslnie 30)
     */ 
    native final float GetFPS();
    
    /**[native] Ustawia ilosc ramek na sekunde
     * @param fps ilosc ramek na sekunde(<code>float</code>)
     */ 
    native final void SetFPS(float fps);
}
